      PROGRAM COMPARE_CFRADS
      IMPLICIT NONE
      INTEGER MAX_HRD_DIM,MAX_RAYS,ARRAYSIZE
      PARAMETER(MAX_HRD_DIM=2048,MAX_RAYS=800,ARRAYSIZE=1638400)
      CHARACTER*200 FILELIST1,FILELIST2,FILENAMES
      CHARACTER FLIGHTID6TEST*6
      INTEGER IAUTOMAN1,IAUTOMAN2
      REAL PCOR1,DCOR1,AZMCOR1,ELCOR1,PCOR2,DCOR2,AZMCOR2,ELCOR2
      WRITE(6,*)'ENTER FILENAME OF FILENAME LISTS'
      READ(5,'(A)')FILENAMES
      OPEN(80,FILE=FILENAMES)
      READ(80,'(A6)')FLIGHTID6TEST
      READ(80,*)PCOR1,DCOR1,AZMCOR1,ELCOR1,IAUTOMAN1
      READ(80,'(A)')FILELIST1
      READ(80,*)PCOR2,DCOR2,AZMCOR2,ELCOR2,IAUTOMAN2
      READ(80,'(A)')FILELIST2
      CLOSE(80)
      CALL READANDCOMPARE(FILELIST1,FILELIST2,IAUTOMAN1,IAUTOMAN2,
     +     FLIGHTID6TEST,PCOR1,DCOR1,AZMCOR1,ELCOR1,
     +     PCOR2,DCOR2,AZMCOR2,ELCOR2)
      STOP
      END
      SUBROUTINE READANDCOMPARE(FILELIST1,FILELIST2,IAUTOMAN1,IAUTOMAN2,
     +     FLIGHTID6TEST,PCOR1,DCOR1,AZMCOR1,ELCOR1,
     +     PCOR2,DCOR2,AZMCOR2,ELCOR2)
      IMPLICIT NONE
      INTEGER NVRDIFFSUM,NVRDIFFSUMTOTAL
      REAL VRDIFFSUM,VRDIFF,VRDIFFSUMTOTAL,VRDIFFTOTAL,VRDIFFSUM2TOTAL
      REAL VRDIFF2TOTAL
      INTEGER MAX_HRD_DIM,MAX_RAYS,ARRAYSIZE
      PARAMETER(MAX_HRD_DIM=2048,MAX_RAYS=800,ARRAYSIZE=1638400)
      CHARACTER*200 FILENAME1,FLIGHTID6TEST*6,FLIGHTID6*6
      CHARACTER*200 FILENAME2
      CHARACTER*200 FILELIST1,FILELIST2
      INTEGER ISCANMAX1,ISCANMAX2,NUM_RAYS1,NUM_RAYS2
      INTEGER IAUTOMAN1,IAUTOMAN2,IREADNEXT,I,J,K,NVRDIFFROT
      REAL REFSWP1(MAX_HRD_DIM,MAX_RAYS),VRSWP1(MAX_HRD_DIM,MAX_RAYS)
      REAL WIDTH1(MAX_HRD_DIM,MAX_RAYS),SQI1(MAX_HRD_DIM,MAX_RAYS)
      REAL RDTAI1(MAX_HRD_DIM),EAZM1(MAX_RAYS),EEV1(MAX_RAYS)
      REAL RRLAT1(MAX_RAYS),RRA1(MAX_RAYS),HEADING1(MAX_RAYS)
      REAL TRACK1(MAX_RAYS),ROLL1(MAX_RAYS),PITCH1(MAX_RAYS)
      REAL DRIFT1(MAX_RAYS),ROTATION1(MAX_RAYS),PELEV1(MAX_RAYS)
      REAL GSE1(MAX_RAYS),GSN1(MAX_RAYS),U1(MAX_RAYS),V1(MAX_RAYS)
      REAL W1(MAX_RAYS),TMSWEEP1(MAX_RAYS),AZ_EL1(2,MAX_RAYS)
      REAL REFSWP2(MAX_HRD_DIM,MAX_RAYS),VRSWP2(MAX_HRD_DIM,MAX_RAYS)
      REAL WIDTH2(MAX_HRD_DIM,MAX_RAYS),SQI2(MAX_HRD_DIM,MAX_RAYS)
      REAL RDTAI2(MAX_HRD_DIM),EAZM2(MAX_RAYS),EEV2(MAX_RAYS)
      REAL RRLAT2(MAX_RAYS),RRA2(MAX_RAYS),HEADING2(MAX_RAYS)
      REAL TRACK2(MAX_RAYS),ROLL2(MAX_RAYS),PITCH2(MAX_RAYS)
      REAL DRIFT2(MAX_RAYS),ROTATION2(MAX_RAYS),PELEV2(MAX_RAYS)
      REAL GSE2(MAX_RAYS),GSN2(MAX_RAYS),U2(MAX_RAYS),V2(MAX_RAYS)
      REAL W2(MAX_RAYS),TMSWEEP2(MAX_RAYS),AZ_EL2(2,MAX_RAYS)
      REAL VGS1(MAX_RAYS),VGS2(MAX_RAYS)
      REAL RRLON1(MAX_RAYS),RRLON2(MAX_RAYS)
      REAL PCOR1,PCOR2,DCOR1,DCOR2,AZMCOR1,AZMCOR2,ELCOR1,ELCOR2
      REAL RDEL1,RDEL2
      INTEGER IROTATION,NVRDIFFROTSUM(360)
      REAL VRDIFFROTSUM(360),VRDIFFROT(360)
      REAL VRDIFFROT2(360),VRDIFFROTSUM2(360)
      REAL RLATDIFF,EEVDIFF,EAZMDIFF,RLATSUM,EEVSUM,EAZMSUM
      REAL EEVDIFF2,EEVSUM2,EAZMDIFF2,EAZMSUM2,TILTSUM,TILTSUM2
      REAL TILTDIFF,TILTDIFF2
      INTEGER NSUM
C      PCOR1=0
C      PCOR2=0
C      DCOR1=0
C      DCOR2=0
C      AZMCOR1=0
C      AZMCOR2=0
C      ELCOR1=0
C      ELCOR2=0
      RDEL1=0
      RDEL2=0
      OPEN(81,FILE=FILELIST1)
      OPEN(82,FILE=FILELIST2)
      IREADNEXT=1
      NVRDIFFSUMTOTAL=0
      VRDIFFSUMTOTAL=0
      VRDIFFSUM2TOTAL=0
      DO I=1,360
         NVRDIFFROTSUM(I)=0
         VRDIFFROTSUM(I)=0
         VRDIFFROTSUM2(I)=0
      ENDDO
      DO WHILE(IREADNEXT.EQ.1)
         READ(81,'(A)',END=999)FILENAME1
         READ(82,'(A)',END=999)FILENAME2
         CALL CFRAD_SWEEP_READER(FILENAME1,ISCANMAX1,NUM_RAYS1,REFSWP1,
     +        VRSWP1,WIDTH1,SQI1,RDTAI1,EAZM1,EEV1,RRLAT1,RRLON1,RRA1,
     +        HEADING1,TRACK1,ROLL1,PITCH1,
     +        DRIFT1,ROTATION1,PELEV1,GSE1,GSN1,VGS1,U1,V1,W1,TMSWEEP1,
     +        FLIGHTID6TEST,FLIGHTID6,AZ_EL1,IAUTOMAN1,
     +        PCOR1,DCOR1,AZMCOR1,ELCOR1)
         WRITE(6,*)'FILENAME1,NUM_RAYS1 = ',FILENAME1,NUM_RAYS1
c         WRITE(6,*)'TIME1 = '
c         WRITE(6,100)(TMSWEEP1(I),I=1,NUM_RAYS1)
         CALL CFRAD_SWEEP_READER(FILENAME2,ISCANMAX2,NUM_RAYS2,REFSWP2,
     +        VRSWP2,WIDTH2,SQI2,RDTAI2,EAZM2,EEV2,RRLAT2,RRLON2,RRA2,
     +        HEADING2,TRACK2,ROLL2,PITCH2,
     +        DRIFT2,ROTATION2,PELEV2,GSE2,GSN2,VGS2,U2,V2,W2,TMSWEEP2,
     +        FLIGHTID6TEST,FLIGHTID6,AZ_EL2,IAUTOMAN2,
     +        PCOR2,DCOR2,AZMCOR2,ELCOR2)
         WRITE(6,*)'FILENAME2,NUM_RAYS2 = ',FILENAME2,NUM_RAYS2
c         WRITE(6,*)'TIME2 = '
c     WRITE(6,100)(TMSWEEP2(I),I=1,NUM_RAYS2)
c     WRITE(6,*)'Yup!'
         NSUM=0
         RLATSUM=0
         IF(NUM_RAYS1.EQ.NUM_RAYS2)THEN
            WRITE(6,*)'RRLAT1 = '
            WRITE(6,100)(RRLAT1(I),I=1,NUM_RAYS1)
            WRITE(6,*)'RRLAT2 = '
            WRITE(6,100)(RRLAT2(I),I=1,NUM_RAYS1)
            DO I=1,NUM_RAYS1
               RRLAT1(I)=RRLAT2(I)-RRLAT1(I)
               IF(ABS(RRLAT1(I)).LT.100.)THEN
                  NSUM=NSUM+1
                  RLATSUM=RLATSUM+RRLAT1(I)
               ENDIF
            ENDDO
            WRITE(6,*)'RLATDIFF = '
            WRITE(6,100)(RRLAT1(I),I=1,NUM_RAYS1)
         ELSE
            WRITE(6,*)'ENDING BECAUSE NUM_RAYS1 NOT EQUAL TO NUM_RAYS2'
            STOP
         ENDIF
         IF(NSUM.GT.0)THEN
            RLATDIFF=RLATSUM/NSUM
            WRITE(6,*)'AVERAGE DIFFERENCE IN LATITUDE IS ',RLATDIFF
         ENDIF
         NSUM=0
         EEVSUM=0
         EEVSUM2=0
         IF(NUM_RAYS1.EQ.NUM_RAYS2)THEN
            WRITE(6,*)'EEV1 = '
            WRITE(6,100)(EEV1(I),I=1,NUM_RAYS1)
            WRITE(6,*)'EEV2 = '
            WRITE(6,100)(EEV2(I),I=1,NUM_RAYS1)
            DO I=1,NUM_RAYS1
               EEV1(I)=EEV2(I)-EEV1(I)
               IF(ABS(EEV1(I)).LT.100.)THEN
                  NSUM=NSUM+1
                  EEVSUM=EEVSUM+EEV1(I)
                  EEVSUM2=EEVSUM2+EEV1(I)*EEV1(I)
               ENDIF
            ENDDO
            WRITE(6,*)'EEVDIFF = '
            WRITE(6,100)(EEV1(I),I=1,NUM_RAYS1)
         ELSE
            WRITE(6,*)'ENDING BECAUSE NUM_RAYS1 NOT EQUAL TO NUM_RAYS2'
            STOP
         ENDIF
         IF(NSUM.GT.0)THEN
            EEVDIFF=EEVSUM/NSUM
            EEVDIFF2=SQRT(EEVSUM2/NSUM-EEVDIFF*2/NSUM/NSUM)
          WRITE(6,*)'AVERAGE DIFFERENCE IN ELEVATION IS ',EEVDIFF
          WRITE(6,*)'STANDARD DEVIATION IN ELEVATION IS ',EEVDIFF2
         ENDIF
         NSUM=0
         TILTSUM=0
         TILTSUM2=0
         IF(NUM_RAYS1.EQ.NUM_RAYS2)THEN
            WRITE(6,*)'TILT1 = '
            WRITE(6,100)(PELEV1(I),I=1,NUM_RAYS1)
            WRITE(6,*)'TILT2 = '
            WRITE(6,100)(PELEV2(I),I=1,NUM_RAYS1)
            DO I=1,NUM_RAYS1
               PELEV1(I)=PELEV2(I)-PELEV1(I)
               IF(ABS(PELEV1(I)).LT.100.)THEN
                  NSUM=NSUM+1
                  TILTSUM=TILTSUM+PELEV1(I)
                  TILTSUM2=TILTSUM2+PELEV1(I)*PELEV1(I)
               ENDIF
            ENDDO
            WRITE(6,*)'TILTDIFF = '
            WRITE(6,100)(PELEV1(I),I=1,NUM_RAYS1)
         ELSE
            WRITE(6,*)'ENDING BECAUSE NUM_RAYS1 NOT EQUAL TO NUM_RAYS2'
            STOP
         ENDIF
         IF(NSUM.GT.0)THEN
            TILTDIFF=TILTSUM/NSUM
            TILTDIFF2=SQRT(TILTSUM2/NSUM-TILTDIFF*2/NSUM/NSUM)
          WRITE(6,*)'AVERAGE DIFFERENCE IN TILT IS ',TILTDIFF
          WRITE(6,*)'STANDARD DEVIATION IN TILT IS ',TILTDIFF2
         ENDIF
         NSUM=0
         EAZMSUM=0
         EAZMSUM2=0
         IF(NUM_RAYS1.EQ.NUM_RAYS2)THEN
            WRITE(6,*)'EAZM1 = '
            WRITE(6,100)(EAZM1(I),I=1,NUM_RAYS1)
            WRITE(6,*)'EAZM2 = '
            WRITE(6,100)(EAZM2(I),I=1,NUM_RAYS1)
            DO I=1,NUM_RAYS1
               EAZM1(I)=EAZM2(I)-EAZM1(I)
               IF(ABS(EAZM1(I)).LT.100.)THEN
                  NSUM=NSUM+1
                  EAZMSUM=EAZMSUM+EAZM1(I)
                  EAZMSUM2=EAZMSUM2+EAZM1(I)*EAZM1(I)
               ENDIF
            ENDDO
            WRITE(6,*)'EAZMDIFF = '
            WRITE(6,100)(EAZM1(I),I=1,NUM_RAYS1)
         ELSE
            WRITE(6,*)'ENDING BECAUSE NUM_RAYS1 NOT EQUAL TO NUM_RAYS2'
            STOP
         ENDIF
         IF(NSUM.GT.0)THEN
            EAZMDIFF=EAZMSUM/NSUM
            EAZMDIFF2=SQRT(EAZMSUM2/NSUM-EAZMDIFF*2/NSUM/NSUM)
          WRITE(6,*)'AVERAGE DIFFERENCE IN EARTH AZIMUTH IS ',EAZMDIFF
          WRITE(6,*)'STANDARD DEVIATION IN EARTH AZIMUTH IS ',EAZMDIFF2
         ENDIF
         IF(NUM_RAYS1.EQ.NUM_RAYS2.AND.ISCANMAX1.EQ.ISCANMAX2)THEN
            DO I=1,NUM_RAYS1
c               WRITE(6,*)'NUMRAY,VRSWP1 = '
c               WRITE(6,100)(VRSWP1(J,I),J=1,ISCANMAX1)
c               WRITE(6,*)'NUMRAY,VRSWP2 = '
c     WRITE(6,100)(VRSWP1(J,I),J=1,ISCANMAX1)
               NVRDIFFSUM=0
               VRDIFFSUM=0
               IROTATION=INT(ROTATION1(I))+1
               DO J=1,ISCANMAX1
                  IF(VRSWP1(J,I).LE.-800.OR.VRSWP2(J,I).LE.-800.)THEN
                     VRSWP1(J,I)=-888.8
                  ELSE
                     VRSWP1(J,I)=VRSWP2(J,I)-VRSWP1(J,I)
                     NVRDIFFSUM=NVRDIFFSUM+1
                     VRDIFFSUM=VRDIFFSUM+VRSWP1(J,I)
                     NVRDIFFSUMTOTAL=NVRDIFFSUMTOTAL+1
                     VRDIFFSUMTOTAL=VRDIFFSUMTOTAL+VRSWP1(J,I)
                     VRDIFFSUM2TOTAL=VRDIFFSUM2TOTAL+VRSWP1(J,I)**2.
                  ENDIF
               ENDDO
               IF(NVRDIFFSUM.EQ.0)THEN
                  VRDIFF=-888.8
               ELSE
                  VRDIFF=VRDIFFSUM/NVRDIFFSUM
                  IF(IROTATION.GE.1.AND.IROTATION.LE.360)THEN
                     NVRDIFFROTSUM(IROTATION)=NVRDIFFROTSUM(IROTATION)+1
                     VRDIFFROTSUM(IROTATION)=VRDIFFROTSUM(IROTATION)+
     +                    VRDIFF
                     VRDIFFROTSUM2(IROTATION)=VRDIFFROTSUM2(IROTATION)+
     +                    VRDIFF*VRDIFF
                  ENDIF
               ENDIF
               WRITE(6,*)'NUMRAY,ELEV,AZIM,VRDIFF = ',
     +              I,EEV1(I),EAZM1(I),VRDIFF
C               WRITE(6,100)(VRSWP1(J,I),J=1,ISCANMAX1)
            ENDDO
         ELSE
            WRITE(6,*)'ENDING BECAUSE ISCANMAX1 NOT EQUAL TO ISCANMAX2'
            STOP
         ENDIF
 100     FORMAT(5F16.6)
      ENDDO
 999  DO I=1,360
         IF(NVRDIFFROTSUM(I).GT.0)THEN
            VRDIFFROT(I)=VRDIFFROTSUM(I)/NVRDIFFROTSUM(I)
            VRDIFFROT2(I)=SQRT(VRDIFFROTSUM2(I)/NVRDIFFROTSUM(I)-
     +           VRDIFFROTSUM(I)**2./NVRDIFFROTSUM(I)/NVRDIFFROTSUM(I))
         ELSE
            VRDIFFROT(I)=-999.9
            VRDIFFROT2(I)=-999.9
         ENDIF
         WRITE(6,*)'IROTATION,NSAMPLES,VRDIFFROT,VRDIFFROTSTDEV,',
     +        'VRDIFFROTSUM,VRDIFFROTSUM2= ',
     +        I,NVRDIFFROTSUM(I),VRDIFFROT(I),VRDIFFROT2(I),
     +        VRDIFFROTSUM(I),VRDIFFROTSUM2(I)
C         WRITE(6,*)'IROTATION,VRDIFFROTSUM,NVRDIFFROTSUM(I) = ',
C     +        I,VRDIFFROTSUM(I),NVRDIFFROTSUM(I)
C         WRITE(6,*)'IROTATION,VRDIFFROTSUM2,NVRDIFFROTSUM = ',
C     +        I,VRDIFFROTSUM2(I),NVRDIFFROTSUM(I)
      ENDDO
      VRDIFFTOTAL=VRDIFFSUMTOTAL/NVRDIFFSUMTOTAL
      VRDIFF2TOTAL=SQRT(VRDIFFSUM2TOTAL/NVRDIFFSUMTOTAL-
     +     VRDIFFSUMTOTAL**2./NVRDIFFSUMTOTAL/NVRDIFFSUMTOTAL)
      WRITE(6,*)'FOR TOTAL SET OF BINS, VRDIFF, VRDIFFSTDV = ',
     +     VRDIFFTOTAL,VRDIFF2TOTAL
      RETURN
      END
      SUBROUTINE CFRAD_SWEEP_READER(FILENAME,DIMRANGE,DIMTIME,DBZ,
     +     VEL,WIDTH,SQI,RANGE,EAZM,EEV,LATITUDE,LONGITUDE,ALTITUDE,
     +     HEADING,TRACK,ROLL,PITCH,
     +     DRIFT,ROTATION,TILT,GSE,GSN,VGS,U,V,W,TIMESECS,
     +     FLIGHTID6TEST,FLIGHTID6,AZ_EL,IAUTOMAN,
     +     PCOR,DCOR,AZMCOR,ELCOR)
      USE NETCDF
C     NEED AZ_EL
C     NEED TO COMPUTE PROPER TIME
      IMPLICIT NONE
      REAL TRACKTEMP,TRAKAZMTEMP,TRAKELEVTEMP,HORAZM,HORELEV
      INTEGER MAX_HRD_DIM,MAX_RAYS,IDRADAR,IBST
      PARAMETER(MAX_HRD_DIM=2048,MAX_RAYS=800)
      INTEGER ISTAT,ISTAT2,MODE,NCID,BUFRSIZE,CACHE_SIZE,CACHE_NELEMS
      INTEGER DBZVARID,DBZUNITLENGTH,XTYPE,NUMTIME,I,J,VELVARID
      INTEGER WIDTHVARID,SQIVARID,RANGEVARID,AZIMUTHVARID,ELEVATIONVARID
      INTEGER LATITUDEVARID,LONGITUDEVARID,TIMEVARID,HEADINGVARID
      INTEGER TRACKVARID,ROLLVARID,DRIFTVARID,ROTATIONVARID,TILTVARID
      INTEGER GSEVARID,GSNVARID,VGSVARID,UVARID,VVARID,WVARID
      INTEGER ALTITUDEVARID,PITCHVARID,IAUTOMAN
      INTEGER COMM,INFO,IDDIMTIME,IDRANGE,DIMTIME,DIMRANGE,DBZDIMIDS(2)
      INTEGER IYEAR,IMONTH,IDAY,IHOURS,IMINS,ISECS,IYEAR2
      CHARACTER FLIGHTID6*6,FLIGHTID6TEST*6
      REAL TIMESECSIN,TIMESECS(MAX_RAYS),AZ_EL(2,MAX_RAYS)
      REAL PITCH1,DRIFT1,ROLL1,TRAKAZM,TRAKELEV
      REAL PCOR,DCOR,RCOR,AZMCOR,ELCOR
      REAL DBZ(MAX_HRD_DIM,MAX_RAYS)
      REAL VEL(MAX_HRD_DIM,MAX_RAYS)
      REAL WIDTH(MAX_HRD_DIM,MAX_RAYS)
      REAL SQI(MAX_HRD_DIM,MAX_RAYS)
      REAL RANGE(MAX_HRD_DIM),EAZM(MAX_RAYS),EEV(MAX_RAYS)
      REAL LATITUDE(MAX_RAYS),LONGITUDE(MAX_RAYS)
      REAL TIME(MAX_RAYS),ALTITUDE(MAX_RAYS),HEADING(MAX_RAYS)
      REAL TRACK(MAX_RAYS),ROLL(MAX_RAYS),PITCH(MAX_RAYS)
      REAL DRIFT(MAX_RAYS),ROTATION(MAX_RAYS),TILT(MAX_RAYS)
      REAL GSE(MAX_RAYS),GSN(MAX_RAYS),VGS(MAX_RAYS)
      REAL U(MAX_RAYS),V(MAX_RAYS),W(MAX_RAYS)
      INTEGER*2, DIMENSION(:,:),ALLOCATABLE::IDBZ
      INTEGER*2, DIMENSION(:,:),ALLOCATABLE::IVEL
      REAL, DIMENSION(:,:),ALLOCATABLE::DBZIN
      REAL, DIMENSION(:,:),ALLOCATABLE::VELIN
      INTEGER*2, DIMENSION(:,:),ALLOCATABLE::IWIDTH
      INTEGER*2, DIMENSION(:,:),ALLOCATABLE::ISQI
      REAL, DIMENSION(:,:),ALLOCATABLE::WIDTHIN
      REAL, DIMENSION(:,:),ALLOCATABLE::SQIIN
      REAL, DIMENSION(:),ALLOCATABLE::RANGEIN
      REAL, DIMENSION(:),ALLOCATABLE::AZIMUTHIN
      REAL, DIMENSION(:),ALLOCATABLE::ELEVATIONIN
      DOUBLE PRECISION, DIMENSION(:),ALLOCATABLE::LATITUDEIN      
      DOUBLE PRECISION, DIMENSION(:),ALLOCATABLE::LONGITUDEIN
      DOUBLE PRECISION, DIMENSION(:),ALLOCATABLE::TIMEIN
      DOUBLE PRECISION, DIMENSION(:),ALLOCATABLE::ALTITUDEIN
      REAL, DIMENSION(:),ALLOCATABLE::HEADINGIN
      REAL, DIMENSION(:),ALLOCATABLE::TRACKIN
      REAL, DIMENSION(:),ALLOCATABLE::ROLLIN
      REAL, DIMENSION(:),ALLOCATABLE::PITCHIN
      REAL, DIMENSION(:),ALLOCATABLE::DRIFTIN
      REAL, DIMENSION(:),ALLOCATABLE::ROTATIONIN     
      REAL, DIMENSION(:),ALLOCATABLE::TILTIN
      REAL, DIMENSION(:),ALLOCATABLE::GSEIN
      REAL, DIMENSION(:),ALLOCATABLE::GSNIN
      REAL, DIMENSION(:),ALLOCATABLE::VGSIN
      REAL, DIMENSION(:),ALLOCATABLE::UIN
      REAL, DIMENSION(:),ALLOCATABLE::VIN
      REAL, DIMENSION(:),ALLOCATABLE::WIN
      REAL CACHE_PREEMPTION
      CHARACTER*200 FILENAME
      CHARACTER CTIME*53
c      WRITE(6,*)'FILENAME = ',FILENAME
      MODE=0
      ISTAT=NF90_OPEN(FILENAME,MODE,NCID)
c      WRITE(6,*)'OPEN STATUS = ',ISTAT
C      CTIME='time'
C      CRANGE='range'
      IF(IAUTOMAN.EQ.1)THEN
         ISTAT=NF90_INQ_VARID(NCID,"DZ",DBZVARID)
      ELSE
         ISTAT=NF90_INQ_VARID(NCID,"DBZ",DBZVARID)
      ENDIF
c      WRITE(6,*)'DBZVARID STATUS, VALUE = ',ISTAT,DBZVARID
      ISTAT=NF90_INQUIRE_VARIABLE(NCID,DBZVARID,DIMIDS=DBZDIMIDS)
c      WRITE(6,*)'ISTAT DBZINQUIREVARIABLE = ',ISTAT
c      WRITE(6,*)'GOT THE DIMENSION IDS FOR EACH DBZ DIMENSION'
      ISTAT=NF90_INQUIRE_DIMENSION(NCID,DBZDIMIDS(1),LEN=DIMRANGE)
      ISTAT2=NF90_INQUIRE_DIMENSION(NCID,DBZDIMIDS(2),LEN=DIMTIME)
c      WRITE(6,*)'ISTAT DBZDIMIDS 1 AND 2 = ',ISTAT
c      WRITE(6,*)'DIMTIME,DIMRANGE = ',DIMTIME,DIMRANGE

      ISTAT=NF90_INQ_VARID(NCID,"range",RANGEVARID)      
      ALLOCATE(RANGEIN(DIMRANGE))
      ISTAT=NF90_GET_VAR(NCID,RANGEVARID,RANGEIN)
c      WRITE(6,*)'SUBROUTINE RANGE, ISTAT = ',ISTAT
c      WRITE(6,100)(RANGEIN(I),I=1,DIMRANGE)
      DO I=1,MAX_HRD_DIM
         IF(I.LE.DIMRANGE)THEN
            RANGE(I)=RANGEIN(I)
         ELSE
            RANGE(I)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"azimuth",AZIMUTHVARID)      
      ALLOCATE(AZIMUTHIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,AZIMUTHVARID,AZIMUTHIN)
c      WRITE(6,*)'SUBROUTINE AZIMUTH, ISTAT = ',ISTAT
c      WRITE(6,100)(AZIMUTHIN(J),J=1,DIMTIME)
c     EAZM AND AZIMUTHIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            EAZM(J)=AZIMUTHIN(J)
         ELSE
            EAZM(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"elevation",ELEVATIONVARID)      
      ALLOCATE(ELEVATIONIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,ELEVATIONVARID,ELEVATIONIN)
c      WRITE(6,*)'SUBROUTINE ELEVATION, ISTAT = ',ISTAT
c      WRITE(6,100)(ELEVATIONIN(J),J=1,DIMTIME)
C     EEV AND ELEVATIONIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            EEV(J)=ELEVATIONIN(J)
         ELSE
            EEV(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"latitude",LATITUDEVARID)      
      ALLOCATE(LATITUDEIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,LATITUDEVARID,LATITUDEIN)
c      WRITE(6,*)'SUBROUTINE LATITUDE, ISTAT = ',ISTAT
c      WRITE(6,100)(LATITUDEIN(J),J=1,DIMTIME)
C     LATITUDE IS REAL AND LATITUDEIN IS DOUBLE
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            LATITUDE(J)=LATITUDEIN(J)
         ELSE
            LATITUDE(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"longitude",LONGITUDEVARID)      
      ALLOCATE(LONGITUDEIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,LONGITUDEVARID,LONGITUDEIN)
c      WRITE(6,*)'SUBROUTINELONGITUDE, ISTAT = ',ISTAT
c      WRITE(6,100)(LONGITUDEIN(J),J=1,DIMTIME)
C     LONGITUDE IS REAL AND LONGITUDEIN IS DOUBLE PRECISION
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            LONGITUDE(J)=LONGITUDEIN(J)
         ELSE
            LONGITUDE(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"time",TIMEVARID)      
      ALLOCATE(TIMEIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,TIMEVARID,TIMEIN)
c      WRITE(6,*)'TIME, ISTAT = ',ISTAT
c      WRITE(6,100)(TIMEIN(J),J=1,DIMTIME)
C     TIME IS REAL AND TIMEIN IS DOUBLE PRECISION
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            TIME(J)=TIMEIN(J)
         ELSE
            TIME(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_GET_ATT(NCID,TIMEVARID,"units",CTIME)
      WRITE(6,*)'ISTAT = ',ISTAT
      WRITE(6,'(A)')CTIME
      READ(CTIME,333)IYEAR,IMONTH,IDAY,IHOURS,IMINS,ISECS
 333  FORMAT(14X,I4,1X,I2,1X,I2,1X,I2,1X,I2,1X,I2)
      IYEAR2=IYEAR-2000
      WRITE(6,334)IYEAR,IMONTH,IDAY,IHOURS,IMINS,ISECS
 334  FORMAT(I4,2I2.2,1X,3I2.2)
C     TIMESECSIN IS REAL
      TIMESECSIN=IHOURS*3600.+IMINS*60.+ISECS
      WRITE(6,*)'TIMESECS = ',TIMESECSIN

      WRITE(FLIGHTID6,'(3I2.2)')IYEAR2,IMONTH,IDAY
      WRITE(6,*)'FLIGHTID6 = ',FLIGHTID6
      WRITE(6,*)'FLIGHTID6TEST = ',FLIGHTID6TEST
C     TIMESECS, TIMESECSIN AND TIME ARE ALL REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            TIMESECS(J)=TIMESECSIN+TIME(J)
         ELSE
            TIMESECS(J)=-999.9
         ENDIF
         IF(J.LE.DIMTIME.AND.FLIGHTID6.NE.FLIGHTID6TEST)THEN
            TIMESECS(J)=TIMESECS(J)+86400.
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"altitude",ALTITUDEVARID)      
      ALLOCATE(ALTITUDEIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,ALTITUDEVARID,ALTITUDEIN)
c      WRITE(6,*)'SUBROUTINE ALTITUDE, ISTAT = ',ISTAT
c      WRITE(6,100)(ALTITUDEIN(J),J=1,DIMTIME)
C     ALTITUDE IS REAL AND ALTITUDEIN IS DOUBLE
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            ALTITUDE(J)=ALTITUDEIN(J)
         ELSE
            ALTITUDE(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"heading",HEADINGVARID)      
      ALLOCATE(HEADINGIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,HEADINGVARID,HEADINGIN)
c      WRITE(6,*)'SUBROUTINE HEADING, ISTAT = ',ISTAT
c      WRITE(6,100)(HEADINGIN(J),J=1,DIMTIME)
C     HEADING AND HEADINGIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            HEADING(J)=HEADINGIN(J)
         ELSE
            HEADING(J)=-999.9
         ENDIF
      ENDDO

c      ISTAT=NF90_INQ_VARID(NCID,"track",TRACKVARID)      
c      ALLOCATE(TRACKIN(DIMTIME))
c      ISTAT=NF90_GET_VAR(NCID,TRACKVARID,TRACKIN)
cc      WRITE(6,*)'SUBROUTINE, ISTAT = ',ISTAT
cc      WRITE(6,100)(TRACKIN(J),J=1,DIMTIME)
cC     TRACK AND TRACKIN ARE BOTH REAL
c      DO J=1,MAX_RAYS
c         IF(J.LE.DIMTIME)THEN
c            TRACK(J)=TRACKIN(J)
c         ELSE
c            TRACK(J)=-999.0
c         ENDIF
c      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"roll",ROLLVARID)      
      ALLOCATE(ROLLIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,ROLLVARID,ROLLIN)
c      WRITE(6,*)'SUBROUTINE ROLL, ISTAT = ',ISTAT
c      WRITE(6,100)(ROLLIN(J),J=1,DIMTIME)
C     ROLL AND ROLLIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            ROLL(J)=ROLLIN(J)
         ELSE
            ROLL(J)=-999.0
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"pitch",PITCHVARID)      
      ALLOCATE(PITCHIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,PITCHVARID,PITCHIN)
c      WRITE(6,*)'SUBROUTINE PITCH, ISTAT = ',ISTAT
c      WRITE(6,100)(PITCHIN(J),J=1,DIMTIME)
C     PITCH AND PITCHIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            PITCH(J)=PITCHIN(J)
         ELSE
            PITCH(J)=-999.9
         ENDIF
       ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"drift",DRIFTVARID)      
      ALLOCATE(DRIFTIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,DRIFTVARID,DRIFTIN)
c      WRITE(6,*)'SUBROUTINE DRIFT, ISTAT = ',ISTAT
c      WRITE(6,100)(DRIFTIN(J),J=1,DIMTIME)
C     DRIFT AND DRIFTIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            DRIFT(J)=DRIFTIN(J)
         ELSE
            DRIFT(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"rotation",ROTATIONVARID)      
      ALLOCATE(ROTATIONIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,ROTATIONVARID,ROTATIONIN)
c      WRITE(6,*)'SUBROUTINE ROTATION, ISTAT = ',ISTAT
c      WRITE(6,100)(ROTATIONIN(J),J=1,DIMTIME)
C     ROTATION AND ROTATIONIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            ROTATION(J)=ROTATIONIN(J)
         ELSE
            ROTATION(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"tilt",TILTVARID)      
      ALLOCATE(TILTIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,TILTVARID,TILTIN)
c      WRITE(6,*)'SUBROUTINE TILT, ISTAT = ',ISTAT
c      WRITE(6,100)(TILTIN(J),J=1,DIMTIME)
C     TILT AND TILTIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            TILT(J)=TILTIN(J)
         ELSE
            TILT(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"eastward_velocity",GSEVARID)      
      ALLOCATE(GSEIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,GSEVARID,GSEIN)
c      WRITE(6,*)'SUBROUTINE GSE, ISTAT = ',ISTAT
c      WRITE(6,100)(GSEIN(J),J=1,DIMTIME)
C     GSE AND GSEIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            GSE(J)=GSEIN(J)
         ELSE
            GSE(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"northward_velocity",GSNVARID)      
      ALLOCATE(GSNIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,GSNVARID,GSNIN)
c      WRITE(6,*)'SUBROUTINE GSN, ISTAT = ',ISTAT
c      WRITE(6,100)(GSNIN(J),J=1,DIMTIME)
C     GSN AND GSNIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            GSN(J)=GSNIN(J)
         ELSE
            GSN(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"vertical_velocity",VGSVARID)      
      ALLOCATE(VGSIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,VGSVARID,VGSIN)
c      WRITE(6,*)'SUBROUTINE VGS, ISTAT = ',ISTAT
c      WRITE(6,100)(VGSIN(J),J=1,DIMTIME)
C     VGS AND VGSIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            VGS(J)=VGSIN(J)
         ELSE
            VGS(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"eastward_wind",UVARID)      
      ALLOCATE(UIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,UVARID,UIN)
c      WRITE(6,*)'SUBROUTINE U, ISTAT = ',ISTAT
c      WRITE(6,100)(UIN(J),J=1,DIMTIME)
C     BOTH U AND UIN ARE REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            U(J)=UIN(J)
         ELSE
            U(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"northward_wind",VVARID)      
      ALLOCATE(VIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,VVARID,VIN)
c      WRITE(6,*)'SUBROUTINE V, ISTAT = ',ISTAT
c      WRITE(6,100)(VIN(J),J=1,DIMTIME)
C     V AND VIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            V(J)=VIN(J)
         ELSE
            V(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"vertical_wind",WVARID)      
      ALLOCATE(WIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,WVARID,WIN)
c      WRITE(6,*)'SUBROUTINE W, ISTAT = ',ISTAT
c      WRITE(6,100)(WIN(J),J=1,DIMTIME)
C     W AND WIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            W(J)=WIN(J)
         ELSE
            W(J)=-999.9
         ENDIF
      ENDDO

      ALLOCATE(IDBZ(DIMRANGE,DIMTIME))
      ALLOCATE(DBZIN(DIMRANGE,DIMTIME))      
      ISTAT=NF90_GET_VAR(NCID,DBZVARID,IDBZ)
c      WRITE(6,*)'ISTAT GET VAR DBZ = ',ISTAT
C     IDBZ IS INTEGER*2 AND DBZIN IS REAL
      DO J=1,DIMTIME
c         WRITE(6,*)'DBZ J = ',J
         DO I=1,DIMRANGE
            IF(IDBZ(I,J).LT.-30000)THEN
               DBZIN(I,J)=-32.
            ELSE
               DBZIN(I,J)=IDBZ(I,J)/100.
            ENDIF
         ENDDO
c         WRITE(6,200)(IDBZ(I,J),I=1,DIMRANGE)
c         WRITE(6,100)(DBZIN(I,J),I=1,DIMRANGE)
 100     FORMAT(10F8.2)
      ENDDO
      IF(IAUTOMAN.EQ.1)THEN
         ISTAT=NF90_INQ_VARID(NCID,"VU",VELVARID)
      ELSE
         ISTAT=NF90_INQ_VARID(NCID,"VEL",VELVARID)
      ENDIF
c      WRITE(6,*)'DBZVARID STATUS, VALUE = ',ISTAT,VELVARID
      ALLOCATE(IVEL(DIMRANGE,DIMTIME))
      ALLOCATE(VELIN(DIMRANGE,DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,VELVARID,IVEL)
C     IVEL IS INTEGER*2 AND VELIN IS REAL
      DO J=1,DIMTIME
c         WRITE(6,*)'VEL J = ',J
         DO I=1,DIMRANGE
            IF(IVEL(I,J).LT.-30000)THEN
               VELIN(I,J)=-888.8
            ELSE
               VELIN(I,J)=IVEL(I,J)/100.
            ENDIF
         ENDDO
c         WRITE(6,200)(IVEL(I,J),I=1,DIMRANGE)
c         WRITE(6,100)(VELIN(I,J),I=1,DIMRANGE)
      ENDDO
      ISTAT=NF90_INQ_VARID(NCID,"WIDTH",WIDTHVARID)
      ALLOCATE(IWIDTH(DIMRANGE,DIMTIME))
      ALLOCATE(WIDTHIN(DIMRANGE,DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,WIDTHVARID,IWIDTH)
C     IWIDTH IS INTEGER*2 AND WIDTHIN IS REAL
      DO J=1,DIMTIME
c         WRITE(6,*)'WIDTH J = ',J
         DO I=1,DIMRANGE
            IF(IWIDTH(I,J).LT.-32767)THEN
               WIDTHIN(I,J)=-888.8
            ELSE
               WIDTHIN(I,J)=327.68+IWIDTH(I,J)/100.
            ENDIF
         ENDDO   
 200     FORMAT(10I8)
c         WRITE(6,100)(WIDTHIN(I,J),I=1,DIMRANGE)
      ENDDO
      ISTAT=NF90_INQ_VARID(NCID,"SQI",SQIVARID)
      ALLOCATE(ISQI(DIMRANGE,DIMTIME))
      ALLOCATE(SQIIN(DIMRANGE,DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,SQIVARID,ISQI)
C     ISQI IS INTEGER*2 AND SQIIN IS REAL
      DO J=1,DIMTIME
c         WRITE(6,*)'SQI J = ',J
         DO I=1,DIMRANGE
            IF(ISQI(I,J).LT.-32767)THEN
               SQIIN(I,J)=0.
            ELSE
               SQIIN(I,J)=.5+ISQI(I,J)*.00001525949
            ENDIF
         ENDDO   
c         WRITE(6,100)(SQIIN(I,J),I=1,DIMRANGE)
      ENDDO
      DO J=1,DIMTIME
         DO I=1,DIMRANGE
C     ALL 8 VARIABLES IN THIS LOOP ARE REAL
            DBZ(I,J)=DBZIN(I,J)
            VEL(I,J)=VELIN(I,J)
            WIDTH(I,J)=WIDTHIN(I,J)
            SQI(I,J)=SQIIN(I,J)
         ENDDO
         IF(DIMRANGE.LT.MAX_HRD_DIM)THEN
            DO I=DIMRANGE+1,MAX_HRD_DIM
               DBZ(I,J)=-32.0
               VEL(I,J)=-888.8
               WIDTH(I,J)=-888.8
               SQI(I,J)=0.
            ENDDO
         ENDIF
      ENDDO
      IF(DIMTIME.LT.MAX_RAYS)THEN
         DO J=DIMTIME+1,MAX_RAYS
            DO I=1,MAX_HRD_DIM
               DBZ(I,J)=-32.0
               VEL(I,J)=-888.8
               WIDTH(I,J)=-888.8
               SQI(I,J)=0.
            ENDDO
         ENDDO
      ENDIF
      ISTAT=NF90_CLOSE(NCID)
      RCOR=0.
      IF(IAUTOMAN.EQ.0)THEN
         PCOR=0.
         DCOR=0.
         AZMCOR=0.
         ELCOR=0.
      ENDIF
C     ALL THE VARIABLES IN THIS LOOP ARE REAL
      WRITE(6,*)'PCOR,DCOR,AZMCOR,ELCOR = ',PCOR,DCOR,AZMCOR,ELCOR
      WRITE(6,*)'IAUTOMAN = ',IAUTOMAN
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            PITCH1=PITCH(J)
            DRIFT1=DRIFT(J)
            ROLL1=ROLL(J)
            TRAKAZM=ROTATION(J)
            TRAKELEV=TILT(J)
            IDRADAR=2
            IF(PITCH1.GT.-100..AND.DRIFT1.GT.-100..AND.ROLL1.GT.-100..
     +           AND.TRAKAZM.GT.-100..AND.TRAKELEV.GT.-100.)THEN
               TRACK(J)=AMOD(HEADING(J)+DRIFT1+DCOR+360.0,360.)
               CALL ANGLECOR(PITCH1,DRIFT1,ROLL1,TRAKAZM,TRAKELEV,
     +           IDRADAR,PCOR,DCOR,RCOR,AZMCOR,ELCOR)
               TRACKTEMP=TRACK(J)
               TRAKAZMTEMP=TRAKAZM
               TRAKELEVTEMP=TRAKELEV
c               WRITE(6,*)'J,TRACK,TRAKAZM,TRAKELEV BEFORE = ',
c     +              J,TRACKTEMP,TRAKAZMTEMP,TRAKAZMTEMP,TRAKELEVTEMP
c               WRITE(6,*)'J,HORAZM, HORELEV BEFORE = ',J,HORAZM,HORELEV
               CALL CONVERTANGLES(TRACKTEMP,TRAKAZMTEMP,TRAKELEVTEMP,
     +              HORAZM,HORELEV)
c               WRITE(6,*)'J,TRACK,TRAKAZM,TRAKELEV AFTER = ',
c     +            J,TRACKTEMP,TRAKAZMTEMP,TRAKAZMTEMP,TRAKELEVTEMP
c               WRITE(6,*)'J,HORAZM, HORELEV AFTER = ',J,HORAZM,HORELEV
               AZ_EL(1,J)=TRAKAZMTEMP
               AZ_EL(2,J)=TRAKELEVTEMP
               IF(IAUTOMAN.EQ.1)THEN
                  HORAZM=90-HORAZM
                  IF(HORAZM.LT.0.)HORAZM=HORAZM+360.
                  IF(HORAZM.GT.360.)HORAZM=HORAZM-360.
c     TRACK(J)=TRACKTEMP
                  EEV(J)=HORELEV
                  EAZM(J)=HORAZM
               ENDIF
            ELSE
               AZ_EL(1,J)=-999.9
               AZ_EL(2,J)=-999.9
            ENDIF
            IF(IAUTOMAN.EQ.1)THEN
               PITCH(J)=PITCH1
               DRIFT(J)=DRIFT1
               ROTATION(J)=ROTATION(J)+AZMCOR
               TILT(J)=TILT(J)+ELCOR
            ENDIF
         ELSE
            AZ_EL(1,J)=-999.9
            AZ_EL(2,J)=-999.9
         ENDIF
      ENDDO
      RETURN
      END
      FUNCTION VTERM_NEW(Z,H,hb,dpb,IRSW,ZLOW,ZHIGH) 
C Terminal velocity from dBZ and height 
C This function computes mean terminal velocity from the reflectivity 
C according to Paul Willis' 2-parameter gamma distribution and
C a snow relationship developed by Atlas et al. (1973)
C Reflectivity, in terms of dBZ, must be passed to this routine.
C HEIGHT MUST BE IN KM
c irsw - 0 Joss and Waldvogel; >0 Willis Gamma
C hb is the height of the bright band, and dpb is the depth of the bright 
C   band both in km 
C 
      ZZ=10.0**(Z*0.1)
      hlow= hb - dpb * .5 
      hhi= hlow + dpb 
C density correction term (rhoo/rho)*0.45 [rho(Z)=rhoo exp-(z/H), where 
C  H is the scale height = 9.58125 from Gray's inner 2 deg composite] 
C 0.45 density correction from Beard (1985, JOAT pp 468-471)
      DCOR=EXP(0.45*H*.10437052)
C The snow relationship (Atlas et al., 1973) --- VT=0.817*Z**0.063  (m/s)
      VTS=-DCOR * (0.817*ZZ**0.063) 
C      VTS=-0.817*ZZ**0.063
      if(irsw.gt.0) then
C The rain relationship --- from Willis analytical-gamma distribution 
         TERM1=7.331/ZZ**0.010022 
         TERM2=0.14034*ZZ**0.095238 
         VTR=-DCOR * (5.5011E+09/(TERM1+TERM2)**10.5) 
      else
C The rain relationship (Joss and Waldvogel,1971) --- VT=2.6*Z**.107 (m/s)
         VTR=-DCOR * (2.6*ZZ**.107) 
      endif 
C test if height is in the transition region between SNOW and RAIN
C  defined as hlow in km < H < hhi in km
C  if in the transition region do a linear weight of VTR and VTS
C Melting band thickness less than 1.5km will be considered stratifrom
C Therefore anything above the melting band will be considered snow
C If the melting band is greater than 1.5 km then the fall speed will
C Use ZLOW and ZHIGH to determine the fallspeed, where anything above
C ZHIGH will be considered to have the fall speed of water
C This version of VTERM is called by interpolating routines that need to use 
C the vertical wind when comparing a Doppler radial to a background guess field
C This version was designed for stratiform downwind legs in particular where 
C where the height and depth of the boundary layer is allowed to vary along 
C the track.  This is designed to beautify somewhat the vertical wind in 3D 
C analyses along the downwind portion where poor specifications of the 
C precipitation fall speed causes 1-2 m/s melting-band vertical-wind anomlies 
C can stand out relative to the other vertical winds.  
C
      IF(Z.GT.ZLOW.AND.Z.LE.ZHIGH.AND.DPB.GT.1.5)THEN
       WEIGHTR=(Z-ZLOW)/(ZHIGH-ZLOW)
       WEIGHTS=1.-WEIGHTR
       VTS=(VTR*WEIGHTR+VTS*WEIGHTS)/(WEIGHTR+WEIGHTS)
      ELSEIF(DPB.GT.1.5.AND.Z.GT.ZHIGH)THEN
       VTS=VTR
      ENDIF
      VTERM_NEW=VTR*(hhi-H)/dpb + VTS*(H-hlow)/dpb  
      IF(H.LT.hlow) VTERM_NEW=VTR 
      IF(H.GT.hhi) VTERM_NEW=VTS
      RETURN
      END 
      
         
