      PROGRAM LEASTWIND
C*****Beginning of declaration of variables in the header record of 
C*****an HRD type Doppler wind file
      CHARACTER FLTNAME*8,EXPERIMENT*32
      CHARACTER FILNAM(40)*80
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT
C*****End of header variables
C
C*****
      REAL TSTARTARRAY(40),TENDARRAY(40)
      CHARACTER FLNAM*80,TATF(80)*2
C
C COMYES DETERMINES WHETHER A COMMAND FILE IS READ
C IN FACT THIS IS ALWAYS DONE
C
      CHARACTER COMYES*1
      CHARACTER OSUMFILENAME(80)*80
      INTEGER IMAX,JMAX,KMAX
      REAL XSHIFT(80),YSHIFT(80),DBZFACT(80)
      REAL RZMAX,EZMAX
      REAL XACC,YACC,ZACC
      PARAMETER(N1=400000,N2=1600000,N3=1200000,N8=3200000)
      REAL SUM1(N1),SUM2(N1),SUM3(N1)
      REAL SUM4(N1),SUM5(N1),SUM6(N1)
      REAL SUM7(N1),SUM8(N1),SUM9(N1)
      REAL SUM10(N1),SUM11(N1),SUM12(N1),SUM13(N1)
      REAL DISTXYZ(N8)
      REAL SUMWTSAVE(N1),SUMDBZ(N1)
      REAL UGUESS(N1),VGUESS(N1),WGUESS(N1)
      CHARACTER RAMSFILES(80)*80
      CHARACTER GRAPHICSYES*1
      REAL VELS(N3)
      CALL GETARG(1,GRAPHICSYES)
      IF(GRAPHICSYES.EQ.'G'.OR.GRAPHICSYES.EQ.'g')THEN
       IGRAPHICS=1
      ELSE
       IGRAPHICS=0
      ENDIF
      RFLAG=-1.0E+10
      OPEN(1,FILE='/dev/null')
      CTR=3.14159/180.
      LUOUT=6
      LUSCAN=97
      DO N=1,N1
       SUMDBZ(N)=RFLAG
      ENDDO
      IDBZONLY=0
C      WRITE(6,*)'Would you like to use a command file?'
C      READ(1,'(A)')COMYES
      COMYES='Y'
      IF(COMYES.EQ.'Y'.OR.COMYES.EQ.'y')THEN
       LUIN=16
c       WRITE(6,*)'Enter command file name'
c       READ(1,'(A)')FILNAM(1)
       FILNAM(1)='jobfile_radar_rt'
       OPEN(16,FILE=FILNAM(1),STATUS='OLD')
      ELSE
       LUIN=1
      ENDIF
C      WRITE(6,*)'Enter flight name 8 characters or less'
      READ(LUIN,'(A8)')FLTNAME
      WRITE(6,1501)FLTNAME
1501  FORMAT('FLIGHT ID IS ',A8)
C      WRITE(6,*)'Enter Experiment Name 32 characters or less'
      READ(LUIN,'(A32)')EXPERIMENT
      WRITE(6,1502)EXPERIMENT
1502  FORMAT('EXPERIMENT NAME IS ',A32)
C      WRITE(6,*)'How many DOP3D files will be used in this program?'
c      READ(LUIN,*)NFILE
      NFILE=2
      WRITE(6,1503)NFILE
1503  FORMAT('NUMBER OF UF FILES TO BE INTERPOLATED IN THIS RUN '/
     + 'BE ',I3)
      IF(NFILE.GT.40)THEN
       WRITE(6,*)'Too many files'
       STOP
      ENDIF
      FILNAM(1)='SUMFILE_aft_rt_auto_first'
      FILNAM(2)='SUMFILE_fore_rt_auto_first'
      OSUMFILENAME(1)='SUMFILE_aft_rt_auto_first'
      OSUMFILENAME(2)='SUMFILE_fore_rt_auto_first'
      READ(LUIN,'(3I2,X,3I2)')IB,JB,KB,IE,JE,KE
      WRITE(6,1506)NF,IB,JB,KB
1506  FORMAT('BEGINNING TIME FOR FILE NO. ',I3,' WILL BE ',3I2)
      WRITE(6,1507)NF,IE,JE,KE
1507  FORMAT('ENDING TIME FOR FILE NO. ',I3,' WILL BE ',3I2)
      TSTART=IB*3600.+JB*60+KB
      STIME=TSTART
      ETIME=IE*3600.+JE*60.+KE
      IF(ETIME.LT.STIME)THEN
       TEND=ETIME+86400.
      ELSE
       TEND=ETIME
      ENDIF
      WRITE(6,*)'STIME,ETIME,TSTART,TEND = ',
     +            STIME,ETIME,TSTART,TEND              
      DO NF=1,2
       TATF(NF)='TA'
       TATF(NF)='TF'
       TSTARTARRAY(NF)=TSTART
       TENDARRAY(NF)=TEND
       DBZFACT(NF)=1.
       XSHIFT(NF)=0.
       YSHIFT(NF)=0.
       WRITE(6,1508)NF,OSUMFILENAME(NF)
1508   FORMAT('OUTPUT INTERPOLATION SUMFILE FOR INPUT FILE NO. ',I3/
     + 'WILL BE ',A80)
       WRITE(6,11508)TATF(NF)
11508  FORMAT('SCAN TYPE WILL BE ',A2)
      ENDDO
      READ(LUIN,*)SMOTIONU,SMOTIONV
      WRITE(6,1509)SMOTIONU,SMOTIONV
1509  FORMAT('ADVECTION FOR VELOCITY FOR INTERPOLATION COMPOSITE '/
     + 'WILL BE ',2F8.3,' M/S')
      READ(LUIN,'(3I2)')IH,IM,IS
      WRITE(6,1510)IH,IM,IS
1510  FORMAT('TIME OF ZERO ADVECTION IN COMPOSITE WILL BE ',3I2)
      CENTIME=IH*3600+IM*60+IS
      IF(CENTIME.LT.STIME.AND.ETIME.GT.86400)CENTIME=CENTIME+86400.
      READ(LUIN,*)OLAT,OLON
      WRITE(6,1511)IH,IM,IS,OLAT,OLON
1511  FORMAT('LATITUDE AND LONGITUDE OF ORIGIN AT TIME ',3I2/
     + 'WILL BE ',2F8.3)
      I1REMOVE=0
C      WRITE(6,*)'Enter SX,SY,SZ OF OUTPUT FILE'
      READ(LUIN,*)SX,SY,SZ
      WRITE(6,1512)SX,SY,SZ
1512  FORMAT('RADIAL-, AZIMUTHAL-, AND VERTICAL-DIRECTION GRID '/
     + 'RESOLUTIONS ARE ',F6.2,' KM, ',F6.2,' DEGREES, AND '/
     + F6.2,' KM, RESPECTIVELY')
C      WRITE(6,*)'Enter XZ,YZ,ZZ,ROT OF OUTPUT FILE'
      READ(LUIN,*)XZ,YZ,ZZ
C 
C SINCE OUTPUT IS IN CYLINDRICAL COORDINATES ROTATION IS SET TO ZERO
C
      ROT=0.
      WRITE(6,1513)XZ
1513  FORMAT('MINIMUM RADIUS FROM STORM CENTER WILL BE ',F8.3)
      WRITE(6,1514)YZ
1514  FORMAT('MINIMUM AZIMUTH COUNTERCLOCKWISE FROM EAST WILL BE ',
     + F8.3,' DEGREES')
      WRITE(6,1515)ZZ
1515  FORMAT('HEIGHT OF LEVEL 1 WILL BE ',F8.3,' KM')
      READ(LUIN,*)IMAX,JMAX,KMAX
      WRITE(6,1516)IMAX,JMAX,KMAX
1516  FORMAT('RADIAL, AZIMUTHAL, AND VERTICAL DIMENSIONS OF ARRAYS '/
     + 'WILL BE ',3I4)
      RRMAX=2.*SX
      RTMAX=3.*SY
      RZMAX=2.*SZ
      WRITE(6,1517)RRMAX,RTMAX,RZMAX
1517  FORMAT('RADIAL, AZIMUTHAL, AND VERTICAL RADII (KM) OF '/
     + 'INFLUENCE OF DOPPLER DATA WILL BE ',3F8.2)
      ERMAX=SX
      ETMAX=SY
      EZMAX=SZ
      WRITE(6,1518)ERMAX,ETMAX,EZMAX
1518  FORMAT('RADIAL, AZIMUTHAL, AND VERTICAL E-FOLDING DISTANCE '/
     + 'FOR GAUSSIAN INTERPOLATION WILL BE ',3F8.2,' KM')
      XACC=99.
      YACC=99.
      ZACC=99.
1519  FORMAT('MAXIMUM ALLOWABLE RADIAL, AZIMUTHAL, AND VERTICAL '/
     + 'DISPLACEMENT OF WEIGHTED AVERAGE POSITION OF OBSERVATIONS '/
     + 'FROM NOMINAL GRID POSITION WILL BE ',3F8.2,' KM')
      PIMAX=45.
      WRITE(6,1520)PIMAX
1520  FORMAT('MAXIMUM AZIMUTHAL DISTANCE (IN DEGREES) '/
     + ' THAT AN OBSERVATION CAN BE FROM A GRID POINT AND BE '/
     + ' INCLUDED IN THE WEIGHTED AVERAGE WILL BE ',F8.2)
      IACROSS=1
      IF(IACROSS.EQ.1)THEN
C
C The following implies a cylindrical wind field with azimuths
C that start before azimuth 0 and extend beyond azimuth 0,
C or implies a full 360 coordinate coverage
C
       WRITE(6,*)'J=1 AND J=JMAX WILL BE CONSIDERED ADJACENT'
      ELSE
C
C Implies a wedge that starts at azimuth greater than 0 and ends
C at azimuth less than 360
C
       WRITE(6,*)'J=1 AND J=JMAX WILL NOT BE CONSIDERED ADJACENT ',
     + '(SECTOR ONLY)'
      ENDIF
C
C LEGACY VARIABLE ALLOWS A DIFFERENT NUMBER OF LEVELS BETWEEN SYNTHESIS
C AND ORIGINAL INTERPLOATION
C
      KMIN2=1
      KMAX2=KMAX
      WRITE(6,1521)KMIN2,KMAX2
1521  FORMAT('MINIMUM AND MAXIMUM LEVELS OF INTERPOLATION FILE ',
     + 'TO BE FILLED ARE ',2I4)
      SINTOL=90.
      WRITE(6,1522)SINTOL
1522  FORMAT('MAXIMUM ANGLE OF DOPPLER RADIAL RELATIVE TO '/
     + 'HORIZONTAL (EARTH-RELATIVE ELEVATION ANGLE) TO BE '/
     + 'ACCEPTABLE FOR INTERPOLATION WILL BE ',F8.2,' DEGREES')
      IF(SINTOL.GE.90.)THEN
       SINTOL=1.
      ELSE
       SINTOL=SINTOL*3.14159/180.
       SINTOL=SIN(SINTOL)
      ENDIF
C
C Legacy
C Begin legacy variables
C Many of the variables really only apply to synthesis stage and
C this is an interpolation program
C 
      TOLERANCE=1000.
      IVWIND=0
      FACTZ=0.
      FACTRH=0.
      ICONTINUITY=0
C
C End legacy variables
C
      IGUESS=0
      IREVERSE=0
      IREADABCD=0
      IWRITEABCD=1
      RDEL=0.0
C      WRITE(6,*)'Enter minimum dBZ and range to include data'
C      READ(1,*)DBZTEST,RRRR
      DBZTEST=-2000.
      RRRR=10.
C      WRITE(6,*)'Use rams files for position--yes(1) or no (0)?'
C      READ(1,*)IRAMSFILES
      IRAMSFILES=0
C
C These VSPEED variables apply to how rapidly to advect observations
C upwind or downwind in azimuthal direction when compositing data
C
C      WRITE(6,*)'Use a constant tangential advection speed (1/0)?'
C      READ(1,*)IVSPEED
C
      IVSPEED=0
      IF(IVSPEED.EQ.1)THEN
       WRITE(6,*)'Enter advection speed'
       READ(1,*)VSPEED0
       VFACTOR=1.
      ELSE
       IF(IGUESS.EQ.5)THEN
        WRITE(6,*)'Enter factor to multiply wind speed by for advection'
        READ(1,*)VFACTOR
       ELSE
        VFACTOR=0.
       ENDIF
       IVSPEED=0
      ENDIF
      IF(IRAMSFILES.EQ.1)THEN
       DO NF=1,NFILE
        READ(LUIN,'(A80)')RAMSFILES(NF)
        WRITE(6,1530)NF,RAMSFILES(NF)
1530    FORMAT('RAMS FILE FOR UF FILE NO. ',I3,' WILL BE: '/A80)
       ENDDO
      ENDIF
C
C Legacy stuff
C
      DO IJK=1,N1
       UGUESS(IJK)=0.
       VGUESS(IJK)=0.
       WGUESS(IJK)=0.
      ENDDO
C
C Since we are working with real time data stream there is only one
C input file, so NFILE=1
C
      NF=1
      write(6,*)'at the beginning of nfile do loop nf = ',nf
C
C Read Scan File No. NF 
C
C sum effects from present wind file, and compute winds if last file
C in iteration
C
      WRITE(6,*)'CALLING ABCD'
      IF(IRAMSFILES.EQ.1)THEN
       CALL OPENRAMFILE(RAMSFILES(NF),LUOUT,STIME,ETIME,DATARATE,IERR)
      ENDIF
      TSTART=TSTARTARRAY(NF)
      TEND=TENDARRAY(NF)
      SLOPE1=DBZFACT(NF)
C
C ABCD is the subroutine that reads the file and composites the observations
C
      CALL ABCD
     1   (RRMAX,RTMAX,RZMAX,ERMAX,ETMAX,EZMAX,XACC,YACC,ZACC,NF,
     2   SUM1,SUM2,SUM3,SUM4,SUM5,SUM6,SUM7,SUM8,SUM9,
     2   SUM10,SUM11,SUM12,SUM13,
     3   KMIN2,KMAX2,
     4   SINTOL,SX,SY,SZ,XZ,YZ,ZZ,ROT,IMAX,JMAX,KMAX,SUMDBZ,
     6   SUMWTSAVE,VELS(1),VELS(1+N1),VELS(1+2*N1),
     6   IGUESS,
     7   IREADABCD,OLAT,OLON,
     9   SLOPE1,CENTIME,TSTART,TEND,
     1   SMOTIONU,SMOTIONV,FLTNAME,DBZTEST,RRRR,
     1   UGUESS,VGUESS,WGUESS,IREVERSE,IRAMSFILES,
     1   DISTXYZ,PIMAX,IACROSS,IVSPEED,VSPEED0,VFACTOR,TATF,IGRAPHICS)
C
C File 98 is opened in one of the routines ABCD calls
C
      CLOSE(98)
C
C Legacy--IWRITEABCD should always be 1 in this program
C
      IF(IWRITEABCD.EQ.1)THEN
C
C LUW is the logical unit number for output SUMFILE.  File is opened
C in main program but closed in a subroutine
C
       LUW=95
       NFF=1
       OPEN(LUW,FILE=OSUMFILENAME(NFF),FORM='UNFORMATTED')
C
C WRITEABCD IS THE SUBROUTINE THAT WRITES OUT THE SUMMATIONS OF PRODUCTS
C THAT ARE NEEDED FOR THE LEAST SQUARES WIND SOLUTION IN THE SYNTHESIS
C PROGRAMS
C
       CALL WRITEABCD(LUW,IMAX,JMAX,KMAX,SUM1,SUM2,SUM3,
     +   SUM4,SUM5,SUM6,SUM7,SUM8,SUM9,SUM10,SUM11,SUM12,SUM13,SUMDBZ,
     +   VELS(1),VELS(N1+1),VELS(2*N1+1),NFF)
       write(6,*)'ended writeabcd for file ',nf
C
C APPARENTLY FILE LUW IS CLOSED IN WRITEABCD
C
       NFF=2
       OPEN(LUW,FILE=OSUMFILENAME(NFF),FORM='UNFORMATTED')
       CALL WRITEABCD(LUW,IMAX,JMAX,KMAX,SUM1,SUM2,SUM3,
     +   SUM4,SUM5,SUM6,SUM7,SUM8,SUM9,SUM10,SUM11,SUM12,SUM13,SUMDBZ,
     +   VELS(1),VELS(N1+1),VELS(2*N1+1),NFF)
       write(6,*)'ended writeabcd for file ',nf
      ENDIF
      STOP
      END
