      PROGRAM EDIT_SWEEPS_LIST
C This program is designed to remove any sweep files from previous flights
C that might make into the TDR flight folder.  These can screw up the 
C beginning and ending of processing.
      CHARACTER DIRECTORYNAME*132,DUMMY*132,COMMAND*132,SKIP_STRING*8
      CHARACTER DIRECTORYNAME2*132,SUBTEST*4
C DIRECTORYNAME:  where sweep files are stored for a given flight id
C COMMAND A system command that will be placed in a script
      CHARACTER CDATE*6,CPLANE*1,CDATELIST*6,CTIME*6,CTIME2*6,CFNO*1
C CDATE Date the start of the flight in the form YYMMDD
C CPLANE H=42, I=43, N=49 42 and 43 are P3s, 49 is a G-IV

      INTEGER(8) YEAR2,YEAR3,MONTH2,MONTH3,DAY2,DAY3,TOTALSECONDS2
C YEAR2, MONTH2, AND DAY2 ARE YEAR MONTH AND DAY FOR START TIME OF 3D ANALYSIS
      INTEGER(8) HOURS,MINUTES,SECONDS,TOTALSECONDS3,EPOCH_TIME
      INTEGER(8) DIFFSECONDS
      INTEGER CDATE2,TIMEFILE,TIMEFILE2,CDATE3
C TIMEFILE  Time in seconds since 000000 UTC on the data the flight starts
C  that the 3D analysis starts
C CDATE  Integer variable for date in YYMMDD 
      CHARACTER*80 FILENAME,FILENAMESAVE,FMT,CTIMEFILE2
      CHARACTER*80 PREFIX,CDUMMY,FMT2,FMT3,PREFIX1
C PREFIX: /home/hrd/YYYYMMDDAI/xxx where xxx is 2TA, 2TM, 2TS, nrs, nrm etc
C The size of PREFIX must be changes if DIRECTORYNAME is not as in previous line
      OPEN(80,FILE='jobfile_radar')
      READ(80,'(A6,2A1,I6)')CDATE,CPLANE
      READ(80,'(A)')CDUMMY
      READ(80,'(3I2)')HOURS,MINUTES,SECONDS
      TIMEFILE=HOURS*3600+MINUTES*60+SECONDS
c      WRITE(6,*)'TIMEFILE = ',TIMEFILE
c      WRITE(6,'(A6)')CDATE
c      WRITE(6,'(2A1)')CPLANE,CFNO
c      WRITE(6,'(A6)')CTIME
      READ(CDATE,'(I6)')CDATE2
      READ(CDATE,'(3I2)')YEAR2,MONTH2,DAY2
      YEAR2=YEAR2+2000
C BECOMES YEAR AD RATHER THAN 2 DIGIT YEAR
      IF(YEAR2.GT.2040)YEAR2=YEAR2-100
c      WRITE(6,*)'YEAR2,MONTH2,DAY2 = ',YEAR2,MONTH2,DAY2
c      WRITE(6,*)'CDATE2 = ',CDATE2
      TOTALSECONDS2=EPOCH_TIME(YEAR2,MONTH2,DAY2,HOURS,MINUTES,SECONDS)
C TOTALSECONDS TIME OF BEGINING OF ANALYSIS RELATIVE TO 000000 UTC 1 JAN 1970
c      WRITE(6,*)'TOTALSECONDS = ',TOTALSECONDS2
      DO I=1,20
       READ(80,'(A)')DUMMY
      ENDDO
      READ(80,'(A)')DIRECTORYNAME
      CALL SYSOPCHANGE(DIRECTORYNAME,DIRECTORYNAME2)
      DIRECTORYNAME=DIRECTORYNAME2
      WRITE(6,'(A)')DIRECTORYNAME
      LENGTHF1=LEN(TRIM(DIRECTORYNAME))
      LENGTHF=LEN(TRIM(DIRECTORYNAME))+3
      WRITE(6,*)'LENGTH OF DIRECTORY NAME IS ',LENGTHF
c      PAUSE
      OPEN(81,FILE='sweeps_list')
      OPEN(82,FILE='edited_sweeps_list')
 1    READ(81,'(A)',END=999)FILENAME
c      WRITE(6,*)'FILENAME = ',FILENAME
C      READ(FILENAME,'(A4)')SUBTEST
      LENGTH=LEN(TRIM(FILENAME))
      FILENAMESAVE=FILENAME
      WRITE(FMT2,700)LENGTHF
      WRITE(FMT3,702)LENGTHF1
 700  FORMAT('(A',I0,',A6,3I2)')
 702  FORMAT('(A',I0,',A4)')      
c      WRITE(6,701)FMT2
 701  FORMAT('FORMAT = ',A)
      READ(FILENAME,FMT3)PREFIX1,SUBTEST
c      WRITE(6,*)'SUBTEST = ',SUBTEST
      IF(SUBTEST.EQ.'sub_')GO TO 480
      READ(FILENAME,FMT2)PREFIX,CDATELIST,HOURS,MINUTES,SECONDS
C     Determine the date (YYMMDD), hours, minutes, and seconds of first sweep
C listed in file
 100  FORMAT(A24,A6,3I2)
C **beginning of computing epoch time of first sweep file**
      TIMEFILE2=HOURS*3600+MINUTES*60+SECONDS
      READ(CDATELIST,'(I6)')CDATE3
      READ(CDATELIST,'(3I2)')YEAR3,MONTH3,DAY3
c      WRITE(6,*)'CDATE2,CDATE3 = ',CDATE2,CDATE3
      YEAR3=YEAR3+2000
      TOTALSECONDS3=EPOCH_TIME(YEAR3,MONTH3,DAY3,HOURS,MINUTES,SECONDS)
C TOTALSECONDS3 is the epoch time of first sweep file in 'sweeps_list'
C **ending of computing epoch time of first sweep file'
C DIFFSECONDS is the difference in seconds between the start of the analysis
C and the time of the first file in 'sweeps_list'
      DIFFSECONDS=TOTALSECONDS3-TOTALSECONDS2
c      WRITE(6,200)PREFIX
 200  FORMAT('PREFIX = ',A24)
c      WRITE(6,300)CDATE,CDATELIST
 300  FORMAT('CDATE = ',A6,' AND CDATELIST = ',A6)
c      WRITE(6,450)TIMEFILE,TIMEFILE2
C      IF(CDATE3.GT.CDATE2.OR.(CDATE3.EQ.CDATE2.AND.
C     1   TIMEFILE2-TIMEFILE.GE.-200))THEN
      IF(CDATE3.GE.CDATE2.AND.DIFFSECONDS.GT.-30000)THEN
C If sweep is less than 30000 seconds before analysis begin time
C then include in 'edited_sweeps_list'
C 30000 is chosen so all the files from present flight are included
C in edited_sweeps_list, but those from a previous flight that started more
C than 30000 seconds before analysis start time are not.
c       WRITE(6,450)TIMEFILE,TIMEFILE2
        WRITE(FMT,600)LENGTH
 600     FORMAT('(A',I0,')')
c         WRITE(6,*)'FORMAT = ',FMT
c         WRITE(6,FMT)FILENAME
c         WRITE(6,FMT)FILENAMESAVE
         WRITE(82,FMT)FILENAMESAVE
c      ELSE
c      WRITE(6,450)TIMEFILE,TIMEFILE2
c      WRITE(6,460)TOTALSECONDS2,TOTALSECONDS3,DIFFSECONDS
c      WRITE(6,400)CDATELIST,FILENAMESAVE
 400  FORMAT('WRONG DATE,DATE IS ',A,' AND FILE NAME IS ',A)
 450  FORMAT('TIMES FROM JOBFILE AND FILE ARE ',I6,1X,I6)
 460  FORMAT('SECONDS FROM JOBFILE AND FILE ARE ',I12,1X,I12,1X,I12)
      ENDIF
 480  GO TO 1
 999  WRITE(FMT,500)LENGTH
 500  FORMAT('("FILENAME IS ",A',I0,')')
c      WRITE(6,*)'FORMAT = ',FMT
c      WRITE(6,FMT)FILENAME
      CLOSE(80)
      CLOSE(81)
      CLOSE(82)
      STOP
      END
      FUNCTION EPOCH_TIME(YYYY,MM,DD,H,M,S)RESULT(TOTALSECONDS)
      IMPLICIT NONE
      INTEGER(8) YYYY,MM,DD,H,M,S,TOTALSECONDS
      INTEGER(8) JULIAN
c      JULIAN=DD-32075+1416*(YYYY+4800+(MM-14)/12)4
c      WRITE(6,*)'YYYY,MM,DD = ',YYYY,MM,DD
c      WRITE(6,*)'H,M,S = ',H,M,S
      JULIAN=DD-32075+1461*(YYYY+4800+(MM-14)/12)/4
     1     +367*(MM-2-((MM-14)/12)*12)/12 -
     1     3*((YYYY+4900+(MM-14)/12)/100)/4
      JULIAN=JULIAN-2440588
c      WRITE(6,*)'JULIAN = ',JULIAN
      TOTALSECONDS=JULIAN*86400
      TOTALSECONDS=TOTALSECONDS+H*3600+M*60+S
      END FUNCTION EPOCH_TIME
      SUBROUTINE SYSOPCHANGE(RADARFILE,RADARFILEOUT)
C See comments in make_sweeps_list.f for a more complete explanation of
C     what is done here
      CHARACTER CWD*132,RADARFILE*132,RADARFILEOUT*132
      CHARACTER SYSOP*11,SYSOPREST*132
      CHARACTER*1 ONE(132),TWO(132),THREE(132)
      LOGICAL SYSOPCHANGEFILE
      INQUIRE(FILE='sysopchange',EXIST=SYSOPCHANGEFILE)
      IF(SYSOPCHANGEFILE)THEN
         OPEN(81,FILE='sysopchange')
         READ(81,'(A)')CWD
C      CALL GETCWD(CWD)
      ELSE
         RADARFILEOUT=RADARFILE
         RETURN
      ENDIF
c      WRITE(6,*)'CWD = ',CWD
      ILENPREFIX=LEN_TRIM(CWD)
c      WRITE(6,*)'ILENPREFIX = ',ILENPREFIX
      READ(CWD,'(132A1)')(ONE(I),I=1,ILENPREFIX)
      READ(RADARFILE,'(A11,A)')SYSOP,SYSOPREST
c      WRITE(6,'("SYSOP = ",A11)')SYSOP
c      ISYSOP=0
c      IF(SYSOP.EQ.'/home/sysop')ISYSOP=1
c      WRITE(6,*)'ISYSOP = ',ISYSOP
c      PAUSE
c      WRITE(6,'("SYSOPREST = ",A)')SYSOPREST
      NSLASH=0
      NCHAR=ILENPREFIX
      NSLASH=0
      READ(RADARFILE,'(132A1)')ONE
      DO I=1,132
         IF(ONE(I).EQ.'/')THEN
            NSLASH=NSLASH+1
            NCHAR2=NCHAR3
            NCHAR3=I
         ENDIF
      ENDDO
      SYSOPREST=' '
      WRITE(SYSOPREST,'(132A1)')(ONE(I),I=NCHAR2,132)
      ILENTRIM=LEN_TRIM(SYSOPREST)
      DO I=1,132
         TWO(I)=' '
      ENDDO
      READ(CWD,'(132A1)')(TWO(I),I=1,NCHAR)
      ISTART=NCHAR+1
      IEND=ISTART+ILENTRIM-1
      READ(SYSOPREST,'(132A1)')(TWO(I),I=ISTART,IEND)
      WRITE(RADARFILEOUT,'(132A1)')(TWO(I),I=1,IEND)
      RETURN
      END

