        SUBROUTINE FINDIDAYS(IDAYS,NAIRCRAFT,FLTNAME)
C
C A ROUTINE TO RETURN THE AIRCRAFT NUMBER, AND THE JULIAN DAY (DAYS SINCE
C JAN 1 1970) FROM THE FLIGHT ID (FLTNAME)
C THE PURPOSE OF THIS ROUTINE IS TO CHECK AND MAKE SURE THE DATA SET IS 
C IN AGREEMENT IN TIME WITH THE JOBFILE
C AND FOR THE CORRECT AIRCRAFT
C FLTNAME IS THE OLD NON-Y2K-COMPLIANT AOC FLIGHT ID WITHOUT FINAL 1 OR 2
        CHARACTER*7 FLTNAME
C CAIR = H,I, OR N FOR NOAA42, NOAA43, AND NOAA49 RESPECTIVELY
        CHARACTER CAIR*1
        INTEGER IMDAYS(11)
        READ(FLTNAME,'(3I2,A)')IYEAR,MONTH,IDAY,CAIR
        NAIRCRAFT=0
C DETERMINE THE AIRCRAFT NUMBER FROM THE 7TH CHARACTER OF THE FLIGHT ID
        IF(CAIR.EQ.'H'.OR.CAIR.EQ.'h')NAIRCRAFT=42
        IF(CAIR.EQ.'I'.OR.CAIR.EQ.'i')NAIRCRAFT=43
        WRITE(6,*)'IYEAR,MONTH,IDAY = ',IYEAR,MONTH,IDAY
C IYEAR FROM THE FLIGHT ID IS A TWO DIGIT NUMBER
C IF THE YEAR IS LESS THAN 60 THEN ADD 100 FOR Y2K
        IF(IYEAR.LT.70)IYEAR=IYEAR+100
C DETERMINE IF IYEAR IS A MULTIPLE OF 4 TO DETERMINE LEAP YEAR
        I4YEARS=IYEAR/4
        IREMYEARS=IYEAR-I4YEARS*4
        IADD=365*3+366
        IDAYS=I4YEARS*IADD+IREMYEARS*365+IDAY
C IF IREMYEARS IS ZERO THEN IT IS A LEAP YEAR
C 2000 WAS THE ONE OUT OF EVERY 400 YEARS WHERE THE LAST YEAR OF THE 
C CENTURY IS STILL A LEAP YEAR
        IF(IREMYEARS.NE.0)IDAYS=IDAYS+1
        IMDAYS(1)=31
        IF(IREMYEARS.EQ.0)THEN
         IMDAYS(2)=29
        ELSE
         IMDAYS(2)=28
        ENDIF
        IMDAYS(3)=31
        IMDAYS(4)=30
        IMDAYS(5)=31
        IMDAYS(6)=30
        IMDAYS(7)=31
        IMDAYS(8)=31
        IMDAYS(9)=30
        IMDAYS(10)=31
        IMDAYS(11)=30
        IF(MONTH.GT.1)THEN
         DO I=1,MONTH-1
          IDAYS=IDAYS+IMDAYS(I)
         ENDDO
        ENDIF
        RETURN
        END

