	subroutine look_tdr_hdr
     1          (airs_age_look,airs_pitch_temp,airs_drift_temp,
     1            airs_roll_temp,airs_heading_temp)
c load GIV  radar exended headr with info from 
c radar tape header in common blicks
C fragments for reading HRD tape or file
C mod 14 July 2011 to use flags in a new
C common block to decide whick vlues
C shoild be assigned to nav, etx.
C
C For each flaf,
C	1: use inertial values ( airs )
C	2: use GPS values
C	3: use AAMPS values
C
C Added test to try to detect crappy data. I look at the
C age varaibles and if they are older or weird, then all
C variables from that system are set to a bad_val.
C 8 August 2012
C
	common /hidden_hdr_flags/ nav_choice,
     +		alt_choice, attitude_choice, gdspd_choice,
     +		wind_choice
	integer*4 nav_choice,
     +		alt_choice, attitude_choice, gdspd_choice,
     +		wind_choice


C added tis to make latest external header avail to calling
C programs:
	include "TDR_hdr_common.f"
C and this include has all the RVP stuff:
	include "TDR_hdr_f90.h"
	TYPE (TDR_hdr) air_hdr

C
	include "hrd_radar_common_blocks.f"
C
	real  bad_nav
	integer time_max
	logical gps_good, airs_good, aamps_good,airs_good_temp
C
	time_max = 1000 ! 1 second
	bad_nav = -999.0
C load values from extendn header:
C
	airs_age_look = air_hdr%irs_age 
        write(6,*)'airs_age_look = ',airs_age_look
        if(airs_age_look.lt.0..or.airs_age_look.gt.time_max)then
         airs_good_temp=.false.
        else
         airs_good_temp=.true.
        endif
	if(airs_good_temp)then
	  airs_pitch_temp = bam16_TO_de g(air_hdr%irs_pitch)   
	  airs_roll_temp = bam16_TO_deg(air_hdr%irs_roll)      
	  airs_heading_temp = bam16_TO_deg(air_hdr%irs_heading)
	  airs_drift_temp = bam16_TO_deg(air_hdr%irs_drift)    
	  airs_tru_track_temp = bam16_TO_deg(air_hdr%irs_tru_track) 
	  airs_pitch_r_temp = bam16_TO_deg(air_hdr%irs_pitch_r)
	  airs_roll_r_temp = bam16_TO_deg(air_hdr%irs_roll_r)  
	  airs_yaw_r = bam16_TO_deg(air_hdr%irs_yaw_r)   
C
        else
	  airs_pitch_temp = -999.9
	  airs_roll_temp = -999.9
	  airs_heading_temp = -999.9
	  airs_drift_temp = -999.9
	  airs_tru_track_temp = -999.9
	  airs_pitch_r_temp = -999.9
	  airs_roll_r_temp = -999.9
	  airs_yaw_r = -999.9
        endif
        write(6,*)'lookhdr,pitch,roll,heading,drift = ',
     1             airs_pitch_temp,airs_roll_temp,airs_heading_temp,
     1             airs_drift_temp
        write(6,*)'airs_good_temp = ',airs_good_temp
	return
	end 
