      SUBROUTINE READWIND(U,V,W,IMX,JMX,KMX,SX,SY,SZ,
     1 OLAT,OLON,XZ,YZ,ZZ,IJKMX,ZLOW,ZHIGH,HB2,DPB2)
C 
      INTEGER IMX,JMX,KMX,KOUNT,NMOSM,IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3 
      REAL U(IJKMX),V(IJKMX),W(IJKMX)
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM(40)*56,OFILNAM*56
      CHARACTER TESTFILE*56,KEYWORDOUT*4,WINDFILE*80
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
C 
      WINDFILE='first_guess_fourier_xy.w'
      LULDPLN=99      
      write(6,*)'opening first_guess_fourier_xy file'
C 
      CALL READHEADERS(LULDPLN,WINDFILE,KEYWORD,FLTNAME,
     + STMNAME,RADAR,EXPERIMENT,
     + CREATIME,EXTRA1,IMX,JMX,KMX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     + SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     + POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)
C 
      WRITE(6,*)'EXTRA1,IMX,JMX,KMX,KOUNT,NMOSM,IUNFLD,IATTEN'
      WRITE(6,*)EXTRA1,IMX,JMX,KMX,KOUNT,NMOSM,IUNFLD,IATTEN
      WRITE(6,*)'EXTRA3,STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ'
      WRITE(6,*)EXTRA3,STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ
      WRITE(6,*)'SUBTRACT WIND FIELD FROM VR YES(1)/NO(0)?'
C 
      IUV=0
C 
      CALL LDPLN(LULDPLN,U,V,W,IMX,JMX,KMX,IUV,ZZ,SZ,
     1 ZLOW,ZHIGH,HB2,DPB2)
C 
      CLOSE(LULDPLN)
C 
      RETURN
      END
      SUBROUTINE READWIND3D(U,V,W,IMX,JMX,KMX,SX,SY,SZ,
     1 OLAT,OLON,XZ,YZ,ZZ,IJKMX,ZLOW,ZHIGH,HB2,DPB2,CARTFILENAME)
C 
      INTEGER IMX,JMX,KMX,KOUNT,NMOSM,IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3 
      REAL U(IJKMX),V(IJKMX),W(IJKMX)
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM(40)*56,OFILNAM*56
      CHARACTER TESTFILE*56,KEYWORDOUT*4,WINDFILE*80,CARTFILENAME*80
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
C 
      WINDFILE='3D.w'
      LULDPLN=99      
      write(6,*)'Opening Cartesian wind file'
C 
      CALL READHEADERS(LULDPLN,CARTFILENAME,KEYWORD,FLTNAME,
     + STMNAME,RADAR,EXPERIMENT,
     + CREATIME,EXTRA1,IMX,JMX,KMX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     + SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     + POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)
C 
      WRITE(6,*)'EXTRA1,IMX,JMX,KMX,KOUNT,NMOSM,IUNFLD,IATTEN'
      WRITE(6,*)EXTRA1,IMX,JMX,KMX,KOUNT,NMOSM,IUNFLD,IATTEN
      WRITE(6,*)'EXTRA3,STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ'
      WRITE(6,*)EXTRA3,STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ
      WRITE(6,*)'SUBTRACT WIND FIELD FROM VR YES(1)/NO(0)?'
C 
      IUV=0
C 
      CALL LDPLNNOVT(LULDPLN,U,V,W,IMX,JMX,KMX,IUV,ZZ,SZ,
     1 ZLOW,ZHIGH,HB2,DPB2)
C 
      CLOSE(LULDPLN)
C 
      RETURN
      END

