      SUBROUTINE SUBSTITUTE_NETCDF(DBZ,VEL,PAZM,AZIMUTH,
     +  OUTTIME,ORIGINAL_NUM_RAYS,OLD_RAY_TABLE,OUTFILENAME)
      USE NETCDF
      INCLUDE "hrd_radar_common_blocks.f"
      REAL DBZ(MAX_HRD_DIM,PETERS_MAX_RAYS)
      REAL AZ_EL(2,PETERS_MAX_RAYS)
      REAL VEL(MAX_HRD_DIM,PETERS_MAX_RAYS)
      REAL DBZINVERSE(MAX_HRD_DIM,PETERS_MAX_RAYS)
      REAL VELINVERSE(MAX_HRD_DIM,PETERS_MAX_RAYS)
      REAL RADIUS(MAX_HRD_DIM),RDFLAG,RYFLAG
      REAL OUTTIME(PETERS_MAX_RAYS),SHIFTER(PETERS_MAX_RAYS)
      REAL AZIMUTH(PETERS_MAX_RAYS),PAZM(PETERS_MAX_RAYS)
      REAL VALID_RANGE(2),VALID_RANGE_DBZ(2),VALID_MIN,VALID_MAX
      REAL VALID_MIN_DBZ,VALID_MAX_DBZ
      INTEGER ORIGINAL_NUM_RAYS,OLD_RAY_TABLE(PETERS_MAX_RAYS)
      CHARACTER*132 OUTFILENAME
      CHARACTER TESTMEOUT*10
      INTEGER NCID,IRADDIMID,IRAYDIMID,IDIMIDS(2)
      INTEGER IRAYVARID,IRADVARID,IDBZVARID,IVELVARID
      INTEGER ISTART(2),ICOUNT(2),ISTAT
      INTEGER IRAYNDIMID,IBINDIMID,ITVARID
      WRITE(6,*)'BEGINNING TO PROCESS A NETCDF FILE'
c      DO J=1,PETERS_MAX_RAYS
c         DO I=1,MAX_HRD_DIM
c            IF(VEL(I,J).LT.-800.)VEL(I,J)=-999.9
c         ENDDO
c      ENDDO
      WRITE(6,*)'OUTFILENAME'
      WRITE(6,*)OUTFILENAME
      WRITE(6,*)'SETTING UP AZIMUTH'
      WRITE(6,*)ORIGINAL_NUM_RAYS
      WRITE(6,*)'SETTING UP AZIMUTH AND ORIGINAL_NUM_RAYS = ',
     + ORIGINAL_NUM_RAYS
      DO I=1,ORIGINAL_NUM_RAYS
         IF(OLD_RAY_TABLE(I).LE.0.OR.OLD_RAY_TABLE(I).GT.500)THEN
            WRITE(6,*)'I,OLD_RAY_TABLE = ',I,OLD_RAY_TABLE(I)
         ENDIF
         SHIFTER(I)=AZIMUTH(OLD_RAY_TABLE(I))
      ENDDO
      DO I=1,ORIGINAL_NUM_RAYS
         AZIMUTH(I)=SHIFTER(I)
      ENDDO
      DO I=1,ORIGINAL_NUM_RAYS
         SHIFTER(I)=PAZM(OLD_RAY_TABLE(I))
      ENDDO
      DO I=1,ORIGINAL_NUM_RAYS
         PAZM(I)=SHIFTER(I)
      ENDDO
      DO I=1,ORIGINAL_NUM_RAYS
         SHIFTER(I)=OUTTIME(OLD_RAY_TABLE(I))
      ENDDO
      DO I=1,ORIGINAL_NUM_RAYS
         OUTTIME(I)=SHIFTER(I)
      ENDDO
      WRITE(6,*)'PAZM'
      WRITE(6,'(10F8.2)')(PAZM(I),I=1,ORIGINAL_NUM_RAYS)
      WRITE(6,*)'AZIMUTH'
      WRITE(6,'(10F8.2)')(AZIMUTH(I),I=1,ORIGINAL_NUM_RAYS)
      WRITE(6,*)'OUTTIME'
      WRITE(6,'(10F12.5)')(OUTTIME(I),I=1,ORIGINAL_NUM_RAYS)
      PAUSE
      RETURN
      END
      SUBROUTINE D1DZ(DBZ,DBZINVERSE,ORIGINAL_NUM_RAYS)
      INCLUDE "hrd_radar_common_blocks.f"
      INTEGER ORIGINAL_NUM_RAYS
      REAL DBZ(MAX_HRD_DIM,PETERS_MAX_RAYS)
      REAL DBZINVERSE(ORIGINAL_NUM_RAYS,NBINS)
      DO I=1,NBINS
         DO J=1,ORIGINAL_NUM_RAYS
            DBZINVERSE(J,I)=DBZ(I,J)
         ENDDO
      ENDDO
      RETURN
      END
      
         
