      PROGRAM TEST_END
      CHARACTER*132 JOBFILE,SWEEPS_LIST,DUMMY
      CHARACTER*200 SOUT,SCRIPTDIR
      CHARACTER*300 S(200)
      CHARACTER*1 BOTHAFTFORE
      CHARACTER DIRECTORY*132,FORMATFILE*132,DIRECTORY2*132,RADAR*3
      INTEGER(8) YYYY,IMJ,IDJ,IHE,IME,ISE,ENDSECONDS,FILESECONDS
      INTEGER(8) EPOCH_TIME,IMO,ID,IH,IM,IS,AFTSECONDS,FORESECONDS
      CALL GETARG(1,BOTHAFTFORE)
      CALL GETARG(2,SCRIPTDIR)
      OPEN(80,FILE='jobfile_radar')
      IAFT=0
      IFORE=0
      AFTSECONDS=0
      FORESECONDS=0
      READ(80,'(3I2)')IYJ,IMJ,IDJ
      READ(80,'(A)')DUMMY
C IHB, IMB, ISB are the hours minutes and seconds of the beginning time of 
C     3D analysis
C IHE, IME, ISE are the hours minutes and seconds of the end time of 3D analysis
      READ(80,'(3I2,X,3I2)')IHB,IMB,ISB,IHE,IME,ISE
      IF(IYJ.LT.50)THEN
         YYYY=2000+IYJ
      ELSE
         YYYY=1900+IYJ
      ENDIF
C ENDSECONDS IS THE EPOCH TIME OF THE END OF THE 3D analysis
      ENDSECONDS=EPOCH_TIME(YYYY,IMJ,IDJ,IHE,IME,ISE)
      WRITE(6,'(I10)')ENDSECONDS
      DO I=1,20
         READ(80,'(A)')DUMMY
      ENDDO
C DIRECTORY is the location of the sweep data in the jobfile
C DIRECTORY2 is the location of the sweep data after employing information
C     in sysopchange that shows the parent directory to the subdirectory
C     containing the sweep data
C sysopchange allows a jobfile to be used without modification of 
C sweep files directory
      READ(80,'(A)')DIRECTORY
      CALL SYSOPCHANGE(DIRECTORY,DIRECTORY2)
      DIRECTORY=DIRECTORY2
      NC=LEN(TRIM(DIRECTORY))
      WRITE(6,'("NC = ",I3)')NC
      CLOSE(80)
      WRITE(FORMATFILE,100)NC
 100  FORMAT("(A",I2,",A3,6I2)")
      WRITE(6,'(A)')FORMATFILE
      OPEN(80,FILE='sweeps_list')
      IF(BOTHAFTFORE.EQ.'a')FORESECONDS=2100000000
      IF(BOTHAFTFORE.EQ.'f')AFTSECONDS=2100000000
C The next lines are for writing to an xchat channel, in this case
C     the #hrd-status channel
       S(1)=SCRIPTDIR
       S(2)='/hrd-sendto-chat.sh'
       S(3)=' '
       S(4)='checking whether files extend beyond job end time'
       NS=4
       CALL WRITECONNECTEDSTRINGS(S,NS,SOUT)
       CALL EXECUTE_COMMAND_LINE(SOUT)
c      CALL EXECUTE_COMMAND_LINE("hrd-sendto-chat.sh
c     +    'checking whether files extend beyond job end time'")
C Read file names until bore fore and aft files times are beyond job end time
      DO WHILE(AFTSECONDS.LT.ENDSECONDS.OR.FORESECONDS.LT.ENDSECONDS)
         WRITE(6,*)'AFTSECONDS,FORESECONDS,ENDSECONDS = ',
     +              AFTSECONDS,FORESECONDS,ENDSECONDS
C Read next line in sweeps_list file
         READ(80,FORMATFILE,END=999)DIRECTORY2,RADAR,IY,IMO,ID,IH,IM,IS
C         WRITE(6,200)RADAR,IY,IMO,ID,IH,IM,IS
         IF(IYJ.LT.50)THEN
            YYYY=2000+IY
         ELSE
            YYYY=1900+IY
         ENDIF
C FILESECONDS is epoch time of the file name just read from sweeps_list
         FILESECONDS=EPOCH_TIME(YYYY,IMO,ID,IH,IM,IS)
         WRITE(6,*)'RADAR,FILESECONDS = ',RADAR,FILESECONDS
C determine from variable RADAR whether names file is an aft or fore file
         IF(RADAR.EQ.'2TA'.OR.RADAR.EQ.'3TA')THEN
C from when fore and aft sweeps were read consecutively from the file nanme
            FORESECONDS=FILESECONDS
            AFTSECONDS=FILESECONDS
         ELSEIF(RADAR.EQ.'2TM'.OR.RADAR.EQ.'3TM'.OR.RADAR.EQ.'nrm')THEN
C when files are separate and the file is a fore file
            FORESECONDS=FILESECONDS
         ELSEIF(RADAR.EQ.'2TS'.OR.RADAR.EQ.'3TS'.OR.RADAR.EQ.'nrs')THEN
C when files are separate and the file is an aft file
            AFTSECONDS=FILESECONDS
         ENDIF
C If only fore or aft files are being read then the time for the other
C type of file is set to a very high value beyond the end of the analysis time
         IF(BOTHAFTFORE.EQ.'a')FORESECONDS=2100000000
         IF(BOTHAFTFORE.EQ.'f')AFTSECONDS=2100000000
         WRITE(6,*)'ENDSECONDS,AFTSECONDS,FORESECONDS = ',
     +              ENDSECONDS,AFTSECONDS,FORESECONDS
      ENDDO
      WRITE(6,*)'I GOT HERE'
      CLOSE(80)
C The writing of last_sweep_satisfied file indicates both fore and aft file
C     times are from beyond the analysis end time
      OPEN(81,FILE='last_sweep_satisfied')
      WRITE(81,*)'sweeps exist beyond end time'
      WRITE(6,*)'fore and aft sweeps exist beyond end time'
c      CALL EXECUTE_COMMAND_LINE
c     + ("bin/hrd-sendto-chat.sh
c     +  'fore and aft sweeps exist beyond end time'")
      WRITE(6,*)'counting 10 seconds and starting job'
c      CALL EXECUTE_COMMAND_LINE
c     + ("bin/hrd-sendto-chat.sh
c     + 'counting 10 seconds and starting job'")
      CLOSE(81)
      STOP
 200  FORMAT(A3,X,6I3)
 999  CLOSE(80)
C if either fore or aft file times do not extend beyond analysis end time, 
C     then end program without writing last_file_satisfied, so the ja 
C     script file loop will execute again
      WRITE(6,*)'BOTHAFTFORE = ',BOTHAFTFORE
      IF(AFTSECONDS.LT.ENDSECONDS.AND.BOTHAFTFORE.NE.'a')THEN
         WRITE(6,*)'SLAVE FILES DO NOT EXIST PAST JOB END'
C Write to #hrd-status that slave files do not exist beyond job end
       S(1)=SCRIPTDIR
       S(2)='/hrd-sendto-chat.sh'
       S(3)=' '
       S(4)='Slave files do not exist past job end'
       NS=4
C WRITECONNECTEDSTRINGS WRITES THE STRING FOR THE SYSTEM COMMAND
       CALL WRITECONNECTEDSTRINGS(S,NS,SOUT)
C SYSTEM COMMAND TO WRITE TO XCHAT #HRD-STATUS CHANNEL
       CALL EXECUTE_COMMAND_LINE(SOUT)
c         CALL EXECUTE_COMMAND_LINE
c     + ("bin/hrd-sendto-chat.sh
c     +  'Slave files do not exist past job end'")
      ENDIF
      IF(FORESECONDS.LT.ENDSECONDS.AND.BOTHAFTFORE.NE.'f')THEN
         WRITE(6,*)'MASTER FILES DO NOT EXIST PAST JOB END'
C Write to #hrd-status that master files do not exist beyond job end
       S(4)='Master files do not exist past job end'
       NS=4
       CALL WRITECONNECTEDSTRINGS(S,NS,SOUT)
       CALL EXECUTE_COMMAND_LINE(SOUT)
C         CALL EXECUTE_COMMAND_LINE
C     + ("bin/hrd-sendto-chat.sh
C     +  'Master slave files do not exist past job end'")
      ENDIF
      STOP
      END
      FUNCTION EPOCH_TIME(YYYY,MM,DD,H,M,S)RESULT(TOTALSECONDS)
C function to compute the epoch time (seconds past 0000 UTC Jan 1 1970
      IMPLICIT NONE
      INTEGER(8) YYYY,MM,DD,H,M,S,TOTALSECONDS
      INTEGER(8) JULIAN
c      JULIAN=DD-32075+1416*(YYYY+4800+(MM-14)/12)4
c      WRITE(6,*)'YYYY,MM,DD = ',YYYY,MM,DD
c      WRITE(6,*)'H,M,S = ',H,M,S
      JULIAN=DD-32075+1461*(YYYY+4800+(MM-14)/12)/4
     1     +367*(MM-2-((MM-14)/12)*12)/12 -
     1     3*((YYYY+4900+(MM-14)/12)/100)/4
      JULIAN=JULIAN-2440588
c      WRITE(6,*)'JULIAN = ',JULIAN
      TOTALSECONDS=JULIAN*86400
      TOTALSECONDS=TOTALSECONDS+H*3600+M*60+S
      END FUNCTION EPOCH_TIME
      SUBROUTINE SYSOPCHANGE(RADARFILE,RADARFILEOUT)
C REFER TO SAME ROUTINE IN 'make_sweeps_list.f' to SEE COMMENTS
      CHARACTER CWD*132,RADARFILE*132,RADARFILEOUT*132
      CHARACTER SYSOP*11,SYSOPREST*132
      CHARACTER*1 ONE(132),TWO(132),THREE(132)
      LOGICAL SYSOPCHANGEFILE
      INQUIRE(FILE='sysopchange',EXIST=SYSOPCHANGEFILE)
      IF(SYSOPCHANGEFILE)THEN
         OPEN(81,FILE='sysopchange')
         READ(81,'(A)')CWD
C      CALL GETCWD(CWD)
      ELSE
         RADARFILEOUT=RADARFILE
         RETURN
      ENDIF
c      WRITE(6,*)'CWD = ',CWD
      ILENPREFIX=LEN_TRIM(CWD)
c      WRITE(6,*)'ILENPREFIX = ',ILENPREFIX
      READ(CWD,'(132A1)')(ONE(I),I=1,ILENPREFIX)
      READ(RADARFILE,'(A11,A)')SYSOP,SYSOPREST
c      WRITE(6,'("SYSOP = ",A11)')SYSOP
c      ISYSOP=0
c      IF(SYSOP.EQ.'/home/sysop')ISYSOP=1
c      WRITE(6,*)'ISYSOP = ',ISYSOP
c      PAUSE
c      WRITE(6,'("SYSOPREST = ",A)')SYSOPREST
      NSLASH=0
      NCHAR=ILENPREFIX
      NSLASH=0
      READ(RADARFILE,'(132A1)')ONE
      DO I=1,132
         IF(ONE(I).EQ.'/')THEN
            NSLASH=NSLASH+1
            NCHAR2=NCHAR3
            NCHAR3=I
         ENDIF
      ENDDO
      SYSOPREST=' '
      WRITE(SYSOPREST,'(132A1)')(ONE(I),I=NCHAR2,132)
      ILENTRIM=LEN_TRIM(SYSOPREST)
      DO I=1,132
         TWO(I)=' '
      ENDDO
      READ(CWD,'(132A1)')(TWO(I),I=1,NCHAR)
      ISTART=NCHAR+1
      IEND=ISTART+ILENTRIM-1
      READ(SYSOPREST,'(132A1)')(TWO(I),I=ISTART,IEND)
      WRITE(RADARFILEOUT,'(132A1)')(TWO(I),I=1,IEND)
      RETURN
      END
      SUBROUTINE WRITECONNECTEDSTRINGS(S,NS,SOUT)
C PROGRAM TO CONCATENATE NS STRINGS TOGETHER AND WRITE TO SOUT
C NS IS THE NUMBER OF STRINGS TO CONCATENTATE
      CHARACTER*300 S(200),CATSTRING,CATSTRINGBEFORE
      CHARACTER*200 SOUT
      CHARACTER*400 PRINTSTRING
      INTEGER I4(200)
      DO I=1,NS
         I4(I)=LEN_TRIM(S(I))
         IF(I4(I).EQ.0)I4(I)=1
      ENDDO
      CATSTRING=''
      CATSTRINGBEFORE=''
c      WRITE(6,*)'I4 = ',(I4(I),I=1,NS)
c      DO I=1,NS
c         WRITE(6,*)'S = ',S(I)
c      ENDDO
      DO I=1,NS
         ICAT=LEN_TRIM(CATSTRINGBEFORE)
         IF(I.GT.1.AND.S(I-1).EQ.' ')ICAT=ICAT+1
C DETERMINE THE PROPER FORMAT TO WRITE OUT THE CONCATENATED STRING
         IF(ICAT.GT.0)THEN
            IF(ICAT.GE.100.AND.I4(I).GE.10)THEN
               WRITE(PRINTSTRING,91),ICAT,I4(I)
 91            FORMAT("(A",I3,",A",I2,")")
            ELSEIF(ICAT.GE.100.AND.I4(I).LT.10)THEN
               WRITE(PRINTSTRING,92),ICAT,I4(I)
 92            FORMAT("(A",I3,",A",I1,")")
            ELSEIF(ICAT.GE.10.AND.I4(I).GE.10)THEN
               WRITE(PRINTSTRING,101)ICAT,I4(I)
 101           FORMAT("(A",I2,",A",I2,")")
            ELSEIF(ICAT.GE.10.AND.I4(I).LT.10)THEN
               WRITE(PRINTSTRING,102)ICAT,I4(I)
 102           FORMAT("(A",I2,",A",I1,")")
            ELSEIF(ICAT.LT.10.AND.I4(I).GE.10)THEN
               WRITE(PRINTSTRING,103)ICAT,I4(I)
 103           FORMAT("(A",I1,",A",I2,")")
            ELSEIF(ICAT.LT.10.AND.I4(I).LT.10)THEN
               WRITE(PRINTSTRING,104)ICAT,I4(I)
 104           FORMAT("(A",I1,",A",I1,")")
            ENDIF
c            WRITE(6,*)PRINTSTRING
c            WRITE(6,PRINTSTRING)CATSTRINGBEFORE,S(I)
C PRINTSTRING IS A FORMAT FOR WRITING CATSTRING
            WRITE(CATSTRING,PRINTSTRING)CATSTRINGBEFORE,S(I)
         ELSE
            IF(I4(I).GE.10)THEN
               WRITE(PRINTSTRING,105)I4(I)
 105           FORMAT("(A",I2,")")
            ELSE
               WRITE(PRINTSTRING,106)I4(I)
 106           FORMAT("(A",I1,")")
            ENDIF
            WRITE(CATSTRING,PRINTSTRING)S(I)
c            WRITE(6,PRINTSTRING)S(I)
         ENDIF
         CATSTRINGBEFORE=CATSTRING
      ENDDO
      ICAT=LEN_TRIM(CATSTRING)
      IF(ICAT.GE.100)THEN
         WRITE(PRINTSTRING,207),ICAT
 207     FORMAT("(A",I3,")")
      ELSEIF(ICAT.GE.10)THEN
         WRITE(PRINTSTRING,107)ICAT
 107     FORMAT("(A",I2,")")
      ELSE
         WRITE(PRINTSTRING,108)ICAT
 108     FORMAT("(A",I1,")")
      ENDIF
c      WRITE(6,*)'THE STRING IS'
c      WRITE(6,PRINTSTRING)CATSTRING
c      WRITE(6,*)'STRING FINISHED'
      WRITE(SOUT,PRINTSTRING)CATSTRING
c      PAUSE
      RETURN
      END

      
