      SUBROUTINE ABCD(U,V,W,
     1   RHMAX,RZMAXIN,EHMAX,EZMAX,XACC,YACC,ZACC,NF,NFILE,
     2   SUM1,SUM2,SUM3,SUM4,SUM5,SUM6,SUM7,SUM8,SUM9,
     2   SUM10,SUM11,SUM12,SUM13,EVRCOR,
     3   SUMWEIGHT,TOLERANCE,KMIN2,KMAX2,
     4   SINTOL,SXB,SYB,SZB,XZB,YZB,ZZB,
     5   ROTB,IMAXB,JMAXB,KMAXB,SUMDBZ,
     6   BETATEST,SUMWTSAVE,XWSAVE,YWSAVE,ZWSAVE,UNEW,IGUESS,FACTR,
     7   ICONTINUITY,IVWIND,FACTZ,IREADABCD,OLAT,OLON,LUSCAN,
     9   IRSW,HB1,DPB1,HB2,DPB2,SLOPE1,IFFILTER,CENTIME,TSTART,TEND,
     1   SMOTIONU,SMOTIONV,FLIGHTID,RDEL,DBZTEST,RRRR,ZLOW,ZHIGH,INDEX1,
     1   UG,VG,WG,IREVERSE,IRAMSFILES,XSHIFT,YSHIFT,IECHO,
     1   DISTXYZ,CHARV,CHARDBZ,LINUXYES,IW0,ICRESS,TATF,
     1   RXMAX,RYMAX,EXMAX,EYMAX,RADIUS2,THETA2,
     1   IGRAPHICS,IPLANE,IVARIATIONAL,IAFTFORE,ISIGMET,IREALTIME,
     1   ROLLTOL)
C     1   IBINS)
      include "hrd_radar_settings.f"
      REAL THETA2(IMAXB,JMAXB,KMAXB),RADIUS2(IMAXB,JMAXB,KMAXB)
      PARAMETER(MAX_X=750,MAX_Y=250)
      CHARACTER FLIGHTID*8, CHARV*2, CHARDBZ*2
      CHARACTER DISPLAY_LABEL*32,WINDOW_LABEL*28
      CHARACTER DISPLAY_LABELZ*32,WINDOW_LABELZ*18
      CHARACTER CHARTIME*6,CHARTIMEMIN*6,CHARTIMEMAX*6
      CHARACTER CHARAFTFORE*5
      INTEGER RAW_WINDOW(100),RAWZ_WINDOW(100)
      INTEGER*2 DBZ_INT(MAX_X,MAX_Y)
      INTEGER WINDOWERROR
      INTEGER DATA_TYPE
      REAL GTLENGTH(MAX_HRD_DIM)
      REAL SLOPETESTSUM(2)
      REAL SUMWTSAVE(IMAXB,JMAXB,KMAXB,2),ANGTESTSUM(2)
      REAL XWSAVE(IMAXB,JMAXB,KMAXB,2)
      REAL YWSAVE(IMAXB,JMAXB,KMAXB,2),ZWSAVE(IMAXB,JMAXB,KMAXB,2)
c      REAL UMASK(IMAXB,JMAXB,KMAXB),VMASK(IMAXB,JMAXB,KMAXB)
c      REAL WMASK(IMAXB,JMAXB,KMAXB)
      REAL U(IMAXB,JMAXB,KMAXB,2),V(IMAXB,JMAXB,KMAXB,2)
      REAL W(IMAXB,JMAXB,KMAXB,2),SUMDBZ(IMAXB,JMAXB,KMAXB,2)
      REAL VR(MAX_HRD_DIM),RANGE(MAX_HRD_DIM),DBZ(MAX_HRD_DIM)
      REAL XR(MAX_HRD_DIM),YR(MAX_HRD_DIM),ZR(MAX_HRD_DIM)
      REAL SUM1(IMAXB,JMAXB,KMAXB,2),SUM2(IMAXB,JMAXB,KMAXB,2)
      REAL SUM3(IMAXB,JMAXB,KMAXB,2),SUM4(IMAXB,JMAXB,KMAXB,2)
      REAL SUM5(IMAXB,JMAXB,KMAXB,2),SUM6(IMAXB,JMAXB,KMAXB,2)
      REAL SUM7(IMAXB,JMAXB,KMAXB,2),SUM8(IMAXB,JMAXB,KMAXB,2)
      REAL SUM9(IMAXB,JMAXB,KMAXB,2),SUM10(IMAXB,JMAXB,KMAXB,2)
      REAL SUM11(IMAXB,JMAXB,KMAXB,2),SUM12(IMAXB,JMAXB,KMAXB,2)
      REAL SUM13(IMAXB,JMAXB,KMAXB,2)
      REAL RHOK(100),WGT(200)
      REAL DISTXYZ(IMAXB,JMAXB,KMAXB,2,2,2,2)
      REAL VRSWP(MAX_HRD_DIM,800),REFSWP(MAX_HRD_DIM,800)
      REAL VRSWP1(MAX_HRD_DIM,800),REFSWP1(MAX_HRD_DIM,800)
      REAL VRRAD(MAX_HRD_DIM,800)
      REAL RDTAI(MAX_HRD_DIM),AZ_EL(2,800),EAZM(800),EEV(800)
      REAL VNYQ(MAX_HRD_DIM,800),PELEV(800)
      REAL UG(IMAXB,JMAXB,KMAXB),VG(IMAXB,JMAXB,KMAXB)
      REAL WG(IMAXB,JMAXB,KMAXB)
      INTEGER JINDEX(MAX_HRD_DIM,800),JIINDEX(MAX_HRD_DIM,800)
      REAL TMP1(MAX_HRD_DIM,800),TMP2(MAX_HRD_DIM,800)
      REAL UNFVEL(MAX_HRD_DIM,800)
      REAL SWEEPSAVE(MAX_HRD_DIM,800)
      REAL TMSWEEP(800),RRLAT(800),RRLON(800),RRA(800)
      REAL SUMMER(200,200,100,2)
      CHARACTER*2 TATF(80),TAF
      INTEGER INDEX1(IMAXB,JMAXB,KMAXB,2),NUMANGTEST(2)
      INTEGER NUMSLOPETEST(2),IAZM(800)
      INTEGER NS(3)
      REAL XSHIFT(80),YSHIFT(80)
      FLAG=-1.0E+10
      IF(IGRAPHICS.EQ.1)THEN
       ILOG_LU=6
       WINDOW_LABEL='cleaned up radial velocities'
       WINDOW_LABELZ='reflectivity (dBZ)'
       CALL RASX_OPEN_WINDOW(RAW_WINDOW,WINDOWERROR,
     +  WINDOW_LABEL)
       CALL RASX_OPEN_WINDOW(RAWZ_WINDOW,WINDOWERROR,
     +  WINDOW_LABELZ)
      ENDIF
      IUSEWIND=IGUESS
      IF(IUSEWIND.EQ.1)THEN
       IJKMX=IMAXB*JMAXB*KMAXB
       WRITE(6,*)'ZLOW,ZHIGH,HB2,DPB2 = ',ZLOW,ZHIGH,HB2,DPB2
c       PAUSE
       CALL READWIND(UG,VG,WG,IMXG,JMXG,KMXG,SXG,SYG,SZG,
     + OLATG,OLONG,XZG,YZG,ZZG,IJKMX,ZLOW,ZHIGH,HB2,DPB2)
       IF(IMXG.NE.IMAXB.OR.JMXG.NE.JMAXB.OR.KMXG.NE.KMAXB)THEN
        WRITE(6,*)'IMXG,IMAXB = ',IMXG,IMAXB
        WRITE(6,*)'JMXG,JMAXB = ',JMXG,JMAXB
        WRITE(6,*)'KMXG,KMAXB = ',KMXG,KMAXB
        WRITE(6,*)'SINCE MASKING IS DONE WITH GUESS FIELD'
        WRITE(6,*)'AND FIELDS DONT MATCH I AM SUSPENDING'
        PAUSE
       ENDIF
       BEAMWR=2.*3.14159/180.
       IMXG=IMAXB
       JMXG=JMAXB
       KMXG=KMAXB
       SXG=SXB
       SYG=SYB
       SZG=SZB
       OLATG=OLAT
       OLONG=OLON
       XZG=XZB
       YZG=YZB
       ZZG=ZZB
      ELSE
       IMXG=IMAXB
       JMXG=JMAXB
       KMXG=KMAXB
       SXG=SXB
       SYG=SYB
       SZG=SZB
       OLATG=OLAT
       OLONG=OLON
       XZG=XZB
       YZG=YZB
       ZZG=ZZB
      ENDIF
c      WRITE(6,*)'CALLING WRITEU,IMXG,JMXG,KMXG = ',IMXG,JMXG,KMXG
c      CALL WRITEU(UG,IMXG,JMXG,KMXG)
c      WRITE(6,*)'RETURNED FROM WRITEU,IMXG,JMXG,KMXG = ',
c     1   IMXG,JMXG,KMXG
      IERR=0
      MAX_GATES=MAX_HRD_DIM
      MAX_RAYS=800
      MDIM=IMAXB*JMAXB*KMAXB
      WRITE(6,'(A2)')CHARV
      WRITE(6,'(A2)')CHARDBZ
      WRITE(6,*)'MDIM = IMAXB*JMAXB*KMAXB = ',MDIM
c      PAUSE
      PI=2.*ASIN(1.)
      WRITE(6,*)'A'
c      PAUSE
      PI2=2.*PI
      DTR=PI/180.
      ICRESS=0
      ISCANDIM=MAX_HRD_DIM
c      ISCANMAX=128
C      ISCANDIM=256
      IBINS=7
      SXB2=.5*SXB*SXB
      SYB2=.5*SYB*SYB
      SZB2=.5*SZB*SZB
      JBINS=3*IBINS+1
c      ZZB=0.
      RDEL=0.
      WRITE(6,*)'B'
c      PAUSE
      DO K=1,KMAXB
       DO J=1,JMAXB
        DO I=1,IMAXB
c         write(6,*)'C',I,J,K
         RADIUS2(I,J,K)=FLAG
         THETA2(I,J,K)=FLAG
        ENDDO
       ENDDO
      ENDDO
      WRITE(6,*)'ONE'
c      PAUSE
      DO L=1,2
       DO K=1,KMAXB
        DO J=1,JMAXB
         DO I=1,IMAXB
          DO KK=1,2
           DO JJ=1,2
            DO II=1,2
             DISTXYZ(I,J,K,L,II,JJ,KK)=1000.
C             YDIST(I,J,K,II,JJ,KK)=1000.
C             ZDIST(I,J,K,II,JJ,KK)=1000.
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      DO I=1,JBINS
       RATIOI=(FLOAT(I)/FLOAT(IBINS))**2.
       WGT(I)=EXP(-RATIOI)
      ENDDO
      DO K=1,KMAXB
       HEIGHT=ZZB+(K-1)*SZB
       RHOK(K)=EXP(-HEIGHT*.10437052)
      ENDDO
      ZTOP=(KMAXB-1)*SZB
      RLZ=ZTOP
      RLH=25.*SXB
      UBAR=10.
      DO I=1,256
       A=I
       RANGE(I)=A
       VR(I)=-A
       DBZ(I)=A*2.
      ENDDO
      write(6,*)'entered abcd'
      NS(1)=0
      NS(2)=0
      NS(3)=1
      NSTEP=2
      NSTEP2=1
      MDIM2=IMAXB*JMAXB
      WRITE(6,*)'IMAXB,JMAXB,KMAXB,SXB,SYB,SZB,ROTB'
      WRITE(6,*)IMAXB,JMAXB,KMAXB,SXB,SYB,SZB,ROTB
      WRITE(6,*)'Entered ABCD'
      RXWEIGHT=EXMAX*EXMAX
      RYWEIGHT=EYMAX*EYMAX
      RHWEIGHT=EHMAX*EHMAX
      RZWEIGHT=EZMAX*EZMAX
      RXMAX=RHMAX
      RYMAX=RHMAX
      RZMAX=RZMAXIN
      WRITE(6,*)'EHMAX,EZMAX,RXMAX,RYMAX,RZMAX'
      WRITE(6,*)EHMAX,EZMAX,RXMAX,RYMAX,RZMAX    
      WRITE(6,*)'XACC = ',XACC
      WRITE(6,*)'YACC = ',YACC
      WRITE(6,*)'ZACC = ',ZACC
      TIMER=0.
c      WRITE(6,*)'AFTER ENTERING ABCD, FACTZ,FACTR = ',FACTZ,FACTR
C      IF(IGUESS.NE.1
C     + .AND.IREADABCD.NE.1)THEN
      IF(IREADABCD.NE.1)THEN
       DO L=1,2
        DO KK=KMIN2,KMAX2
         DO JJ=1,JMAXB
          DO II=1,IMAXB
C
C First call to ABCD:  zero all angle-projection summations
C
           SUMMER(II,JJ,KK,L)=0
           SUMDBZ(II,JJ,KK,L)=0
           SUMWTSAVE(II,JJ,KK,L)=0
           SUM1(II,JJ,KK,L)=0
           SUM2(II,JJ,KK,L)=0
           SUM3(II,JJ,KK,L)=0
           SUM4(II,JJ,KK,L)=0
           SUM5(II,JJ,KK,L)=0
           SUM6(II,JJ,KK,L)=0
           SUM7(II,JJ,KK,L)=0
           SUM8(II,JJ,KK,L)=0
           SUM9(II,JJ,KK,L)=0
           SUM10(II,JJ,KK,L)=0
           SUM11(II,JJ,KK,L)=0
           SUM12(II,JJ,KK,L)=0
           SUM13(II,JJ,KK,L)=0
           XWSAVE(II,JJ,KK,L)=0
           YWSAVE(II,JJ,KK,L)=0
           ZWSAVE(II,JJ,KK,L)=0
           INDEX1(II,JJ,KK,L)=0
C
C If w found during first iteration, set to zero to begin second iteration
C
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF
c5556  OPEN(103,FILE='/hrd/dat/gustav/tracking/insideabcd')
c      WRITE(103,*)'AT STATEMENT 5556--NF=',NF
c      CLOSE(103)
      NRECORD=1
      RLATBEFORE=0.
      IBEGIN=0
      ICLSWP=0
      DO L2=1,2
       NUMANGTEST(L2)=0
       ANGTESTSUM(L2)=0
       ANGTEST=-999.9
       GROUNDSLOPE=-999.9
       NUMSLOPETEST(L2)=0
       SLOPETESTSUM(L2)=0.
      ENDDO
      IF(IREADABCD.EQ.1)GO TO 72735
c92923 CALL SCANNER(TIMES,RLAT,RLON,ELEV,AZIM,DBZ,VR,RANGE,RALT)
c92923 READ(LUSCAN)TIMES,RLAT,RLON,ELEV,AZIM,DBZ,VR,RANGE,RALT
c      write(6,*)'calling readuf_disc'
92923 TAF=TATF(NF)
c      WRITE(6,*)'CALLING SWEEPIN'
c      write(6,*)'iusewind = ',iusewind
c      write(6,*)'rolltol = ',rolltol
      CALL SWEEPIN(VRSWP,REFSWP,MAX_RAYS,MAX_GATES,NUM_RAYS,RDTAI,
     + AZ_EL,ICLSWP,NRECORD,VRRAD,UNFVEL,TMP1,TMP2,JINDEX,
     + JIINDEX,VNYQ,ILATERSWEEP,SWEEPSAVE,UG,VG,WG,
     + IMXG,JMXG,KMXG,SXG,SYG,SZG,OLATG,OLONG,XZG,YZG,ZZG,
     + IUSEWIND,EAZM,EEV,TMSWEEP,RRLAT,RRLON,RRA,SMOTIONU,SMOTIONV,
     + CENTIME,PELEV,ISCANMAX,ANGTEST,GROUNDSLOPE,IAZM,
     + IPLANE,IVARIATIONAL,IAFTFORE,ISIGMET,IREALTIME,ROLLTOL)
c       write(6,*)'returned from sweepin'
c       write(6,*)'times = ',times
       write(6,*)'num_rays,times,tend = ',num_rays,times,tend
       IF(NUM_RAYS.LE.1)GO TO 92923
       TIMES=TMSWEEP(1)
       IF(NUM_RAYS.LE.1.AND.TIMES.LT.TEND)GO TO 92923
c       WRITE(6,*)'ISCANMAX = ',ISCANMAX
c       WRITE(6,*)'RDTAI = '
c       WRITE(6,'(10F8.2)')(RDTAI(I),I=1,ISCANMAX)
c       WRITE(6,*)TMSWEEP(1)
c       write(6,*)'num_rays = ',num_rays
c       WRITE(6,*)'REF AT 5 = '
c       WRITE(6,591)(REFSWP(5,J),J=1,NUM_RAYS)
c 591   FORMAT(15F9.2)
c       WRITE(6,*)'VR AT 5 = '
c       WRITE(6,591)(VRSWP(5,J),J=1,NUM_RAYS)
c       WRITE(6,*)'REF AT 5 = '
c       WRITE(6,591)(REFSWP(5,J),J=1,NUM_RAYS)
c       WRITE(6,*)'VR AT 5 = '
c       WRITE(6,591)(VRSWP(5,J),J=1,NUM_RAYS)
c       WRITE(6,*)'TMSWEEP(J) = '
c       WRITE(6,591)(TMSWEEP(J),J=1,NUM_RAYS)
c       WRITE(6,*)'AZ_EL(1,J) = '
c       WRITE(6,591)(AZ_EL(1,J),J=1,NUM_RAYS)
c       WRITE(6,*)'AZ_EL(2,J) = '
c       WRITE(6,591)(AZ_EL(2,J),J=1,NUM_RAYS)
c       DO J=1,NUM_RAYS
c        WRITE(6,*)"VRSWP,TMSWEEP,PELEV,EEV,EAZM, J = ",J,
c     1    TMSWEEP(J),AZ_EL(1,J),AZ_EL(2,J),PELEV(J),EEV(J),EAZM(J)
c        WRITE(6,*)(VRSWP(I,J),I=1,50)
c        WRITE(6,*)"REFSWP, J = ",J
c        WRITE(6,*)(REFSWP(I,J),I=1,50)
c       ENDDO
       TMSWEEPMIN=300000.
       TMSWEEPMAX=0.
       DO J=1,NUM_RAYS
        IF(TMSWEEP(J).GT.TMSWEEPMAX)TMSWEEPMAX=TMSWEEP(J)
       IF(TMSWEEP(J).LT.TMSWEEPMIN)TMSWEEPMIN=TMSWEEP(J)
       DO I=1,MAX_HRD_DIM
        RANGE(I)=RDTAI(I)
        GTLENGTH(I)=RDTAI(I)
c       WRITE(6,*)'I,RANGE(I) = ',I,RANGE(I)
        IF(RANGE(I).GT.0..AND.RANGE(I).LT.RHIGH.AND.
     1    I.GT.NBINMAX)NBINMAX=I
       ENDDO
      ENDDO
      DO J=1,NUM_RAYS
         DO I=1,ISCANMAX
            IF(RANGE(I).GT.0..AND.RANGE(I).LT.200.)THEN
               REFSWP(I,J)=RANGE(I)*10.*BEAMWR
            ELSE
               REFSWP(I,J)=-32.1
            ENDIF
         ENDDO
       ENDDO
c      WRITE(6,*)TMSWEEPMIN,TMSWEEPMAX
c      WRITE(6,*)'ANGTEST = ',ANGTEST
c       write(6,*)'returned iusewind = ',iusewind
c       write(6,*)'abcd rra = ',rra
c       do kjk=1,512
c        do jkj=1,800
c         if(vrswp(kjk,jkj).gt.-800.)write(6,*)'i,j,vrswp = ',kjk,jkj,
c     +    vrswp(kjk,jkj)
c        enddo
c       enddo
c       write(6,*)'vrswp = ',vrswp
c      write(6,*)'num_rays,tmsweep = ',
c     +           num_rays,(tmsweep(jm),jm=1,num_rays)
c      WRITE(6,*)'BACK FROM SWEEPIN'
      ICLSWP=1
      NR=1
      PELEVSUM=0.
      DO NRR=1,NUM_RAYS
       PELEVSUM=PELEVSUM+PELEV(NRR)
      ENDDO
      PELEVSUM=PELEVSUM/NUM_RAYS
c      DO NRR=1,NUM_RAYS
c       IF(EEV(NRR).GT.-12..AND.EEV(NRR).LT.-3.)THEN
c        DO I=1,MAX_HRD_DIM
c         REFSWP(I,NRR)=-32.
c         VRSWP(I,NRR)=-888.8
c        ENDDO
c       ENDIF
c      ENDDO
      DO I=1,ISCANMAX
       RANGE(I)=RDTAI(I)
       GTLENGTH(I)=RDTAI(I)
      ENDDO
      DO I=1,MAX_HRD_DIM
       IF(RANGE(I).GT.RHIGH)RANGE(I)=RHIGH+.01
      ENDDO
      IF(IGRAPHICS.EQ.1)THEN
C
C BEGIN VARIABLES FOR SCAN GRAPHICS
C
       RMX=GTLENGTH(ISCANMAX)
       XDIS=75.
       YDIS=20.
       SWEEPSX=.20
       SWEEPSY=.20
       IMAXSWEEP=MAX_X
       JMAXSWEEP=MAX_Y
       MAXX=MAX_X
       MAXY=MAX_Y
       RDEL=0.
       RDEL_Z=0.
       NMOSM=0
       BAD_VAL=-888.8
       DOPMIN=-90.
       DOPMAX=90.
       TOO_NOISY=-200.
       AMBIGUOUS=-100.
       BAD_VALZ=-100.0
       DBZMIN=-40.
       DBZMAX=80.
       DATA_TYPE=2
       IXL=20
       IYB=20
c       write(6,*)'rmx = ',rmx
C
C END VARIABLES FOR SCAN GRAPHICS
C
       DO J1=1,NUM_RAYS
c        WRITE(6,*)J1,EEV(J1)
c        WRITE(6,'(10F8.2)')(REFSWP(I1,J1),I1=1,500)
        IRANGERTEST=0
        DO I1=1,MAX_HRD_DIM
         VRSWP1(I1,J1)=VRSWP(I1,J1)
         REFSWP1(I1,J1)=REFSWP(I1,J1)
         IRANGER=INT((RANGE(I1)+.001)/10.)
         REMRANGER=RANGE(I1)-IRANGER*10.
         IF(IRANGER.GT.IRANGERTEST.AND.RANGE(I1).LT.RHIGH)THEN
          IF(REMRANGER.LT.1.21)THEN
           VRSWP1(I1,J1)=DOPMAX-1.
           REFSWP1(I1,J1)=DBZMAX-1.
           IRANGERTEST=IRANGER
          ENDIF
         ENDIF
        ENDDO
       ENDDO
c       WRITE(6,*)'REF1 AT 10 = ',(REFSWP1(10,J),J=1,NUM_RAYS)
c       WRITE(6,*)'VR1 AT 10 = ',(VRSWP1(10,J),J=1,NUM_RAYS)
       IHOURSMIN=TMSWEEPMIN/3600.
       SECLEFT=TMSWEEPMIN-IHOURSMIN*3600.
       IMINSMIN=SECLEFT/60.
       ISECSMIN=TMSWEEPMIN-IHOURSMIN*3600.-IMINSMIN*60.
       ITHHMMSS=IHOURSMIN*10000+IMINSMIN*100+ISECSMIN
       WRITE(CHARTIMEMIN,'(3I2.2)')IHOURSMIN,IMINSMIN,ISECSMIN
c       WRITE(6,'(3I2.2)')IHOURSMIN,IMINSMIN,ISECSMIN
       IF(PELEVSUM.GT.0.)THEN
        WRITE(CHARAFTFORE,'(A5)')' FORE'
       ELSE
        WRITE(CHARAFTFORE,'(A5)')'  AFT'
       ENDIF
       IHOURSMAX=TMSWEEPMAX/3600.
       SECLEFT=TMSWEEPMAX-IHOURSMAX*3600.
       IMINSMAX=SECLEFT/60.
       ISECSMAX=TMSWEEPMAX-IHOURSMAX*3600.-IMINSMAX*60.
       ITHHMMSS=IHOURSMAX*10000+IMINSMAX*100+ISECSMAX
       WRITE(CHARTIMEMAX,'(3I2.2)')IHOURSMAX,IMINSMAX,ISECSMAX       
c       WRITE(6,'(3I2.2)')IHOURSMAX,IMINSMAX,ISECSMAX       
c       pause
       ISCANMAX960=ISCANMAX
       IF(ISCANMAX960.GT.960)ISCANMAX960=960
       CALL SOLO_CONVT(DATA_TYPE,ELMIN,ELMAX,
     +  DBZ_INT,MAXX,MAXY,ILOG_LU,
     +  AZ_EL,VRSWP1,MAX_GATES,ISCANMAX960,NUM_RAYS,IERSM,
     +  IMAXSWEEP,JMAXSWEEP,SWEEPSX,SWEEPSY,XDIS,YDIS,RLATDUM,
     +  RLONDUM,SLATDUM,SLONDUM,RMX,RDEL_Z,TIMES,NMOSM,ITFLG,
     +  GTLENGTH,BAD_VAL)
       CALL SHOW_IZ(IXL,IYB,DBZ_INT,MAXX,MAXY,IMAXSWEEP,JMAXSWEEP,
     +  DOPMIN,DOPMAX,DATA_TYPE,TOO_NOISY,AMBIGUOUS,
     +  RAW_WINDOW,DISPLAY_LABEL,CHARTIMEMIN,CHARTIMEMAX,CHARAFTFORE)
       DATA_TYPE=1
       CALL SOLO_CONVT(DATA_TYPE,ELMIN,ELMAX,
     +  DBZ_INT,MAXX,MAXY,ILOG_LU,
     +  AZ_EL,REFSWP1,MAX_GATES,ISCANMAX960,NUM_RAYS,IERSM,
     +  IMAXSWEEP,JMAXSWEEP,SWEEPSX,SWEEPSY,XDIS,YDIS,RLATDUM,
     +  RLONDUM,SLATDUM,SLONDUM,RMX,RDEL_Z,TIMES,NMOSM,ITFLG,
     +  GTLENGTH,BAD_VALZ)
       CALL SHOW_IZ(IXL,IYB,DBZ_INT,MAXX,MAXY,IMAXSWEEP,JMAXSWEEP,
     +  DBZMIN,DBZMAX,DATA_TYPE,TOO_NOISY,AMBIGUOUS,
     +  RAWZ_WINDOW,DISPLAY_LABELZ,CHARTIMEMIN,CHARTIMEMAX,CHARAFTFORE)
      ENDIF
92924 DO WHILE(NR.LE.NUM_RAYS)
       IAZMM=IAZM(NR)
c       WRITE(6,*)'NR,IAZMM = ',NR,IAZMM
c       WRITE(6,*)'DBZ = ',(DBZ(I),I=1,NBINS)
       IF(IAZMM.NE.1.AND.ELEV.GT.-5..AND.ELEV.LT.-1.)THEN
        NR=NR+1
        GO TO 92924
       ENDIF
       ELEVTEST=PELEV(NR)
c       WRITE(6,*)'TMSWEEP,NR,ELEVTEST = ',TMSWEEP(NR),NR,ELEVTEST
c       write(6,'(a2)')TAF
       IF(ELEVTEST.LE.0)THEN
C        IF(ELEVTEST.LE.0.)write(6,*)'going to 27272'
C        IF(ELEVTEST.LE.0.)GO TO 27272
        L2=1
       ELSE
C        IF(ELEVTEST.GE.0.)write(6,*)'going to 27272'
C        IF(ELEVTEST.GE.0.)GO TO 27272
        L2=2
       ENDIF
       IF(ANGTEST.GT.-900.)THEN
        NUMANGTEST(L2)=NUMANGTEST(L2)+1
        ANGTESTSUM(L2)=ANGTESTSUM(L2)+ANGTEST
c        WRITE(6,*)'L2,NUMANGTEST,ANGTESTSUM = ',
c     1   L2,NUMANGTEST(L2),ANGTESTSUM(L2)
       ENDIF
       IF(GROUNDSLOPE.GT.-900.)THEN
        NUMSLOPETEST(L2)=NUMSLOPETEST(L2)+1
        SLOPETESTSUM(L2)=SLOPETESTSUM(L2)+GROUNDSLOPE
c        WRITE(6,*)'L2,NUMSLOPETEST,SLOPETESTSUM = ',
c     1   L2,NUMSLOPETEST(L2),SLOPETESTSUM(L2)
        ENDIF
       RLATBEFORE=RLAT
       TIMES=TMSWEEP(NR)
       AZIM=EAZM(NR)
C
C Sweepin uses math angles but VRLOCATE was based upon using the
C UF file reader which reports back in navigational coordinates
C Thus do a reflection and check
C
       AZIM=90-AZIM
       IF(AZIM.LT.0.)AZIM=AZIM+360.
       IF(AZIM.GT.360.)AZIM=AZIM-360.
       RALT=RRA(NR)
       ELEV=EEV(NR)
       RLAT=RRLAT(NR)
       RLON=RRLON(NR)
c       WRITE(6,*)'NR,NUM_RAYS,NRECORD = ',NR,NUM_RAYS,NRECORD
c       WRITE(6,*)'TIMES,RLAT,RLON,RALT,AZIM,ELEV = ',
c     + TIMES,RLAT,RLON,RALT,AZIM,ELEV
       ILIST=0
c       WRITE(6,*)'VRSWP, NR = ',NR
c       WRITE(6,7777)(VRSWP(I,NR),I=1,ISCANMAX)       
c 7777  FORMAT(10F8.2)
c       WRITE(6,*)'REFSWP, NR = ',NR
c       WRITE(6,7777)(REFSWP(I,NR),I=1,ISCANMAX)       
       DO I=1,ISCANMAX
        VR(I)=VRSWP(I,NR)
        IF(VR(I).GT.-800..AND.ABS(VR(I)).GT.70.)ILIST=1
        DBZ(I)=REFSWP(I,NR)
C        IF(VR(I).GT.-800.)
C     +   write(6,'(I5,3F10.3)')NR,VR(I),DBZ(I),RANGE(I)
       ENDDO
C92923 CALL READUF_DISC(TIMES,NUMSWEEP,FLIGHTID,NRECORD,RLAT,RLON,
C     + RALT,AZIM,ELEV,RANGE,DBZ,VR,ISCANDIM,IERR,CHARV,CHARDBZ,
C     + NUMREC,LINUXYES)
c      WRITE(6,*)'VE = ',(VR(I),I=1,ISCANDIM)
c      WRITE(6,*)'DZ = ',(DBZ(I),I=1,ISCANDIM)
       IF(RLAT.EQ.0.)RLAT=RLATBEFORE
        IF(IRAMSFILES.EQ.1)THEN
        rlat22=rlat
        rlon22=rlon
        CALL READRAMFILE(TIMES,TIME_RAM,RLAT,RLON,DM1,DM2,DM3,
     *                      DM4,DM5,DM6,DM7,IOS)
c       write(6,*)'times,rlatold,rlonold = ',times,rlat22,rlon22
c       write(6,*)'times,rlat,rlon from reader = ',times,rlat,rlon
       ENDIF
       IF(IBEGIN.EQ.1.AND.TIMES.LT.TSTART)TIMES=TIMES+86400.
c       write(6,*)'times,tend,ierr = ',times,tend,ierr
c       WRITE(6,*)'TIMES,TEND,IERR,NR,NUM_RAYS = ',
c     + TIMES,TEND,IERR,NR,NUM_RAYS
       IF(TIMES.GT.TEND.OR.IERR.EQ.-1)GO TO 92929
       IF(TIMES.GT.TIMEOLD)THEN
        ITIMES=TIMES
        IHOURS=TIMES/3600
        IHSECS=IHOURS*3600
        ILEFT=ITIMES-IHSECS
        IMINS=ILEFT/60
        ISECS=ILEFT-60*IMINS
        ITIMESS=IHOURS*10000+IMINS*100+ISECS       
        IF(IRAMSFILES.NE.1)THEN
c         WRITE(6,*)ITIMESS,RALT
        ELSE
c         WRITE(6,*)'Time, Radar lat lon = ',ITIMESS,RLAT22,RLON22
c         WRITE(6,*)'TIME, RAMS  LAT LON = ',ITIMESS,RLAT,RLON
        ENDIF
       ENDIF
       TIMEOLD=TIMES
       IF(IREADABCD.NE.1.AND.TIMES.GE.TSTART.AND.TIMES.LE.TEND)THEN
c       IF(RDEL.GT.0.)THEN
c        JJJSTART=1
c       ELSE
c        JJJSTART=2-(RDEL/.15)
c       ENDIF
        JJJSTART=1
        IF(RDEL.LT.0)THEN
         DO JJJ=JJJSTART,ISCANMAX
          RANGE(JJJ)=RANGE(JJJ)+RDEL
          IF(IREVERSE.EQ.1)THEN
c          VR(JJJ)=-VR(JJJ)
         ENDIF
         ENDDO
        ENDIF
        RHIGH=300.
        RLOW=.1
c       WRITE(6,*)'RANGE(1) = ',RANGE(1)
c        RLOW=(RALT/1000.)+2.5
c      WRITE(6,*)TIMES,RLAT,RLON,ELEV,AZIM,JJJSTART,RANGE(JJJSTART),
c     +RLOW,RHIGH
C
C Angle projection summing follows.  
C
        IBEGIN=1
        XWEIGHT=0
        YWEIGHT=0
        ZWEIGHT=0
        SUMWEIGHT=0
c       ISCANDIM=512
c       DO I=1,ISCANDIM
c        DBZ(I)=0.
c        VR(I)=0.
c        RANGE(I)=I*.150
c       ENDDO
        CALL VRLOCATE(OLAT,OLON,TIMES,
     +  RLAT,RLON,RALT,ELEV,AZIM,RANGE,XR,YR,ZR,
     +  SMOTIONU,SMOTIONV,ISCANDIM,CENTIME,IBINS,WGT,VR,ISCANMAX)
c        write(6,*)'olat,olon,rlat,rlon = ',olat,olon,rlat,rlon
c        write(6,*)'xr,yr,zr = ',xr(1),yr(1),zr(1)
        AZIMM=AZIM-ROTB
c       GAMMAT=TAN(ELEV*DTR)*SZB/SXB
        GAMMA=SIN(ELEV*DTR)
        ALPHA=SIN(AZIMM*DTR)*COS(ELEV*DTR)
        BETA=COS(AZIMM*DTR)*COS(ELEV*DTR)
c       WRITE(6,*)'RLAT,RLON = ',RLAT,RLON
c       WRITE(6,*)'ZZZB = ',ZZZB
c       WRITE(6,*)'TIMES,RANGE(1),XR(1),YR(1),ZR(1) = ',
c     +  TIMES,RANGE(1),XR(1),YR(1),ZR(1)
c        DO I=JJJSTART,ISCANMAX
c         ZR(I)=ZR(I)-ZZZB
c        ENDDO
c       WRITE(6,*)'RLAT,RLON = ',RLAT,RLON
c       WRITE(6,*)'TIMES,XR(1),YR(1),ZR(1) = ',TIMES,XR(1),YR(1),ZR(1)
c       do i=1,iscandim
c        write(6,*)i,xr(i),yr(i),zr(i)
c       enddo
c        write(6,*)'nr,gamma,range(4,5),zr(4,5),vr(4,5),dbz(4,5) = ',
c     +   nr,gamma,
c     +   range(4),range(5),zr(4),zr(5),vr(4),vr(5),dbz(4),dbz(5)
        ISCANTEST=0
c        IF(ILIST.EQ.1)THEN
c         WRITE(6,*)'TIMES = ',TIMES
c         WRITE(6,*)'RANGE = ',(RANGE(I),I=1,ISCANMAX)
c         WRITE(6,*)'VR = ',(VR(I),I=1,ISCANMAX)
c        ENDIF
C        WRITE(6,*)'NR,ISCANMAX = ',NR,ISCANMAX
C        WRITE(6,*)'DBZ = ',(DBZ(I),I=1,ISCANMAX)
C        WRITE(6,*)'RANGE = ',(RANGE(I),I=1,ISCANMAX)
C        WRITE(6,*)'AZIMM,ELEV = ',AZIMM,ELEV
        DO I=JJJSTART,ISCANMAX
c         DBZCHK=DBZTEST+20.*ALOG10(RANGE(I)/RRRR)
         DBZCHK=-31.99
         RXMAX=RHMAX
         RYMAX=RHMAX 
         RZMAX=RZMAXIN        
C         IF(ICRESS.EQ.1)THEN
C          SEARCHRADIUS=RANGE(I)/30.
C          IF(SEARCHRADIUS.GT.RHMAX)THEN
C           RXMAX=SEARCHRADIUS
C           RYMAX=SEARCHRADIUS
C           RZMAX=SEARCHRADIUS
c          write(6,*)'i,range,searchradius = ',i,range(i),searchradius
C          ENDIF
C         ENDIF
c        WRITE(6,*)'RANGE(I),DBZTEST,RRRR,DBZCHK,DBZ(I) = '
c        WRITE(6,*)RANGE(I),DBZTEST,RRRR,DBZCHK,DBZ(I)
c        write(6,*)'i,range,dbz,vr = ',range(i),dbz(i),vr(i)
         RHO=EXP(-ZR(I)*.10437052)
c        RHO=EXP(-ZR(I)*.11)
c        ZRCHECK=RANGE(I)/57.*.95*COS(ELEV*DTR)
         ZRCHECK=0.
c        DISTCHECK=RANGE(I)*.08
C        RLOW=0.1
c        write(6,*)'rlow,rhigh,ralt,i,range(i) = ',
c     +             rlow,rhigh,ralt,i,range(i)
         XR(I)=XR(I)+XSHIFT(NF)
         YR(I)=YR(I)+YSHIFT(NF)
c        WRITE(6,*)'VR,DBZ,ZR,RANGE,RLOW,RHIGH = ',
c     + VR(I),DBZ(I),ZR(I),RANGE(I),RLOW,RHIGH
c        X=XR(I)
c        Y=YR(I)
c        Z=ZR(I)
c        UAN=UBAR*SIN(PI2*X/RLH)*COS(PI2*Y/RLH)*COS(PI2*Z/RLZ)
c        VAN=UBAR*COS(PI2*X/RLH)*SIN(PI2*Y/RLH)*COS(PI2*Z/RLZ)
c        WAN=-2.*UBAR*RLZ/RLH*COS(PI2*X/RLH)*
c     +                     COS(PI2*Y/RLH)*SIN(PI2*Z/RLZ)
c        WRITE(6,*)'I,RLZ,RLH,PI2,UBAR = ',I,RLZ,RLH,PI2,UBAR
c        WRITE(6,*)'I,X,Y,Z,UAN,VAN,WAN = ',I,X,Y,Z,UAN,VAN,WAN
c        UAN=UAN/RHO
c        VAN=VAN/RHO
c        WAN=WAN/RHO
c        UAN=UAN
c        VAN=VAN
c        WAN=WAN
c        VRVR=UAN*ALPHA+VAN*BETA+WAN*GAMMA
         VRVR=VR(I)
C         DBZ(I)=0.
c         WRITE(6,*)'IAZMM,NR = ',IAZMM,NR
         IF((VR(I).GT.-800..OR.DBZ(I).GT.DBZCHK).AND.
     +     ZR(I).GT.ZRCHECK.AND.ZR(I).GT..075.
C     +      ZR(I).GT.-4.
     +     AND.RANGE(I).GT.RLOW.AND.RANGE(I).LT.RHIGH.
     +     AND.IAZMM.EQ.1)THEN
c          write(6,*)'I GOT HERE ISCANMAX =',ISCANMAX
          IGAMMATEST=1
c          IGAMMATEST=0
c         IF(IW0.EQ.1)THEN
c          IF(ABS(GAMMAT).LE.1.)IGAMMATEST=1
c         ELSE
           IF(ABS(GAMMA).LE.SINTOL)IGAMMATEST=1
c         ENDIF
          IF(IGAMMATEST.EQ.1)THEN
C
C Determine actual distance from location of datum in data file
C to the point being evaluated in output file 
C
           CALL DIFFOBLONG(XR(I),YR(I),ZR(I),
     +      RXMAX,RYMAX,RZMAX,SXB,SYB,SZB,
     +      XZB,YZB,ZZB,IMAXB,JMAXB,KMAXB,
     +      IXMIN,IXMAX,IYMIN,IYMAX,IZMIN,IZMAX,ROTB)
c            if(zr(i).le.1.)then
c             write(6,*)'i,xr,yr,zr,sx,sy,sz,xz,yz,zz,ixmin,ixmax,
c     +       iymin,iymax,izmin,izmax,gamma = ',
c     +       i,xr(i),yr(i),zr(i),sxb,syb,szb,xzb,yzb,zzb,ixmin,ixmax,
c     +        iymin,iymax,izmin,izmax,gamma
c            endif
           ICALLED=0
           DO KK=IZMIN,IZMAX
            RHOVRVR=VRVR*RHOK(KK)
            DO JJ=IYMIN,IYMAX
             DO II=IXMIN,IXMAX  
c              CALL DIFFDISTXYRT(XR(I),YR(I),ZR(I),
c     +        II,JJ,KK,INEAR,JNEAR,KNEAR,
c     +        SXB,SYB,SZB,XZB,YZB,ZZB,RX,RY,RZ,ROTB,
c     +        DELTHETA,DELRAD,DISTTHETA,
c     +        IMAXB,JMAXB,KMAXB,THETA1,RADIUS1,THETA2,RADIUS2,
c     +        ICALLED,XBROT,YBROT)
              CALL DIFFDIST(XR(I),YR(I),ZR(I),
     +        II,JJ,KK,INEAR,JNEAR,KNEAR,
     +        SXB,SYB,SZB,XZB,YZB,ZZB,RX,RY,RZ,ROTB)
c             WRITE(6,*)'II,JJ,KK = ',II,JJ,KK
c             WRITE(6,*)'RX,RY,RZ = ',RX,RY,RZ
              XX=(FLOAT(II-1)+.5)*SXB-XZB
              YY=(FLOAT(JJ-1)+.5)*SYB-YZB
              ZZ=(KK-1)*SZB+ZZB
              ZZ2=ZZ*2.
              IF(ZZ2.LT.SZB)ZZ2=SZB
              IF(RX.LE.0)IA=1
              IF(RX.GT.0)IA=2
              IF(RY.LE.0)JA=1
              IF(RY.GT.0)JA=2
              IF(RZ.LE.0)KA=1
              IF(RZ.GT.0)KA=2
              RR=SQRT(RX*RX+RY*RY+RZ*RZ)
              IF(RR.LT.DISTXYZ(II,JJ,KK,L2,IA,JA,KA))THEN
               DISTXYZ(II,JJ,KK,L2,IA,JA,KA)=RR
              ENDIF
C              IF(ICRESS.EQ.1)THEN
C               IF(RR.GT.0.)THEN
C                P=1./RR/RR
C               ELSE
C                P=1000.
C               ENDIF
C              ELSE
C               P=1.
C              ENDIF
              IF(ABS(RX).LT.RXMAX.AND.ABS(RY).LT.RYMAX.AND.
     1          ABS(RZ).LT.RZMAX.AND.ZR(I).LT.ZZ2)THEN
               ABCC=RX**2./RXMAX*2.+RY*2./RYMAX**2.+
     1           RZ**2./RZMAX**2.
               ABC=RX*RX/RXWEIGHT+
     1           RY*RY/RYWEIGHT+RZ*RZ/RZWEIGHT
c               ABC=(RX*RX+RY*RY)/RHWEIGHT+RZ*RZ/RZWEIGHT
C               ALPHANEW=ALPHA*COS(DELTHETA)-BETA*SIN(DELTHETA)
C               BETANEW=ALPHA*SIN(DELTHETA)+BETA*COS(DELTHETA)
               ALPHANEW=ALPHA
               BETANEW=BETA
c               write(6,*)'alpha,alphanew,beta,betanew = ',
c     1          alpha,alphanew,beta,betanew
c               write(6,*)'delrad,deltheta,disttheta = ',
c     1           delrad,deltheta,disttheta
               IF(ICRESS.NE.1)THEN
                WEIGHT=EXP(-ABC)
                P=WEIGHT
               ELSE
                WEIGHT=1-ABCC
                IF(WEIGHT.LT.0.)WEIGHT=0
                P=WEIGHT
               ENDIF
C
C Accumulate weighted sums of x, y, and z distances of input data
C
               SUMWEIGHT=P
               IF(DBZ(I).GT.-100)THEN
                DBZZ=DBZ(I)*SLOPE1
                ELSE
                DBZZ=-200.
               ENDIF
C
C Perform DBZ weighted sum
C
c               ZE=10.**(DBZZ/10.)
               ZE=DBZZ
C      IF((VTEST.GT.0.OR.DBZ(I).GT.DBZCHK).AND.KK.GE.19)THEN
C       WRITE(6,*)'II,JJ,KK,L2,P,VTEST,SUMMER,SUMDBZ,SUMWTSAVE,ZE = ',
C     + II,JJ,KK,L2,P,VTEST,SUMMER(II,JJ,KK,L2),SUMDBZ(II,JJ,KK,L2),
C     + SUMWTSAVE(II,JJ,KK,L2),ZE
C      ENDIF
               IF(ABS(VR(I)).LT.800.)THEN
                VTEST=1.
               ELSE
                VTEST=0.
               ENDIF
               IF(DBZ(I).GT.DBZCHK)THEN
                SUMDBZ(II,JJ,KK,L2)=
     +          SUMDBZ(II,JJ,KK,L2)+P*DBZZ
                SUMMER(II,JJ,KK,L2)=SUMMER(II,JJ,KK,L2)+P
c              IF(KK.EQ.5)THEN
c               WRITE(6,*)'II,JJ,KK,I,RANGE(I),ELEV,XR,YR,ZR,DBZ = ',
c     + II,JJ,KK,I,RANGE(I),ELEV,XR(I),YR(I),ZR(I),DBZ(I)
c              ENDIF
               ENDIF
C
C Perform weighted sums of 9 direction cosine/Vr terms
C
               IF(VTEST.GT.0.)THEN
c              IF(KK.EQ.1)THEN
c               WRITE(6,*)'II,JJ,KK,I,RANGE(I),ELEV,XR,YR,ZR,VR = ',
c     + II,JJ,KK,I,RANGE(I),ELEV,XR(I),YR(I),ZR(I),VR(I)
c              ENDIF
c             ENDIF
c            IF(II.GT.19.AND.II.LT.23.AND.
c     +         JJ.GT.76.AND.JJ.LT.80)THEN
c             WRITE(6,*)'TIMES = ',TIMES
c             WRITE(6,*)'ELEV,AZIM,ALPHA,BETA,GAMMA = ',
c     +                  ELEV,AZIM,ALPHA,BETA,GAMMA
c             WRITE(6,*)'ALPHANEW,BETANEW,GAMMANEW = ',
c     +                  ALPHANEW,BETANEW,GAMMANEW
c             WRITE(6,*)'VR = ',(VR(IINDEX),IINDEX=1,ISCANMAX)
c             WRITE(6,*)'II,JJ,KK,I,ISCANMAX,RANGE,XR,YR,ZR,VR = ',
c     +        II,JJ,KK,I,ISCANMAX,RANGE(I),XR(I),YR(I),ZR(I),VR(I)
cc             PAUSE
c            ENDIF
                ISCANTEST=1
                SUMWTSAVE(II,JJ,KK,L2)=SUMWTSAVE(II,JJ,KK,L2)+P
                SUM1(II,JJ,KK,L2)=
     +          SUM1(II,JJ,KK,L2)+P*ALPHANEW*BETANEW
                SUM2(II,JJ,KK,L2)=
     +          SUM2(II,JJ,KK,L2)+P*BETANEW*RHOVRVR
                SUM3(II,JJ,KK,L2)=
     +          SUM3(II,JJ,KK,L2)+P*BETANEW*BETANEW
                SUM4(II,JJ,KK,L2)=
     +          SUM4(II,JJ,KK,L2)+P*ALPHANEW*RHOVRVR
                SUM5(II,JJ,KK,L2)=
     +          SUM5(II,JJ,KK,L2)+P*ALPHANEW*ALPHANEW
                SUM6(II,JJ,KK,L2)=
     +          SUM6(II,JJ,KK,L2)+P*ALPHANEW*GAMMA
                SUM7(II,JJ,KK,L2)=
     +          SUM7(II,JJ,KK,L2)+P*BETANEW*GAMMA
                SUM8(II,JJ,KK,L2)=
     +          SUM8(II,JJ,KK,L2)+P*GAMMA*GAMMA
                SUM9(II,JJ,KK,L2)=
     +          SUM9(II,JJ,KK,L2)+P*GAMMA*RHOVRVR
                SUM10(II,JJ,KK,L2)=
     +          SUM10(II,JJ,KK,L2)+P*ALPHANEW
                SUM11(II,JJ,KK,L2)=
     +          SUM11(II,JJ,KK,L2)+P*BETANEW
                SUM12(II,JJ,KK,L2)=
     +          SUM12(II,JJ,KK,L2)+P*GAMMA
                SUM13(II,JJ,KK,L2)=
     +          SUM13(II,JJ,KK,L2)+P*RHOVRVR
                XWSAVE(II,JJ,KK,L2)=XWSAVE(II,JJ,KK,L2)+P*RX
                YWSAVE(II,JJ,KK,L2)=YWSAVE(II,JJ,KK,L2)+P*RY
                ZWSAVE(II,JJ,KK,L2)=ZWSAVE(II,JJ,KK,L2)+P*RZ
               ENDIF
C      IF((VTEST.GT.0.OR.DBZ(I).GT.DBZCHK).AND.KK.GE.19)THEN
C      WRITE(6,*)'DBZ,VTEST = ',DBZ(I),VTEST
C      WRITE(6,*)'II,JJ,KK,L2,P,VTEST,SUMMER,SUMDBZ,SUMWTSAVE = ',
C     + II,JJ,KK,L2,P,VTEST,SUMMER(II,JJ,KK,L2),SUMDBZ(II,JJ,KK,L2),
C     + SUMWTSAVE(II,JJ,KK,L2)
C      ENDIF
              ENDIF
             ENDDO
            ENDDO
           ENDDO
          ENDIF
         ENDIF
        ENDDO
c        IF(ISCANTEST.EQ.1)THEN
c         WRITE(6,*)'VR = ',(VR(JI),JI=1,ISCANMAX)
c        ENDIF
       ENDIF
27272  NR=NR+1
      ENDDO
      GO TO 92923
92929 WRITE(6,*)'JUST FINISHED VR SUMMATION'
      CLOSE(320)
      CLOSE(321)
c5554  OPEN(103,FILE='/hrd/dat/gustav/tracking/insideabcd')
c      WRITE(103,*)'AT STATEMENT 5554--NF=',NF
c      WRITE(103,*)'JUST FINISHED VR SUMMATION'
c      CLOSE(103)
C      DO L2=1,2
C       DO KK=1,KMAXB
C        DO JJ=1,JMAXB
C         DO II=1,IMAXB
C          ITEST=0
C          IF(KK.LE.4)THEN
C           KABOT=2
C          ELSE
C           KABOT=1
C          ENDIF
C          DO KA=KABOT,2
C           DO JA=1,2
C            DO IA=1,2
CC            IF(KK.LE.2.AND.KA.EQ.1)THEN
CC             DIST=DISTXYZ(II,JJ,KK,IA,JA,2)
CC             IF(DIST.GT.EZMAX)DIST=1000.
CC            ELSE
C             DIST=DISTXYZ(II,JJ,KK,L2,IA,JA,KA)
CC            ENDIF
C             IF(DIST.GE.999.)THEN
C              SUM1(II,JJ,KK,L2)=0
C              SUM2(II,JJ,KK,L2)=0
C              SUM3(II,JJ,KK,L2)=0
C              SUM4(II,JJ,KK,L2)=0
C              SUM5(II,JJ,KK,L2)=0
C              SUM6(II,JJ,KK,L2)=0
C              SUM7(II,JJ,KK,L2)=0
C              SUM8(II,JJ,KK,L2)=0
C              SUM9(II,JJ,KK,L2)=0
C              SUM10(II,JJ,KK,L2)=0
C              SUM11(II,JJ,KK,L2)=0
C              SUM12(II,JJ,KK,L2)=0
C              SUM13(II,JJ,KK,L2)=0
C              XWSAVE(II,JJ,KK,L2)=1000.
C              YWSAVE(II,JJ,KK,L2)=1000.
C              ZWSAVE(II,JJ,KK,L2)=1000.
C              GO TO 10097
C             ENDIF
C            ENDDO
C           ENDDO
C          ENDDO
C10097    ENDDO
C        ENDDO
C       ENDDO
C      ENDDO
      IOKAY=1
72735 IF(IOKAY.EQ.1)THEN
C
C At end of each complete iteration
C
       WRITE(6,*)'IN ABCD'
       WRITE(6,*)'SUM1,SUM2,SUM3 = ',
     + SUM1(20,20,4,1),SUM2(20,20,4,1),SUM3(20,20,4,1),
     + SUMDBZ(20,20,4,1),SUMWTSAVE(20,20,4,1)
       OPEN(93,FILE='SUMS')
       DO L2=1,2
        DO KK=KMIN2,KMAX2
c        OPEN(102,FILE='/hrd/dat/gustav/tracking/abcd')
c        WRITE(102,*)'IN ABCD--K,NF = ',KK,NF
c        CLOSE(102)
         DO JJ=1,JMAXB
          DO II=1,IMAXB
           IF(SUMWTSAVE(II,JJ,KK,L2).GT.0..AND.
     +        SUMMER(II,JJ,KK,L2).GT.0..AND.IMXG.EQ.IMAXB.
     +        AND.JMXG.EQ.JMAXB.AND.KMXG.EQ.KMAXB.AND.
     +        UG(II,JJ,KK).GT.-999.)THEN
c           IF(SUMWTSAVE(II,JJ,KK,L2).GT.0..AND.
c     +        SUMMER(II,JJ,KK,L2).GT.0.)THEN
            ZE=SUMDBZ(II,JJ,KK,L2)/SUMMER(II,JJ,KK,L2)
C            SUMDBZ(II,JJ,KK,L2)=10.*ALOG10(ZE)
            SUMDBZ(II,JJ,KK,L2)=ZE
            SUM1(II,JJ,KK,L2)=SUM1(II,JJ,KK,L2)/
     +          SUMWTSAVE(II,JJ,KK,L2)
            SUM2(II,JJ,KK,L2)=SUM2(II,JJ,KK,L2)/
     +          SUMWTSAVE(II,JJ,KK,L2)
            SUM3(II,JJ,KK,L2)=SUM3(II,JJ,KK,L2)/
     +          SUMWTSAVE(II,JJ,KK,L2)
            SUM4(II,JJ,KK,L2)=SUM4(II,JJ,KK,L2)/
     +          SUMWTSAVE(II,JJ,KK,L2)
            SUM5(II,JJ,KK,L2)=SUM5(II,JJ,KK,L2)/
     +          SUMWTSAVE(II,JJ,KK,L2)
            SUM6(II,JJ,KK,L2)=SUM6(II,JJ,KK,L2)/
     +          SUMWTSAVE(II,JJ,KK,L2)
            SUM7(II,JJ,KK,L2)=SUM7(II,JJ,KK,L2)/
     +          SUMWTSAVE(II,JJ,KK,L2)
            SUM8(II,JJ,KK,L2)=SUM8(II,JJ,KK,L2)/
     +          SUMWTSAVE(II,JJ,KK,L2)
            SUM9(II,JJ,KK,L2)=SUM9(II,JJ,KK,L2)/
     +          SUMWTSAVE(II,JJ,KK,L2)
            SUM10(II,JJ,KK,L2)=SUM10(II,JJ,KK,L2)/
     +          SUMWTSAVE(II,JJ,KK,L2)
            SUM11(II,JJ,KK,L2)=SUM11(II,JJ,KK,L2)/
     +          SUMWTSAVE(II,JJ,KK,L2)
            SUM12(II,JJ,KK,L2)=SUM12(II,JJ,KK,L2)/
     +          SUMWTSAVE(II,JJ,KK,L2)
            SUM13(II,JJ,KK,L2)=SUM13(II,JJ,KK,L2)/
     +          SUMWTSAVE(II,JJ,KK,L2)
            XWSAVE(II,JJ,KK,L2)=XWSAVE(II,JJ,KK,L2)/
     +          SUMWTSAVE(II,JJ,KK,L2)
            YWSAVE(II,JJ,KK,L2)=YWSAVE(II,JJ,KK,L2)/
     +          SUMWTSAVE(II,JJ,KK,L2)
            ZWSAVE(II,JJ,KK,L2)=ZWSAVE(II,JJ,KK,L2)/
     +          SUMWTSAVE(II,JJ,KK,L2)
           ELSEIF(SUMMER(II,JJ,KK,L2).GT.2.)THEN
            ZE=SUMDBZ(II,JJ,KK,L2)/SUMMER(II,JJ,KK,L2)
C            SUMDBZ(II,JJ,KK,L2)=10.*ALOG10(ZE)
            SUMDBZ(II,JJ,KK,L2)=ZE
            SUMWTSAVE(II,JJ,KK,L2)=0.
            SUM1(II,JJ,KK,L2)=0.
            SUM2(II,JJ,KK,L2)=0.
            SUM3(II,JJ,KK,L2)=0.
            SUM4(II,JJ,KK,L2)=0.
            SUM5(II,JJ,KK,L2)=0.
            SUM6(II,JJ,KK,L2)=0.
            SUM7(II,JJ,KK,L2)=0.
            SUM8(II,JJ,KK,L2)=0.
            SUM9(II,JJ,KK,L2)=0.
            SUM10(II,JJ,KK,L2)=0.
            SUM11(II,JJ,KK,L2)=0.
            SUM12(II,JJ,KK,L2)=0.
            SUM13(II,JJ,KK,L2)=0.
            XWSAVE(II,JJ,KK,L2)=1000.
            YWSAVE(II,JJ,KK,L2)=1000.
            ZWSAVE(II,JJ,KK,L2)=1000.
           ELSE
            SUMWTSAVE(II,JJ,KK,L2)=0.
            SUM1(II,JJ,KK,L2)=0.
            SUM2(II,JJ,KK,L2)=0.
            SUM3(II,JJ,KK,L2)=0.
            SUM4(II,JJ,KK,L2)=0.
            SUM5(II,JJ,KK,L2)=0.
            SUM6(II,JJ,KK,L2)=0.
            SUM7(II,JJ,KK,L2)=0.
            SUM8(II,JJ,KK,L2)=0.
            SUM9(II,JJ,KK,L2)=0.
            SUM10(II,JJ,KK,L2)=0.
            SUM11(II,JJ,KK,L2)=0.
            SUM12(II,JJ,KK,L2)=0.
            SUM13(II,JJ,KK,L2)=0.
            XWSAVE(II,JJ,KK,L2)=1000.
            YWSAVE(II,JJ,KK,L2)=1000.
            ZWSAVE(II,JJ,KK,L2)=1000.
            SUMDBZ(II,JJ,KK,L2)=FLAG
           ENDIF
          ENDDO
          WRITE(93,*)'L2,KK,JJ = ',L2,KK,JJ
          WRITE(93,*)'SUMWTSAVE = '
          WRITE(93,8602)(SUMWTSAVE(II,JJ,KK,L2),II=1,IMAXB)
          WRITE(93,*)'SUMMER = '
          WRITE(93,8602)(SUMMER(II,JJ,KK,L2),II=1,IMAXB)
          WRITE(93,*)'SUM2 = '
          WRITE(93,8602)(SUM3(II,JJ,KK,L2),II=1,IMAXB)
          WRITE(93,*)'SUM4 = '
          WRITE(93,8602)(SUM4(II,JJ,KK,L2),II=1,IMAXB)
          WRITE(93,*)'SUM9 = '
          WRITE(93,8602)(SUM9(II,JJ,KK,L2),II=1,IMAXB)
8602      FORMAT(8E14.4)
         ENDDO
        ENDDO      
       ENDDO
c       DO K=1,KMAXB
c        DO J=1,JMAXB
c         WRITE(6,*)'ONE,K,J,SUM1,SUM2,SUM3,SUMDBZ,SUMWTSAVE = ',
c     + (SUM3(I,J,K,1),SUM5(I,J,K,1),SUM8(I,J,K,1),
c     + SUMDBZ(I,J,K,1),SUMWTSAVE(I,J,K,1),I=1,IMAXB)
c         WRITE(6,*)'TWO,K,J,SUM1,SUM2,SUM3,SUMDBZ,SUMWTSAVE = ',
c     + (SUM3(I,J,K,2),SUM5(I,J,K,2),SUM8(I,J,K,2),
c     + SUMDBZ(I,J,K,2),SUMWTSAVE(I,J,K,2),I=1,IMAXB)
c       WRITE(6,*)'imaxb,jmaxb,kmaxb = ',imaxb,jmaxb,kmaxb
cc       WRITE(6,*)'SUM1,SUM2,SUM3,SUMDBZ,SUMWTSAVE = ',
cc     + SUM1(20,20,4,1),SUM2(20,20,4,1),SUM3(20,20,4,1),
cc     + SUMDBZ(20,20,4,1),SUMWTSAVE(20,20,4,1)
cc       WRITE(6,*)'imaxb,jmaxb,kmaxb = ',imaxb,jmaxb,kmaxb
c        ENDDO
c       ENDDO
      ENDIF
      CLOSE(93)
c      OPEN(89,FILE='angtest.txt')
c      DO L2=1,2
c       ANGTEST=-999.
c       GROUNDSLOPE=-999.
c       IF(NUMANGTEST(L2).GT.2)THEN
c        ANGTEST=ANGTESTSUM(L2)/NUMANGTEST(L2)
c       ENDIF
c       WRITE(89,6259)L2,ANGTEST,ANGTESTSUM(L2),NUMANGTEST(L2)
c       IF(NUMSLOPETEST(L2).GT.2)THEN
c        GROUNDSLOPE=SLOPETESTSUM(L2)/NUMSLOPETEST(L2)
c       ENDIF
c       WRITE(89,6259)L2,GROUNDSLOPE,SLOPETESTSUM(L2),NUMSLOPETEST(L2) 
c6259   FORMAT(I2,2F12.3,I10)
c      ENDDO
c      CLOSE(89)
      OPEN(81,FILE='beam_p3_aft',FORM='UNFORMATTED')
      DO K=1,KMAXB
         DO J=1,JMAXB
            WRITE(81)(SUMDBZ(I,J,K,1),I=1,IMAXB)
         ENDDO
      ENDDO
      CLOSE(81)
      OPEN(81,FILE='beam_p3_fore',FORM='UNFORMATTED')
      DO K=1,KMAXB
         DO J=1,JMAXB
            WRITE(81)(SUMDBZ(I,J,K,2),I=1,IMAXB)
         ENDDO
      ENDDO
      CLOSE(81)
      RETURN
      END
      SUBROUTINE VRLOCATE(OLAT,OLON,TIMES,
     + RLAT,RLON,ALT,ELEV,AZIM,RANGE,XR,YR,ZR,
     + SMOTIONU,SMOTIONV,ISCANDIM,CENTIME,IBINS,WEIGHT,VR,ISCANMAX)
      INCLUDE "hrd_radar_settings.f"
      REAL RANGE(ISCANDIM),XR(ISCANDIM),YR(ISCANDIM),ZR(ISCANDIM)
      REAL SUM(MAX_HRD_DIM),WSUM(MAX_HRD_DIM),WEIGHT(200)
      REAL VR(MAX_HRD_DIM)   
c      write(6,*)'olat,olon,times = ',olat,olon,times
c      write(6,*)'rlat,rlon,alt,elev = ',rlat,rlon,alt,elev
      RALT=ALT/1000.
      PI=ASIN(1.0)*2.
      DTR=PI/180.
      REARTH=6366.
      TDIFF=TIMES-CENTIME
      JBINS=IBINS*3
c      DO I=1,ISCANDIM
c       SUM(I)=0
c       WSUM(I)=0
c       ISTART=I-JBINS
c       IEND=I+JBINS
c       IF(ISTART.LT.1)ISTART=1
c       IF(IEND.GT.ISCANDIM)IEND=ISCANDIM
c       DO J=ISTART,IEND
c        IF(VR(J).GT.-900.)THEN
c         IDIFF=J-I
c         IDIFF=IABS(IDIFF)
c         WSUM(I)=WSUM(I)+WEIGHT(IDIFF)
c         SUM(I)=SUM(I)+WEIGHT(IDIFF)*VR(J)
c        ENDIF
c       ENDDO
c      ENDDO
c      DO I=1,ISCANDIM
c       IF(WSUM(I).LE.0..AND.VR(I).LE.-900.)THEN
c        VR(I)=-999.9
c       ELSE
c        VR(I)=SUM(I)/WSUM(I)
c       ENDIF
c      ENDDO
      XSHIFT=TDIFF*SMOTIONU/1000.
      YSHIFT=TDIFF*SMOTIONV/1000.     
      RAZIM=AZIM*DTR
      RELEV=ELEV*DTR
      DO I=1,ISCANMAX
c xradar=horizontal distance from aircraft
c yradar=vertical distance from center of earth
       XRADAR=RANGE(I)*COS(RELEV)
       YRADAR=REARTH+RALT+RANGE(I)*SIN(RELEV)
c radnew=distance of datum from center of earth
       RADNEW=SQRT(XRADAR*XRADAR+YRADAR*YRADAR)
c delangle=angle between vertical at aircraft and vertical at datum
       DELANGLE=ATAN(XRADAR/YRADAR)
c distance along great circle from radar to datum
       DISTANCE=.5*(RADNEW+REARTH+RALT)*DELANGLE
c height=altitude of datum
       HEIGHT=RADNEW-REARTH
c distance2=xradar
       DISTANCE2=RANGE(I)*COS(RELEV)
c height2=altitude of datum not accounting for earth's curvature
       HEIGHT2=RALT+RANGE(I)*SIN(RELEV)
c delx=distance (aircraft/datum) along great circle due to east west
       DELX=DISTANCE*SIN(RAZIM)
c dely=distance(aircraft/datum)along great circle due to north-south
       DELY=DISTANCE*COS(RAZIM)
c dx=east west distance from origin to aircraft
       XLAT=.5*(RLAT+OLAT)*DTR
       DX=(RLON-OLON)*DTR*REARTH*COS(XLAT)
c dy=north south distance from origin to aircraft
       DY=(RLAT-OLAT)*DTR*REARTH
c xshift=east-west distance from lower left corner to origin
c yshift=north-south distance from lower left corner to origin
c XR=distance of datum from lower left corner
c YR=distance of datum from lower left corner
       XR(I)=DELX+DX-XSHIFT
c yshift=distance from lower left corner to origin
       YR(I)=DELY+DY-YSHIFT
       ZR(I)=HEIGHT
c       WRITE(6,*)'I,RANGE,DISTANCE,HEIGHT,DELX,DELY,DX,DY,XSHIFT,'
c     +  'YSHIFT = ',
c     +  I,RANGE(I),DISTANCE,HEIGHT,DELX,DELY,DX,DY,XSHIFT,YSHIFT
      ENDDO
      CONTINUE
      RETURN
      END
      SUBROUTINE WRITEU(U,IMAX,JMAX,KMAX)
      REAL U(IMAX,JMAX,KMAX)
      WRITE(6,*)'ENTERED WRITEU'
      WRITE(6,*)'IMAX,JMAX,KMAX = ',IMAX,JMAX,KMAX
      DO K=1,KMAX
       WRITE(6,*)'KMAX = ',KMAX
       DO J=1,JMAX
        WRITE(6,*)'JMAX = ',JMAX
        WRITE(6,*)'WRITEU J,K,U = ',J,K,(U(I,J,K),I=1,IMAX)
       ENDDO
      ENDDO
      RETURN
      END


