      PROGRAM CHECK_ANALYSIS
      IMPLICIT NONE
      CHARACTER WINDFILENAME*132
      INTEGER LU
      COMMON /HEADER/ KEYWORD,FLTNAME,STMNAME,RADAR,EXPERIMENT,
     + CREATIME,EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     + SX,SY,SZFILE,XZ,YZ,ZZ,ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     + POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7,
     + RMIN,ZMIN,SR,SZ,IPRT,XSIZE,YSIZE,IFLAG                       
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM*80
      INTEGER IMAX,JMAX,KMAX,KOUNT,NMOSM,
     +     IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,IFLAG,IPRT,IPASS
      REAL XSIZE,YSIZE,RMIN,SR,SZ,ZMIN
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZFILE,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      CALL GETARG(1,WINDFILENAME)
      LU=80
      CALL READHEADER(LU,WINDFILENAME)
      CALL LDPLN(LU,IMAX,JMAX,KMAX,IPASS)
      IF(IPASS.EQ.1)THEN
         WRITE(6,'(A6)')'passed'
      ELSE
         WRITE(6,'(A6)')'failed'
      ENDIF
      STOP
      END
      SUBROUTINE READHEADER(LU,FILNAM)
      COMMON /HEADER/ KEYWORD,FLTNAME,STMNAME,RADAR,EXPERIMENT,
     + CREATIME,EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     + SX,SY,SZFILE,XZ,YZ,ZZ,ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     + POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7,
     + RMIN,ZMIN,SR,SZ,IPRT,XSIZE,YSIZE,IFLAG                       
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM*80
      INTEGER IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZFILE,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      OPEN(LU,FILE=FILNAM,STATUS='OLD',FORM='UNFORMATTED')
      READ(LU)KEYWORD,FLTNAME,STMNAME,RADAR,EXPERIMENT,CREATIME,
     + EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,IUNFLD,IATTEN,FLAG,EXTRA2,
     + EXTRA3,STIME,ETIME,OLAT,OLON,SX,SY,SZFILE,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      RETURN
      END
      SUBROUTINE LDPLN(LU,IMAX,JMAX,KMAX,IPASS)
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX),W(IMAX,JMAX,KMAX)
      INTEGER*2 IU(2400),IV(2400),IW(2400),IDB(2400),IDV(2400)
      REAL RU(2400),RV(2400),RW(2400),RDV(2400)
      FLAG=-1.0E+10
      IRSW=0
      IUW=0
      IPASS=0
      DO K=1,KMAX
       DO J=1,JMAX
         READ(LU)(IU(I),IV(I),IW(I),IDB(I),IDV(I),I=1,IMAX)
c         write(6,20)(iu(i),i=1,imax)
c         write(6,20)(iv(i),i=1,imax)
c         write(6,20)(iw(i),i=1,imax)
c         write(6,20)(idb(i),i=1,imax)
c         write(6,20)'(idv(i),i=1,imax)
C 20      FORMAT(15I7)
         DO I=1,IMAX
            IF(IU(I).GT.-9000.AND.IV(I).GT.-9000)THEN
c                WRITE(6,*)'PASSED,I,J,K,IU,IV = ',I,J,K,IU(I),IV(I)
                IPASS=1
                RETURN
            ELSE
c               WRITE(6,*)'FAILED,I,J,K,IU,IV = ',I,J,K,IU(I),IV(I)
c               IF(IU(I).GT.-9000.OR.IV(I).GT.-9000)RETURN
            ENDIF
         ENDDO
       ENDDO
      ENDDO
      RETURN
      END
      BLOCK DATA                                                                
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM*80
      INTEGER IMX,JMX,KMX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      COMMON /HEADER/ KEYWORD,FLTNAME,STMNAME,RADAR,EXPERIMENT,
     + CREATIME,EXTRA1,IMX,JMX,KMX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     + SX,SY,SZFILE,XZ,YZ,ZZ,ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     + POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7
     + ,RMIN,ZMIN,SR,SZ,IPRT,XSIZE,YSIZE,IFLAG                       
      COMMON /CONTR/ CONDAT(31)                                                 
      COMMON /NUMSZ/ HGT                                                        
      END                                                                       
      
      
