      SUBROUTINE DWRPLN(LU,IMAX,JMAX,KMAX,U,V,W,DIV,SUMDBZ,
     + SUMWTSAVE,IUV,ZZ,SZ)
      INTEGER*2 ID(5,2400)
      REAL RD(5,2400)
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX),W(IMAX,JMAX,KMAX)
      REAL DIV(IMAX,JMAX,KMAX)
      DOUBLE PRECISION SUMDBZ(IMAX,JMAX,KMAX)
      DOUBLE PRECISION SUMWTSAVE(IMAX,JMAX,KMAX)
      FLAG=-1.0E+10
      ITOTALTEST=21*IMAX*JMAX+48*IMAX
      WRITE(6,*)'ZZ,SZ = ',ZZ,SZ
      DO K=1,KMAX
       H=ZZ+(K-1)*SZ
       RHO=EXP(-H*.10437052)
       DO J=1,JMAX
         DO I=1,IMAX
         IF(U(I,J,K).GT.FLAG.AND.V(I,J,K).GT.FLAG.AND.
     +     (U(I,J,K).NE.0..OR.V(I,J,K).NE.0.))THEN
          IF(IUV.EQ.0)THEN
           UU=U(I,J,K)/RHO
           VV=V(I,J,K)/RHO
           WDR=AMOD(630.0-57.29578*ATAN2(VV,UU),360.0)
           WSP=SQRT(UU*UU+VV*VV)
           ID(1,I)=WDR*10.
           ID(2,I)=WSP*10.
          ELSE
           RD(1,I)=U(I,J,K)/RHO
           RD(2,I)=V(I,J,K)/RHO
          ENDIF
         ELSE
          ID(1,I)=-32000
          ID(2,I)=-32000
          RD(1,I)=FLAG
          RD(2,I)=FLAG
         ENDIF
         IF(IUV.EQ.1)THEN
          IF(W(I,J,K).GT.FLAG)THEN
           RD(3,I)=W(I,J,K)/RHO
          ELSE
           RD(3,I)=FLAG
          ENDIF
         ELSE
          IF(W(I,J,K).GT.FLAG)THEN
           ID(3,I)=W(I,J,K)*100./RHO
          ELSE
           ID(3,I)=-32000
          ENDIF
         ENDIF
         IF(IUV.EQ.1)THEN
          IF(DIV(I,J,K).GT.FLAG)THEN
           RD(5,I)=DIV(I,J,K)
          ELSE
           RD(5,I)=FLAG
          ENDIF
         ELSE
          IF(ABS(DIV(I,J,K)).LT..32766)THEN
           ID(5,I)=DIV(I,J,K)*1.0E+05
          ELSE
           ID(5,I)=32767
          ENDIF
         ENDIF
         IF(SUMDBZ(I,J,K).LT.-100.)THEN
           ID(4,I)=-32000
         ELSE
           DBZ=SUMDBZ(I,J,K)
           ID(4,I)=NINT(DBZ*10.)
         ENDIF
        ENDDO
        IF(IUV.NE.1)THEN
         WRITE(LU)((ID(N,I),N=1,5),I=1,IMAX)
        ELSE
         WRITE(LU)((RD(N,I),N=1,3),ID(4,I),RD(5,I),I=1,IMAX)
        ENDIF
       ENDDO
      ENDDO
      RETURN
      END
      SUBROUTINE DREADABCD(LUW,IMAX,JMAX,KMAX,SUM1,SUM2,SUM3,SUM4,SUM5,
     +   SUM6,SUM7,SUM8,SUM9,SUM10,SUM11,SUM12,SUM13,
     +   SUMDBZ,KMAX2,XWEIGHT,YWEIGHT,ZWEIGHT)
      DOUBLE PRECISION SUM1(IMAX,JMAX,KMAX),SUM2(IMAX,JMAX,KMAX)
      DOUBLE PRECISION SUM3(IMAX,JMAX,KMAX),SUM4(IMAX,JMAX,KMAX)
      DOUBLE PRECISION SUM5(IMAX,JMAX,KMAX),SUM6(IMAX,JMAX,KMAX)
      DOUBLE PRECISION SUM7(IMAX,JMAX,KMAX),SUM8(IMAX,JMAX,KMAX)
      DOUBLE PRECISION SUM9(IMAX,JMAX,KMAX)
      REAL XWEIGHT(IMAX,JMAX,KMAX)
      REAL YWEIGHT(IMAX,JMAX,KMAX),ZWEIGHT(IMAX,JMAX,KMAX)
      DOUBLE PRECISION SUMDBZ(IMAX,JMAX,KMAX)
      DOUBLE PRECISION SUM10(IMAX,JMAX,KMAX),SUM11(IMAX,JMAX,KMAX)
      DOUBLE PRECISION SUM12(IMAX,JMAX,KMAX),SUM13(IMAX,JMAX,KMAX)
      DOUBLE PRECISION SUMM1(2400),SUMM2(2400),SUMM3(2400)
      DOUBLE PRECISION SUMM4(2400),SUMM5(2400),SUMM6(2400)
      DOUBLE PRECISION SUMM7(2400),SUMM8(2400),SUMM9(2400)
      DOUBLE PRECISION SUMM10(2400),SUMM11(2400),SUMM12(2400)
      DOUBLE PRECISION SUMM13(2400)
      DOUBLE PRECISION SUMDBZZ(2400)
      REAL XW(2400),YW(2400),ZW(2400)
      READ(LUW)IMAXTEST,JMAXTEST,KMAXTEST
      IF(IMAX.NE.IMAXTEST.OR.JMAX.NE.JMAXTEST.OR.KMAX.NE.KMAXTEST)THEN
       WRITE(6,*)'SUMFILE ERROR'
       WRITE(6,*)'IMAX,JMAX,KMAX = ',IMAX,JMAX,KMAX
       WRITE(6,*)'IMAXTEST,JMAXTEST,KMAXTEST ',
     +            IMAXTEST,JMAXTEST,KMAXTEST
       IF(KMAX.NE.KMAXTEST.AND.IMAX.EQ.IMAXTEST.AND.JMAX.EQ.JMAXTEST)
     + THEN
        WRITE(6,*)'SUMFILE ERROR'
        WRITE(6,*)'IMAX,JMAX,KMAX = ',IMAX,JMAX,KMAX
        WRITE(6,*)'IMAXTEST,JMAXTEST,KMAXTEST ',
     +            IMAXTEST,JMAXTEST,KMAXTEST
        ICONTINUE=1
        IF(ICONTINUE.EQ.0)STOP
       ELSE
        STOP
       ENDIF
      ENDIF
      DO K=1,KMAX2
       DO J=1,JMAX
c        write(6,*)'j,k,imax,jmax,kmax2 = ',j,k,imax,jmax,kmax2
        READ(LUW)(SUMM1(I),SUMM2(I),SUMM3(I),
     +   SUMM4(I),SUMM5(I),SUMM6(I),SUMM7(I),SUMM8(I),SUMM9(I),
     +   SUMM10(I),SUMM11(I),SUMM12(I),SUMM13(I),
     +              SUMDBZZ(I),XW(I),YW(I),ZW(I),I=1,IMAX)
        DO I=1,IMAX
         SUM1(I,J,K)=SUMM1(I)
         SUM2(I,J,K)=SUMM2(I)
         SUM3(I,J,K)=SUMM3(I)
         SUM4(I,J,K)=SUMM4(I)
         SUM5(I,J,K)=SUMM5(I)
         SUM6(I,J,K)=SUMM6(I)
         SUM7(I,J,K)=SUMM7(I)
         SUM8(I,J,K)=SUMM8(I)
         SUM9(I,J,K)=SUMM9(I)
         SUM10(I,J,K)=SUMM10(I)
         SUM11(I,J,K)=SUMM11(I)
         SUM12(I,J,K)=SUMM12(I)
         SUM13(I,J,K)=SUMM13(I)
         SUMDBZ(I,J,K)=SUMDBZZ(I)
         XWEIGHT(I,J,K)=XW(I)
         YWEIGHT(I,J,K)=YW(I)
         ZWEIGHT(I,J,K)=ZW(I)
        ENDDO
       ENDDO
      ENDDO
      CLOSE(LUW)
      RETURN
      END
      SUBROUTINE WRPLNRT(LU,IMAX,JMAX,KMAX,U,V,W,DIV,SUMDBZ,
     + SUMWTSAVE,IUV,ZZ,SZ)
      INTEGER*2 ID(5,2400)
      REAL RD(5,2400)
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX),W(IMAX,JMAX,KMAX)
      REAL DIV(IMAX,JMAX,KMAX),SUMDBZ(IMAX,JMAX,KMAX)
      REAL SUMWTSAVE(IMAX,JMAX,KMAX)
      FLAG=-1.0E+10
c      WRITE(6,*)'ENTERED WRPLN'
c      OPEN(102,FILE='/hrd/dat/gustav/tracking/wrpln')
c      WRITE(102,*)'Entering WRPLN'
      ITOTALTEST=21*IMAX*JMAX+48*IMAX
      DO K=1,KMAX
       H=ZZ+(K-1)*SZ
       RHO=EXP(-H*.10437052)
c       RHO=EXP(-H*.11)
c       WRITE(6,*)'k,zz,sz,h,rho = ',k,zz,sz,h,rho
c       WRITE(6,*)'Writing plane ',K
       DO J=1,JMAX
C        WRITE(6,*)'K = ',K,'J = ',J
        DO I=1,IMAX
C         ITOTALIJK=I+(J-1)*IMAX+(K-1)*IMAX*JMAX
C          IF(K.GE.22)THEN 
C         IF(ITOTALIJK.GT.ITOTALTEST.AND.NNIT.GT.1)THEN
C          WRITE(6,*)'I,J,K,U,V,W,DIV,SUMDBZ,SUMWTSAVE = ',
C     +     I,J,K,U(I,J,K),V(I,J,K),W(I,J,K),DIV(I,J,K),
C     +     SUMDBZ(I,J,K),SUMWTSAVE(I,J,K)
C         ENDIF
         IF(U(I,J,K).GT.FLAG.AND.V(I,J,K).GT.FLAG.AND.
     +     (U(I,J,K).NE.0..OR.V(I,J,K).NE.0.))THEN
          IF(IUV.EQ.0)THEN
           UU=U(I,J,K)/RHO
           VV=V(I,J,K)/RHO
           VV=VV+45.
           ID(1,I)=UU*10.
           ID(2,I)=VV*10.
          ELSE
           RD(1,I)=U(I,J,K)/RHO
           RD(2,I)=V(I,J,K)/RHO
          ENDIF
         ELSE
          ID(1,I)=-32000
          ID(2,I)=-32000
          RD(1,I)=FLAG
          RD(2,I)=FLAG
         ENDIF
         IF(IUV.EQ.1)THEN
          IF(W(I,J,K).GT.FLAG)THEN
           RD(3,I)=W(I,J,K)/RHO
          ELSE
           RD(3,I)=FLAG
          ENDIF
         ELSE
          IF(W(I,J,K).GT.FLAG)THEN
           ID(3,I)=W(I,J,K)*100./RHO
          ELSE
           ID(3,I)=-32000
          ENDIF
         ENDIF
         IF(IUV.EQ.1)THEN
          IF(DIV(I,J,K).GT.FLAG)THEN
           RD(5,I)=DIV(I,J,K)
          ELSE
           RD(5,I)=FLAG
          ENDIF
         ELSE
          IF(ABS(DIV(I,J,K)).LT..32766)THEN
           ID(5,I)=DIV(I,J,K)*1.0E+05
          ELSE
           ID(5,I)=32767
          ENDIF
         ENDIF
         IF(SUMDBZ(I,J,K).LT.-100.)THEN
c          IF(IUV.EQ.1)THEN
c           RD(4,I)=FLAG
c          ELSE
           ID(4,I)=-32000
c          ENDIF
         ELSE
           DBZ=SUMDBZ(I,J,K)
c           WRITE(6,*)'DBZ,Z,SUMDBZ,SUMWTSAVE,I,J,K = ',
c     +     DBZ,Z,SUMDBZ(I,J,K),SUMWTSAVE(I,J,K)
c          IF(IUV.EQ.1)THEN
c           RD(4,I)=DBZ
c          ELSE
           ID(4,I)=NINT(DBZ*10.)
c          ENDIF
         ENDIF
        ENDDO
        IF(IUV.NE.1)THEN
         WRITE(LU)((ID(N,I),N=1,5),I=1,IMAX)
        ELSE
         WRITE(LU)((RD(N,I),N=1,3),ID(4,I),RD(5,I),I=1,IMAX)
        ENDIF
       ENDDO
      ENDDO
c      WRITE(102,*)'LEAVING WRPLN'
c      CLOSE(102)
      RETURN
      END
      SUBROUTINE WRPLN(LU,IMAX,JMAX,KMAX,U,V,W,DIV,SUMDBZ,
     + SUMWTSAVE,IUV,ZZ,SZ)
      INTEGER*2 ID(5,2400)
      REAL RD(5,2400)
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX),W(IMAX,JMAX,KMAX)
      REAL DIV(IMAX,JMAX,KMAX),SUMDBZ(IMAX,JMAX,KMAX)
      REAL SUMWTSAVE(IMAX,JMAX,KMAX)
      FLAG=-1.0E+10
c      WRITE(6,*)'ENTERED WRPLN'
c      OPEN(102,FILE='/hrd/dat/gustav/tracking/wrpln')
c      WRITE(102,*)'Entering WRPLN'
      ITOTALTEST=21*IMAX*JMAX+48*IMAX
      DO K=1,KMAX
       H=ZZ+(K-1)*SZ
       RHO=EXP(-H*.10437052)
c       RHO=EXP(-H*.11)
c       WRITE(6,*)'k,zz,sz,h,rho = ',k,zz,sz,h,rho
c       WRITE(6,*)'Writing plane ',K
       DO J=1,JMAX
C        WRITE(6,*)'K = ',K,'J = ',J
        DO I=1,IMAX
C         ITOTALIJK=I+(J-1)*IMAX+(K-1)*IMAX*JMAX
C          IF(K.GE.22)THEN 
C         IF(ITOTALIJK.GT.ITOTALTEST.AND.NNIT.GT.1)THEN
C          WRITE(6,*)'I,J,K,U,V,W,DIV,SUMDBZ,SUMWTSAVE = ',
C     +     I,J,K,U(I,J,K),V(I,J,K),W(I,J,K),DIV(I,J,K),
C     +     SUMDBZ(I,J,K),SUMWTSAVE(I,J,K)
C         ENDIF
         IF(U(I,J,K).GT.FLAG.AND.V(I,J,K).GT.FLAG.AND.
     +     (U(I,J,K).NE.0..OR.V(I,J,K).NE.0.))THEN
          IF(IUV.EQ.0)THEN
           UU=U(I,J,K)/RHO
           VV=V(I,J,K)/RHO
           WDR=AMOD(630.0-57.29578*ATAN2(VV,UU),360.0)
           WSP=SQRT(UU*UU+VV*VV)
           ID(1,I)=WDR*10.
           ID(2,I)=WSP*10.
          ELSE
           RD(1,I)=U(I,J,K)/RHO
           RD(2,I)=V(I,J,K)/RHO
          ENDIF
         ELSE
          ID(1,I)=-32000
          ID(2,I)=-32000
          RD(1,I)=FLAG
          RD(2,I)=FLAG
         ENDIF
         IF(IUV.EQ.1)THEN
          IF(W(I,J,K).GT.FLAG)THEN
           RD(3,I)=W(I,J,K)/RHO
          ELSE
           RD(3,I)=FLAG
          ENDIF
         ELSE
          IF(W(I,J,K).GT.FLAG)THEN
           ID(3,I)=W(I,J,K)*100./RHO
          ELSE
           ID(3,I)=-32000
          ENDIF
         ENDIF
         IF(IUV.EQ.1)THEN
          IF(DIV(I,J,K).GT.FLAG)THEN
           RD(5,I)=DIV(I,J,K)
          ELSE
           RD(5,I)=FLAG
          ENDIF
         ELSE
          IF(ABS(DIV(I,J,K)).LT..32766)THEN
           ID(5,I)=DIV(I,J,K)*1.0E+05
          ELSE
           ID(5,I)=32767
          ENDIF
         ENDIF
         IF(SUMDBZ(I,J,K).LT.-100.)THEN
c          IF(IUV.EQ.1)THEN
c           RD(4,I)=FLAG
c          ELSE
           ID(4,I)=-32000
c          ENDIF
         ELSE
           DBZ=SUMDBZ(I,J,K)
c           WRITE(6,*)'DBZ,Z,SUMDBZ,SUMWTSAVE,I,J,K = ',
c     +     DBZ,Z,SUMDBZ(I,J,K),SUMWTSAVE(I,J,K)
c          IF(IUV.EQ.1)THEN
c           RD(4,I)=DBZ
c          ELSE
           ID(4,I)=NINT(DBZ*10.)
c           write(6,*)'i,j,k,sumdbz,id = ',i,j,k,sumdbz(i,j,k),id(4,i)
c          ENDIF
         ENDIF
        ENDDO
        IF(IUV.NE.1)THEN
         WRITE(LU)((ID(N,I),N=1,5),I=1,IMAX)
        ELSE
         WRITE(LU)((RD(N,I),N=1,3),ID(4,I),RD(5,I),I=1,IMAX)
        ENDIF
       ENDDO
      ENDDO
c      WRITE(102,*)'LEAVING WRPLN'
c      CLOSE(102)
      RETURN
      END
      SUBROUTINE READHEADER(LU,FILNAM,KEYWORD,FLTNAME,
     + STMNAME,RADAR,EXPERIMENT,
     + CREATIME,EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     + SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     + POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM*80
      INTEGER IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      OPEN(LU,FILE=FILNAM,STATUS='OLD',FORM='UNFORMATTED')
      READ(LU)KEYWORD,FLTNAME,STMNAME,
     + RADAR,EXPERIMENT,CREATIME,
     + EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,
     + EXTRA3,STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      RETURN
      END
      SUBROUTINE WRITEHEADER(LU,FILNAM,KEYWORD,FLTNAME,
     + STMNAME,RADAR,EXPERIMENT,
     + CREATIME,EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     + SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     + POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM*80
      INTEGER IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
c      OPEN(102,FILE='/hrd/dat/gustav/tracking/writeheader')
c      WRITE(102,*)'Entering WRITEHEADER = '
      write(6,*)'WRITEHEADER ENTERED'
      OPEN(LU,FILE=FILNAM,FORM='UNFORMATTED')
      write(6,*)'OPENED LU ',LU,' AS '
      write(6,'(A)')FILNAM
      WRITE(LU)KEYWORD,FLTNAME,STMNAME,RADAR,EXPERIMENT,CREATIME,
     + EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,IUNFLD,IATTEN,FLAG,EXTRA2,
     + EXTRA3,STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
c      WRITE(102,*)'Leaving WRITEHEADER'
c      CLOSE(102)
      RETURN
      END
      SUBROUTINE WRITEABCD(LUW,IMAX,JMAX,KMAX,SUM1,SUM2,SUM3,
     +   SUM4,SUM5,SUM6,SUM7,SUM8,SUM9,SUM10,SUM11,SUM12,SUM13,SUMDBZ,
     +   XWEIGHT,YWEIGHT,ZWEIGHT)
      REAL SUM1(IMAX,JMAX,KMAX),SUM2(IMAX,JMAX,KMAX)
      REAL SUM3(IMAX,JMAX,KMAX),SUM4(IMAX,JMAX,KMAX)
      REAL SUM5(IMAX,JMAX,KMAX),SUM6(IMAX,JMAX,KMAX)
      REAL SUM7(IMAX,JMAX,KMAX),SUM8(IMAX,JMAX,KMAX)
      REAL SUM9(IMAX,JMAX,KMAX),XWEIGHT(IMAX,JMAX,KMAX)
      REAL YWEIGHT(IMAX,JMAX,KMAX),ZWEIGHT(IMAX,JMAX,KMAX)
      REAL SUM10(IMAX,JMAX,KMAX),SUM11(IMAX,JMAX,KMAX)
      REAL SUM12(IMAX,JMAX,KMAX),SUM13(IMAX,JMAX,KMAX)
      REAL SUMDBZ(IMAX,JMAX,KMAX)
      WRITE (LUW)IMAX,JMAX,KMAX
      DO K=1,KMAX
       DO J=1,JMAX
        WRITE(LUW)(SUM1(I,J,K),SUM2(I,J,K),SUM3(I,J,K),
     +             SUM4(I,J,K),SUM5(I,J,K),SUM6(I,J,K),
     +             SUM7(I,J,K),SUM8(I,J,K),SUM9(I,J,K),
     +            SUM10(I,J,K),SUM11(I,J,K),SUM12(I,J,K),SUM13(I,J,K),
     +              SUMDBZ(I,J,K),XWEIGHT(I,J,K),YWEIGHT(I,J,K),
     +              ZWEIGHT(I,J,K),I=1,IMAX)
       ENDDO
      ENDDO
      write(6,*)'about to close sumfile'
      CLOSE(LUW)
      write(6,*)'closing sumfile and returning'
      RETURN
      END
      SUBROUTINE READABCD(LUW,IMAX,JMAX,KMAX,SUM1,SUM2,SUM3,SUM4,SUM5,
     +   SUM6,SUM7,SUM8,SUM9,SUM10,SUM11,SUM12,SUM13,
     +   SUMDBZ,KMAX2,XWEIGHT,YWEIGHT,ZWEIGHT)
      REAL SUM1(IMAX,JMAX,KMAX),SUM2(IMAX,JMAX,KMAX)
      REAL SUM3(IMAX,JMAX,KMAX),SUM4(IMAX,JMAX,KMAX)
      REAL SUM5(IMAX,JMAX,KMAX),SUM6(IMAX,JMAX,KMAX)
      REAL SUM7(IMAX,JMAX,KMAX),SUM8(IMAX,JMAX,KMAX)
      REAL SUM9(IMAX,JMAX,KMAX),XWEIGHT(IMAX,JMAX,KMAX)
      REAL YWEIGHT(IMAX,JMAX,KMAX),ZWEIGHT(IMAX,JMAX,KMAX)
      REAL SUMDBZ(IMAX,JMAX,KMAX)
      REAL SUM10(IMAX,JMAX,KMAX),SUM11(IMAX,JMAX,KMAX)
      REAL SUM12(IMAX,JMAX,KMAX),SUM13(IMAX,JMAX,KMAX)
      REAL SUMM1(2400),SUMM2(2400),SUMM3(2400)
      REAL SUMM4(2400),SUMM5(2400),SUMM6(2400)
      REAL SUMM7(2400),SUMM8(2400),SUMM9(2400)
      REAL SUMM10(2400),SUMM11(2400),SUMM12(2400),SUMM13(2400)
      REAL SUMDBZZ(2400),XW(2400),YW(2400),ZW(2400)
      READ(LUW)IMAXTEST,JMAXTEST,KMAXTEST
      IF(IMAX.NE.IMAXTEST.OR.JMAX.NE.JMAXTEST.OR.KMAX.NE.KMAXTEST)THEN
       WRITE(6,*)'SUMFILE ERROR'
       WRITE(6,*)'IMAX,JMAX,KMAX = ',IMAX,JMAX,KMAX
       WRITE(6,*)'IMAXTEST,JMAXTEST,KMAXTEST ',
     +            IMAXTEST,JMAXTEST,KMAXTEST
       IF(KMAX.NE.KMAXTEST.AND.IMAX.EQ.IMAXTEST.AND.JMAX.EQ.JMAXTEST)
     + THEN
        WRITE(6,*)'SUMFILE ERROR'
        WRITE(6,*)'IMAX,JMAX,KMAX = ',IMAX,JMAX,KMAX
        WRITE(6,*)'IMAXTEST,JMAXTEST,KMAXTEST ',
     +            IMAXTEST,JMAXTEST,KMAXTEST
c        WRITE(6,*)'CONTINUE PROGRAM Y(1)/N(0)?'
c        READ(1,*)ICONTINUE
        ICONTINUE=1
        IF(ICONTINUE.EQ.0)STOP
       ELSE
        STOP
       ENDIF
      ENDIF
      DO K=1,KMAX2
       DO J=1,JMAX
c        write(6,*)'j,k,imax,jmax,kmax2 = ',j,k,imax,jmax,kmax2
        READ(LUW)(SUMM1(I),SUMM2(I),SUMM3(I),
     +   SUMM4(I),SUMM5(I),SUMM6(I),SUMM7(I),SUMM8(I),SUMM9(I),
     +   SUMM10(I),SUMM11(I),SUMM12(I),SUMM13(I),
     +              SUMDBZZ(I),XW(I),YW(I),ZW(I),I=1,IMAX)
        DO I=1,IMAX
         SUM1(I,J,K)=SUMM1(I)
         SUM2(I,J,K)=SUMM2(I)
         SUM3(I,J,K)=SUMM3(I)
         SUM4(I,J,K)=SUMM4(I)
         SUM5(I,J,K)=SUMM5(I)
         SUM6(I,J,K)=SUMM6(I)
         SUM7(I,J,K)=SUMM7(I)
         SUM8(I,J,K)=SUMM8(I)
         SUM9(I,J,K)=SUMM9(I)
         SUM10(I,J,K)=SUMM10(I)
         SUM11(I,J,K)=SUMM11(I)
         SUM12(I,J,K)=SUMM12(I)
         SUM13(I,J,K)=SUMM13(I)
         SUMDBZ(I,J,K)=SUMDBZZ(I)
         XWEIGHT(I,J,K)=XW(I)
         YWEIGHT(I,J,K)=YW(I)
         ZWEIGHT(I,J,K)=ZW(I)
c         write(6,*)'i,j,k,sum1,sum2,sum3,sumdbz = '
c       write(6,*)i,j,k,sum1(i,j,k),sum2(i,j,k),sum3(i,j,k),sumdbz(i,j,k)
c       write(6,*)'sum4,sum5,sum6,sum7,sum8,sum9 = '
c        write(6,*)sum4(i,j,k),sum5(i,j,k),sum6(i,j,k),sum7(i,j,k),
c     +            sum8(i,j,k),sum9(i,j,k)
c        write(6,*)'xw,yw,zw = ',xweight(i,j,k),yweight(i,j,k),
c     + zweight(i,j,k)
        ENDDO
       ENDDO
      ENDDO
      CLOSE(LUW)
      RETURN
      END
      SUBROUTINE WRITEABCD24(LUW,IMAX,JMAX,KMAX,SUM1,SUM2,SUM3,
     +   SUM4,SUM5,SUM6,SUM7,SUM8,SUM9,SUM10,SUM11,SUM12,SUM13,
     + SUM14,SUM15,SUM16,SUM17,SUM18,SUM19,SUM20,SUM21,SUM22,
     + SUM23,SUM24,SUMDBZ,
     +   XWEIGHT,YWEIGHT,ZWEIGHT,NFF)
      REAL SUM1(IMAX,JMAX,KMAX,NFF),SUM2(IMAX,JMAX,KMAX,NFF)
      REAL SUM3(IMAX,JMAX,KMAX,NFF),SUM4(IMAX,JMAX,KMAX,NFF)
      REAL SUM5(IMAX,JMAX,KMAX,NFF),SUM6(IMAX,JMAX,KMAX,NFF)
      REAL SUM7(IMAX,JMAX,KMAX,NFF),SUM8(IMAX,JMAX,KMAX,NFF)
      REAL SUM9(IMAX,JMAX,KMAX,NFF),XWEIGHT(IMAX,JMAX,KMAX,NFF)
      REAL YWEIGHT(IMAX,JMAX,KMAX,NFF),ZWEIGHT(IMAX,JMAX,KMAX,NFF)
      REAL SUM10(IMAX,JMAX,KMAX,NFF),SUM11(IMAX,JMAX,KMAX,NFF)
      REAL SUM12(IMAX,JMAX,KMAX,NFF),SUM13(IMAX,JMAX,KMAX,NFF)
      REAL SUM14(IMAX,JMAX,KMAX,NFF),SUM15(IMAX,JMAX,KMAX,NFF)
      REAL SUM16(IMAX,JMAX,KMAX,NFF),SUM17(IMAX,JMAX,KMAX,NFF)
      REAL SUM18(IMAX,JMAX,KMAX,NFF),SUM19(IMAX,JMAX,KMAX,NFF)
      REAL SUM20(IMAX,JMAX,KMAX,NFF),SUM21(IMAX,JMAX,KMAX,NFF)
      REAL SUM22(IMAX,JMAX,KMAX,NFF),SUM23(IMAX,JMAX,KMAX,NFF)
      REAL SUM24(IMAX,JMAX,KMAX,NFF)
      REAL SUMDBZ(IMAX,JMAX,KMAX,NFF)
      WRITE (LUW)IMAX,JMAX,KMAX
      DO K=1,KMAX
       DO J=1,JMAX
        WRITE(LUW)(SUM1(I,J,K,NFF),SUM2(I,J,K,NFF),SUM3(I,J,K,NFF),
     +             SUM4(I,J,K,NFF),SUM5(I,J,K,NFF),SUM6(I,J,K,NFF),
     +             SUM7(I,J,K,NFF),SUM8(I,J,K,NFF),SUM9(I,J,K,NFF),
     +            SUM10(I,J,K,NFF),SUM11(I,J,K,NFF),
     +            SUM12(I,J,K,NFF),SUM13(I,J,K,NFF),
     +            SUM14(I,J,K,NFF),SUM15(I,J,K,NFF),
     +            SUM16(I,J,K,NFF),SUM17(I,J,K,NFF),
     +            SUM18(I,J,K,NFF),SUM19(I,J,K,NFF),
     +            SUM20(I,J,K,NFF),SUM21(I,J,K,NFF),
     +            SUM22(I,J,K,NFF),SUM23(I,J,K,NFF),
     +            SUM24(I,J,K,NFF),
     +              SUMDBZ(I,J,K,NFF),XWEIGHT(I,J,K,NFF),
     +              YWEIGHT(I,J,K,NFF),
     +              ZWEIGHT(I,J,K,NFF),I=1,IMAX)
       ENDDO
      ENDDO
      write(6,*)'about to close sumfile'
      CLOSE(LUW)
      write(6,*)'closing sumfile and returning'
      RETURN
      END
      SUBROUTINE READABCD24(LUW,IMAX,JMAX,KMAX,SUM1,SUM2,SUM3,SUM4,SUM5,
     +   SUM6,SUM7,SUM8,SUM9,SUM10,SUM11,SUM12,SUM13,SUM14,SUM15,SUM16,
     +   SUM17,SUM18,SUM19,SUM20,SUM21,SUM22,SUM23,SUM24,
     +   SUMDBZ,KMAX2,XWEIGHT,YWEIGHT,ZWEIGHT)
      REAL SUM1(IMAX,JMAX,KMAX),SUM2(IMAX,JMAX,KMAX)
      REAL SUM3(IMAX,JMAX,KMAX),SUM4(IMAX,JMAX,KMAX)
      REAL SUM5(IMAX,JMAX,KMAX),SUM6(IMAX,JMAX,KMAX)
      REAL SUM7(IMAX,JMAX,KMAX),SUM8(IMAX,JMAX,KMAX)
      REAL SUM9(IMAX,JMAX,KMAX),XWEIGHT(IMAX,JMAX,KMAX)
      REAL SUM10(IMAX,JMAX,KMAX)
      REAL SUM11(IMAX,JMAX,KMAX),SUM12(IMAX,JMAX,KMAX)
      REAL SUM13(IMAX,JMAX,KMAX),SUM14(IMAX,JMAX,KMAX)
      REAL SUM15(IMAX,JMAX,KMAX),SUM16(IMAX,JMAX,KMAX)
      REAL SUM17(IMAX,JMAX,KMAX),SUM18(IMAX,JMAX,KMAX)
      REAL SUM19(IMAX,JMAX,KMAX),SUM20(IMAX,JMAX,KMAX)
      REAL SUM21(IMAX,JMAX,KMAX),SUM22(IMAX,JMAX,KMAX)
      REAL SUM23(IMAX,JMAX,KMAX),SUM24(IMAX,JMAX,KMAX)
      REAL YWEIGHT(IMAX,JMAX,KMAX),ZWEIGHT(IMAX,JMAX,KMAX)
      REAL SUMDBZ(IMAX,JMAX,KMAX)
      REAL SUMM1(2400),SUMM2(2400),SUMM3(2400)
      REAL SUMM4(2400),SUMM5(2400),SUMM6(2400)
      REAL SUMM7(2400),SUMM8(2400),SUMM9(2400)
      REAL SUMM10(2400),SUMM11(2400),SUMM12(2400),SUMM13(2400)
      REAL SUMM14(2400),SUMM15(2400),SUMM16(2400),SUMM17(2400)
      REAL SUMM18(2400),SUMM19(2400),SUMM20(2400),SUMM21(2400)
      REAL SUMM22(2400),SUMM23(2400),SUMM24(2400)
      REAL SUMDBZZ(2400),XW(2400),YW(2400),ZW(2400)
      READ(LUW)IMAXTEST,JMAXTEST,KMAXTEST
      IF(IMAX.NE.IMAXTEST.OR.JMAX.NE.JMAXTEST.OR.KMAX.NE.KMAXTEST)THEN
       WRITE(6,*)'SUMFILE ERROR'
       WRITE(6,*)'IMAX,JMAX,KMAX = ',IMAX,JMAX,KMAX
       WRITE(6,*)'IMAXTEST,JMAXTEST,KMAXTEST ',
     +            IMAXTEST,JMAXTEST,KMAXTEST
       IF(KMAX.NE.KMAXTEST.AND.IMAX.EQ.IMAXTEST.AND.JMAX.EQ.JMAXTEST)
     + THEN
        WRITE(6,*)'SUMFILE ERROR'
        WRITE(6,*)'IMAX,JMAX,KMAX = ',IMAX,JMAX,KMAX
        WRITE(6,*)'IMAXTEST,JMAXTEST,KMAXTEST ',
     +            IMAXTEST,JMAXTEST,KMAXTEST
c        WRITE(6,*)'CONTINUE PROGRAM Y(1)/N(0)?'
c        READ(1,*)ICONTINUE
        ICONTINUE=1
        IF(ICONTINUE.EQ.0)STOP
       ELSE
        STOP
       ENDIF
      ENDIF
      DO K=1,KMAX2
       DO J=1,JMAX
c        write(6,*)'j,k,imax,jmax,kmax2 = ',j,k,imax,jmax,kmax2
        READ(LUW)(SUMM1(I),SUMM2(I),SUMM3(I),
     +   SUMM4(I),SUMM5(I),SUMM6(I),SUMM7(I),SUMM8(I),SUMM9(I),
     +   SUMM10(I),SUMM11(I),SUMM12(I),SUMM13(I),
     +   SUMM14(I),SUMM15(I),SUMM16(I),SUMM17(I),SUMM18(I),SUMM19(I),
     +   SUMM20(I),SUMM21(I),SUMM22(I),SUMM23(I),SUMM24(I),
     +              SUMDBZZ(I),XW(I),YW(I),ZW(I),I=1,IMAX)
        DO I=1,IMAX
         SUM1(I,J,K)=SUMM1(I)
         SUM2(I,J,K)=SUMM2(I)
         SUM3(I,J,K)=SUMM3(I)
         SUM4(I,J,K)=SUMM4(I)
         SUM5(I,J,K)=SUMM5(I)
         SUM6(I,J,K)=SUMM6(I)
         SUM7(I,J,K)=SUMM7(I)
         SUM8(I,J,K)=SUMM8(I)
         SUM9(I,J,K)=SUMM9(I)
         SUM10(I,J,K)=SUMM10(I)
         SUM11(I,J,K)=SUMM11(I)
         SUM12(I,J,K)=SUMM12(I)
         SUM13(I,J,K)=SUMM13(I)
         SUM14(I,J,K)=SUMM14(I)
         SUM15(I,J,K)=SUMM15(I)
         SUM16(I,J,K)=SUMM16(I)
         SUM17(I,J,K)=SUMM17(I)
         SUM18(I,J,K)=SUMM18(I)
         SUM19(I,J,K)=SUMM19(I)
         SUM20(I,J,K)=SUMM20(I)
         SUM21(I,J,K)=SUMM21(I)
         SUM22(I,J,K)=SUMM22(I)
         SUM23(I,J,K)=SUMM23(I)
         SUM24(I,J,K)=SUMM24(I)
         SUMDBZ(I,J,K)=SUMDBZZ(I)
         XWEIGHT(I,J,K)=XW(I)
         YWEIGHT(I,J,K)=YW(I)
         ZWEIGHT(I,J,K)=ZW(I)
c         write(6,*)'i,j,k,sum1,sum2,sum3,sumdbz = '
c       write(6,*)i,j,k,sum1(i,j,k),sum2(i,j,k),sum3(i,j,k),sumdbz(i,j,k)
c       write(6,*)'sum4,sum5,sum6,sum7,sum8,sum9 = '
c        write(6,*)sum4(i,j,k),sum5(i,j,k),sum6(i,j,k),sum7(i,j,k),
c     +            sum8(i,j,k),sum9(i,j,k)
c        write(6,*)'xw,yw,zw = ',xweight(i,j,k),yweight(i,j,k),
c     + zweight(i,j,k)
        ENDDO
       ENDDO
      ENDDO
      CLOSE(LUW)
      RETURN
      END
      SUBROUTINE LDPLNWD(LU,U,V,W,DBZ,IMAX,JMAX,KMAX,IUV,ZZ,SZ)
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX),W(IMAX,JMAX,KMAX)
      REAL DBZ(IMAX,JMAX,KMAX)
      INTEGER*2 IU(2400),IV(2400),IW(2400),IDB(2400),IDV(2400)
      REAL RU(2400),RV(2400),RW(2400),RDV(2400)
      FLAG=-1.0E+10
      WRITE(6,*)'INSIDE LDPLNW'
      write(6,*)'lu = ',lu
      WRITE(6,*)'IMAX,JMAX,KMAX,IUV = ',IMAX,JMAX,KMAX,IUV
      DO K=1,KMAX
       write(6,*)'level ',k
       H=ZZ+(K-1)*SZ
       RHO=EXP(-H*.10437052)
c       RHO=EXP(-H*.11)
       DO J=1,JMAX
c        write(6,*)'j = ',j
        IF(IUV.EQ.0)THEN
         READ(LU)(IU(I),IV(I),IW(I),IDB(I),IDV(I),I=1,IMAX)
        ELSE
         READ(LU)(RU(I),RV(I),RW(I),IDB(I),RDV(I),I=1,IMAX)
        ENDIF
        DO I=1,IMAX
         IF(IDB(I).GT.-9000)THEN
          DBZ(I,J,K)=IDB(I)*.1
         ELSE
          DBZ(I,J,K)=FLAG
         ENDIF
         IF(IUV.EQ.0)THEN
          IF(IU(I).LT.-31999)THEN
           U(I,J,K)=FLAG
           V(I,J,K)=FLAG
          ELSE
           WDR=IU(I)*.1
           WSP=IV(I)*.1
c           CALL COMP(XU,XV,WDR,WSP)
           XU=-SIN(WDR*3.14159/180.)*WSP
           XV=-COS(WDR*3.14159/180.)*WSP
           U(I,J,K)=XU*RHO
           V(I,J,K)=XV*RHO
          ENDIF
          IF(IW(I).GT.-31999)THEN
           W(I,J,K)=IW(I)*.01*RHO
          ELSE
           W(I,J,K)=FLAG
          ENDIF
         ELSE
          IF(RU(I).GT.FLAG.AND.RV(I).GT.FLAG.AND.RW(I).GT.FLAG)THEN
           U(I,J,K)=RU(I)*RHO
           V(I,J,K)=RV(I)*RHO
           W(I,J,K)=RW(I)*RHO
          ELSE
           U(I,J,K)=FLAG
           V(I,J,K)=FLAG
           W(I,J,K)=FLAG
          ENDIF
         ENDIF
        ENDDO
       ENDDO
      ENDDO
      RETURN
      END
      SUBROUTINE LDPLNW(LU,U,V,W,IMAX,JMAX,KMAX,IUV,ZZ,SZ)
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX),W(IMAX,JMAX,KMAX)
      INTEGER*2 IU(2400),IV(2400),IW(2400),IDB(2400),IDV(2400)
      REAL RU(2400),RV(2400),RW(2400),RDV(2400)
      FLAG=-1.0E+10
      WRITE(6,*)'INSIDE LDPLNW'
      WRITE(6,*)'IMAX,JMAX,KMAX,IUV = ',IMAX,JMAX,KMAX,IUV
      DO K=1,KMAX
       H=ZZ+(K-1)*SZ
       RHO=EXP(-H*.10437052)
c       RHO=EXP(-H*.11)
       DO J=1,JMAX
        IF(IUV.EQ.0)THEN
         READ(LU)(IU(I),IV(I),IW(I),IDB(I),IDV(I),I=1,IMAX)
        ELSE
         READ(LU)(RU(I),RV(I),RW(I),IDB(I),RDV(I),I=1,IMAX)
        ENDIF
        DO I=1,IMAX
         IF(IUV.EQ.0)THEN
          IF(IU(I).LT.-31999)THEN
           U(I,J,K)=FLAG
           V(I,J,K)=FLAG
          ELSE
           WDR=IU(I)*.1
           WSP=IV(I)*.1
c           CALL COMP(XU,XV,WDR,WSP)
           XU=-SIN(WDR*3.14159/180.)*WSP
           XV=-COS(WDR*3.14159/180.)*WSP
           U(I,J,K)=XU*RHO
           V(I,J,K)=XV*RHO
          ENDIF
          IF(IW(I).GT.-31999)THEN
           W(I,J,K)=IW(I)*.01*RHO
          ELSE
           W(I,J,K)=FLAG
          ENDIF
         ELSE
          IF(RU(I).GT.FLAG.AND.RV(I).GT.FLAG.AND.RW(I).GT.FLAG)THEN
           U(I,J,K)=RU(I)*RHO
           V(I,J,K)=RV(I)*RHO
           W(I,J,K)=RW(I)*RHO
          ELSE
           U(I,J,K)=FLAG
           V(I,J,K)=FLAG
           W(I,J,K)=FLAG
          ENDIF
         ENDIF
        ENDDO
       ENDDO
      ENDDO
      RETURN
      END


