/*   previous_ten_test.c version to test on old data
* previous_ten.c
* This program uses the Standard C Library time
* functions (see time.h) to obatain the current time in UTC and then figure out
* previous 10 minute period to generate a file name filter to
* get alist of radar file names in 10 minute chumnks and then dump the headers
* to a file that Paul Reasors INE correction code can work on.
* 14 May, 2018
*/
#include <time.h>
#include <stdlib.h>
#include <stdio.h>
# include <string.h>

int main(int argc, char **argv)
{
    time_t current_time;
	struct tm *gmt;
    char* c_time_string;
/* pathe something like
*	/home/sysop/yearmodaNn/
*/
	char path[22];
	char command_string[132];
	int len;
	int month,day,hour;
	int interval;
	int year_code;
	int test, test_year, test_month, test_day;
	char  test_date[8];
if(argc > 2) {
		test = 1;
	strcpy(test_date, argv[2]);
}
	else
		test =0;

	if(argc > 1)
		strcpy(path, argv[1]);
	else
		sprintf(path, "/home/sysop/yearmodaNn/");

    /* Obtain current time. */
    current_time = time(NULL);
	gmt = gmtime(&current_time);

    if (current_time == ((time_t)-1))
    {
        (void) fprintf(stderr, "Failure to obtain the current time.\n");
        exit(EXIT_FAILURE);
    }



printf("Day of year: %d\n", gmt->tm_yday);
	printf("UTC time: %.2d:%.2d:%.2d \n", gmt->tm_hour,gmt->tm_min,gmt->tm_sec);
/* now make up the radar file name string to search for:
*/
	year_code = gmt->tm_year -100;
/* that should work until 2099, by which time this code 
* will not be needed!
*/
	month = gmt->tm_mon + 1;
	day = gmt->tm_mday;
/* over ride date so I can test with older data on test machine:
*/
	if(test == 1) {
		sscanf(test_date,"%d",&test_year);
		year_code = test_year / 10000 ;
		month =( test_year - year_code*10000) / 100;
		day = test_year - year_code * 10000 - month *100;
	year_code = year_code - 2000;
	printf("extracted year %d month %d day %d \n",year_code, month, day);
}

	hour = gmt->tm_hour;
	interval = gmt->tm_min / 10;
	interval = interval -1;
	if(interval < 0) {
		interval = 5;
	hour = hour -1;
}
	if(hour <0) {
		hour = 23;
		day = day -1;
}
/* and if day is 0 then we have to get mmonth and day right!
*/
	len = sprintf(command_string, "ls %snrs%.2d%.2d%.2d%.2d%.1d*RAW* > swps_list \n",path,year_code,month,day,hour,interval);
	system(command_string);

    exit(EXIT_SUCCESS);
}

