	subroutine check_hrd_blocks(chk_flags)
C Check the nav, inertial, and derived quantities
C in the rapeheader and rayheader common blocks
C we don't test everything..just those values that could f*** up 
C Doppler analyses. Thsi subroutine was created 
C because of intermittent crappy extended header data in
C the GIV radar data. 9 Aug 2011 Peter Dodge
	integer*4 chk_flags
	include "hrd_radar_common_blocks.f"
C
	ws_max = 300.0 ! m/s
	vws_max = 100.0 ! m/s
	vws_min = -vws_max
	ra_max = 16000.0 ! m
	gs_max = 400.0 ! m/s
	gs_min = -gs_max
	vgs_max = 100.0
	vgs_min = -vgs_max
	pitch_max = 90.0
	pitch_min = -pitch_max
	roll_max = 90.0	
	roll_min = -roll_max
	drift_max = 90.0
	drift_min = -drift_max
C
	chk_flags = 0 ! means all is well
C
C bit 0: radar altitude
	if( (ra .lt. 0.0) .or.(ra .gt. ra_max) ) then
		chk_flags = 1
	end if
C bits 1-3: flight level wind
	if( (ws .lt. 0.0) .or. (ws .gt. ws_max) ) then
		chk_flags = chk_flags + 2
	end if
	if( (wd .lt. 0.0) .or. (wd .gt. 360.0) ) then
		chk_flags = chk_flags + 4
	end if
	if( (vws .lt. vws_min) .or. (vws .gt. vws_max) ) then
		chk_flags = chk_flags + 8
	end if
C bits 4-6: aircraft ground spwwd
	if( (gs .le. 0.0) .or. (gs .gt. gs_max) ) then
		chk_flags = chk_flags + 16
	end if
	if( (gse .lt. gs_min) .or. (gse .gt. gs_max) .or.
     +	 (gsn .lt. gs_min) .or. (gsn .gt. gs_max) ) then
		chk_flags = chk_flags + 32
	end if
	if( (vgs .lt. vgs_min) .or. (vgs .gt. vgs_max) ) then
		chk_flags = chk_flags + 64
	end if

C bits 7-9: attitude angles
	if( (pitch .lt. pitch_min) .or. (pitch.gt.pitch_max)) then
		cdk_flags = chk_flags + 128
	end if
	if( (drift .lt. drift_min) .or. (drift.gt.drift_max)) then
		cdk_flags = chk_flags + 256
	end if
	if( (roll .lt. roll_min) .or. (roll.gt.roll_max)) then
		cdk_flags = chk_flags + 512
	end if
C cannot reaaly test for heading, az all values of
C the binary angle are valid. 

C bits 10-1q: lat and lon. Note that these are harder
C to test withoot knwting wxptected of previous values.
C no sure yet how I will implement this.
	return
	end
C ====================================
	subroutine print_hrd_blocks(lu, chk_flags)
C
	integer*4 lu, chk_flags
	include "hrd_radar_common_blocks.f"
C
	if(chk_flas .eq. 0) then
	   write(lu,*)'Good Header'
	else 
	   write(lu,*)'Bad Header. Flags: ',chk_flags
	end if
	write(lu,*)'RA: ',ra
	write(lu,*)'wd,ws,vws: ',wd,ws,vws
	write(lu,*)'gse, gsn, vgs: ',gse, gsn, vgs
	write(lu,*)'pitch,drift,roll,heading: ',pitch, drift,toll, heading
	write(lu,*)'rlat, rlon:', rlat,rlon
C
	return
	end


