/*	xplot_arrows.h
 * These functions use Xlib functions to plot arrows pointing with wind
 */

extern int xplot_arrow(
	Display *display,
	Drawable drawable,	
	GC gc,
	Position x, Position y,
	double shaft, double u, double v);
	
extern int xplot_barb_wd(
	Display *display,
	Drawable drawable,	
	GC gc,
	Position xc, Position yc,
	double dir, double spd, double shaft);

extern int xplot_barb_uv(
	Display *display,
	Drawable drawable,	
	GC gc,
	Position xc, Position yc,
	float shaft, float u, float v);
